<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: card_types.php,v 1.2.2.1 2003/03/12 06:43:21 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";


function func_local_update_card_types () {
	global $config, $sql_tbl;

	db_query ("UPDATE $sql_tbl[config] SET value='".addslashes(serialize($config["card_types"]))."' WHERE name='card_types'");
}

$test = func_query_first ("SELECT * FROM $sql_tbl[config] WHERE name='card_types'");
if (!$test) {
	db_query ("INSERT INTO $sql_tbl[config] (name, value) VALUES ('card_types', '')");
}

if ($mode == "add" && $code && !empty($new_name)) {
	$config["card_types"] [] = array ("code"=>stripslashes($code), "type"=>stripslashes($new_name));

	func_local_update_card_types ();

	header ("Location: card_types.php?added");
	exit;
}

if ($mode == "delete" and  $old_name) {
	$new_levels = array ();

	if ($config["card_types"]) {
		foreach ($config["card_types"] as $key=>$value) {
			if (!(($value["code"] == stripslashes($code)) and ($value["type"] == stripslashes($old_name)))) 
				$new_levels [] = $value;
		}
	}

	$config["card_types"] = $new_levels;

	func_local_update_card_types ();

	header ("Location: card_types.php?deleted");
	exit;
}

if ($mode == "rename" && $new_name && $old_name) {
	
	if ($config["card_types"]) {
		foreach ($config["card_types"] as $key=>$value) {
			if (($value["code"] == stripslashes($code)) && ($value["type"] == stripslashes($old_name))) {
				$config["card_types"][$key]["type"] = stripslashes($new_name);
			}
		}
	}

	func_local_update_card_types ();

	header ("Location: card_types.php?renamed");
	exit;
}

$smarty->assign("main","card_types");
@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>


