<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE Ruslan R. Fazliev TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE Ruslan R. Fazliev TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: editor_mode.php,v 1.4.2.1 2003/01/30 12:49:15 ndv Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";

if (empty($login) && $HTTP_SESSION_VARS["editor_mode"]!='editor') {
    header("Location: error_message.php?access_denied");
    exit;
}
		
if ($HTTP_POST_VARS["editor_mode"] || $HTTP_GET_VARS["editor_mode"] || $HTTP_COOKIE_VARS["editor_mode"]) {
    header("Location: ../admin/error_message.php?access_denied");
    exit();
}
session_register("editor_mode");
if ($REQUEST_METHOD == "POST") {

	if ($mode == "start_mode") 
		$editor_mode = "editor";
	elseif ($mode == "quit_mode")
		$editor_mode = "";

	header("Location: editor_mode.php");
	exit();

}

$smarty->assign("editor_mode_enabled", ($editor_mode?"editor_mode":""));
$smarty->assign("site_edit", "http://".$xcart_http_host.$xcart_web_dir);
$smarty->assign("main", "editor_mode");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
