<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: giftcerts.php,v 1.10.2.1 2003/01/17 09:18:24 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";
 
if ($REQUEST_METHOD=="POST")
{

	if ($mode == "add_gc" || $mode == "modify_gc") {

		$fill_error = (empty($purchaser) || empty($recipient));
		$amount_error = (($config["General"]["min_gc_amount"] && $amount<$config["General"]["min_gc_amount"]) || ($config["General"]["max_gc_amount"] && $amount>$config["General"]["max_gc_amount"]));

#
# Add GC to cart
#
		if ($send_via == "E") {
#
# Send via Email
#
			$fill_error = ($fill_error || empty($recipient_email));

				$giftcert = array ("purchaser" => stripslashes($purchaser),
                           "recipient" => stripslashes($recipient),
                           "message" => stripslashes($message),
                           "amount" => $amount,
                           "send_via" => $send_via,
                           "recipient_email" => $recipient_email);
		}
		else {
#
# Send via Postal Mail
#
			$fill_error = ($fill_error || empty($recipient_firstname) || empty($recipient_lastname) || empty($recipient_address) || empty($recipient_city) || empty($recipient_zipcode) || empty($recipient_state) || empty($recipient_country));

			$giftcert = array ("purchaser" => stripslashes($purchaser),
                           "recipient" => stripslashes($recipient),
                           "message" => stripslashes($message),
                           "amount" => $amount,
                           "send_via" => $send_via,
                           "recipient_firstname" => stripslashes($recipient_firstname),
                           "recipient_lastname" => stripslashes($recipient_lastname),
                           "recipient_address" => stripslashes($recipient_address),
                           "recipient_city" => stripslashes($recipient_city),
                           "recipient_zipcode" => $recipient_zipcode,
                           "recipient_state" => $recipient_state,
                           "recipient_country" => $recipient_country,
                           "recipient_phone" => $recipient_phone);
		}
#
# If gcindex is empty - add
# overwise - update
#
		if (!$fill_error && !$amount_error) {

			if ($mode == "add_gc") {
			
				$gcid = strtoupper(md5(uniqid(rand())));

				db_query("insert into $sql_tbl[giftcerts] (gcid, orderid, purchaser, recipient, send_via, recipient_email, recipient_firstname, recipient_lastname, recipient_address, recipient_city, recipient_state, recipient_country, recipient_zipcode, recipient_phone, message, amount, debit, status, add_date) values ('$gcid', '0','".addslashes($giftcert[purchaser])."','".addslashes($giftcert[recipient])."','$giftcert[send_via]','$giftcert[recipient_email]','".addslashes($giftcert[recipient_firstname])."','".addslashes($giftcert[recipient_lastname])."','".addslashes($giftcert[recipient_address])."','".addslashes($giftcert[recipient_city])."','$giftcert[recipient_state]','$giftcert[recipient_country]','$giftcert[recipient_zipcode]','$giftcert[recipient_phone]','".addslashes($giftcert[message])."','$giftcert[amount]','$giftcert[amount]','P','".time()."')");

			}
			elseif ($gcid) {

				db_query("UPDATE $sql_tbl[giftcerts] SET purchaser='".addslashes($giftcert[purchaser])."', recipient='".addslashes($giftcert[recipient])."', send_via='$giftcert[send_via]', recipient_email='$giftcert[recipient_email]', recipient_firstname='".addslashes($giftcert[recipient_firstname])."', recipient_lastname='".addslashes($giftcert[recipient_lastname])."', recipient_address='".addslashes($giftcert[recipient_address])."', recipient_city='".addslashes($giftcert[recipient_city])."', recipient_state='$giftcert[recipient_state]', recipient_country='$giftcert[recipient_country]', recipient_zipcode='$giftcert[recipient_zipcode]', recipient_phone='$giftcert[recipient_phone]', message='".addslashes($giftcert[message])."', amount='$giftcert[amount]', debit='$giftcert[amount]' WHERE gcid='$gcid'");

			}

			header ("Location: giftcerts.php");	
			exit;

	    }

	}
	else {
	
		while (list ($key,$val)=each($HTTP_POST_VARS))
		{
			if (strstr($key,"-"))
			{
				list ($field,$gcid)=split("-",$key);
				if ($field == "status") {
					$res = func_query_first("SELECT * FROM $sql_tbl[giftcerts] WHERE gcid='$gcid'");
					if ($val=="A" && $val!=$res["status"] && $res["send_via"]=="E")
						func_send_gc($config["Company"]["orders_department"], $res);
				}
				db_query("UPDATE $sql_tbl[giftcerts] SET $field='$val' WHERE gcid='$gcid'");
			}
		}
		header ("Location: giftcerts.php");	
		exit;

	}
}

if ($mode=="delete") {
#
# Delete gift certificate
#
	db_query("DELETE FROM $sql_tbl[giftcerts] WHERE gcid='$gcid'");
	header("Location: giftcerts.php");
	exit;
}

if ($mode == "add_gc" || $mode == "modify_gc") {

	include "../include/countries.php";
	include "../include/states.php";
	$giftcert=func_query_first("SELECT * FROM $sql_tbl[giftcerts] where gcid='$gcid'");
	$smarty->assign("giftcert",$giftcert);
	$gc_readonly = ($mode == "modify_gc" && $giftcert["status"]!="P"?"Y":"");

}
else {
	$expired_condition=($config["General"]["gc_show_expired"]=="Y"?"":" and status!='E'");

	$giftcerts=func_query("SELECT *, add_date+'".$config["General"]["timezone_offset"]."' as add_date FROM $sql_tbl[giftcerts] where 1 $expired_condition");
	$smarty->assign("giftcerts",$giftcerts);
}

$smarty->assign("main","giftcerts");
$smarty->assign("gc_readonly", $gc_readonly);

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
