#!/usr/local/bin/php
<?
#
# $Id: pay_subscriptions.php,v 1.3.4.1 2003/04/07 06:00:52 svowl Exp $
#

include "../smarty.php";
include "../config.php";

$logfile = $file_temp_dir."../pay_subscriptions.log";

#
# Authorize.Net CC processing module
#
function cc_processing($subscriptionid)
{

    global $store_cc, $module_params, $str, $sql_tbl;

    #
    # Set data for cc_processing
    #
    $query = "select sc.*, c.* from $sql_tbl[subscription_customers] as sc, $sql_tbl[customers] as c where sc.login=c.login and sc.subscriptionid='$subscriptionid'";
    $userinfo = func_query_first($query);
	$userinfo[card_number] = text_decrypt($userinfo[card_number]);

    $query = "select p.*, s.* from $sql_tbl[products] as p, $sql_tbl[subscriptions] as s where p.productid=s.productid and s.productid='$userinfo[productid]'";
    $product = func_query_first($query);

    $cart[total_cost] = $product[price_period];

    #
    # Include needed cc_processing module
    #
    chdir("../payment");
    include "cc_authorizenet.php";
    chdir("../admin");

    $cc_result[status] = "($bill_errorcode) $bill_error: $bill_message";
    $cc_result[bill_error] = $bill_errorcode;

    if ($cc_result[bill_error] != '1') {
        $order_status="F";
        $orderstatus_set = ", subscription_status='Disabled'";
    }   
    else 
        $order_status="P";
                            
    if (!$store_cc) $order_details = "";

    $payment_method = "Recurring billing (AuthorizeNet)";
    
    #
    # Insert into orders
    #
    $query = "insert into $sql_tbl[orders] (login, total, subtotal, shipping_cost, shippingid, tax, discount, coupon, coupon_discount, date, status, payment_method, flag, details, title, firstname, lastname, company, b_address, b_city, b_state, b_country, b_zipcode, s_address, s_city, s_state, s_country, s_zipcode, phone, fax, email) values ('$userinfo[login]', '$product[price_period]', '$product[price_period]','0', '0', '0', '0', '0', '0', '".time()."', '$order_status', '$payment_method', 'N', '".text_crypt($order_details)."', '$userinfo[title]', '$userinfo[firstname]', '$userinfo[lastname]', '$userinfo[company]', '$userinfo[b_address]', '$userinfo[b_city]', '$userinfo[b_state]', '$userinfo[b_country]', '$userinfo[b_zipcode]', '$userinfo[s_address]', '$userinfo[s_city]', '$userinfo[s_state]', '$userinfo[s_country]', '$userinfo[s_zipcode]', '$userinfo[phone]', '$userinfo[fax]', '$userinfo[email]')";
    db_query($query);

    $orderid=db_insert_id();

    #
    # Insert into order details
    #
    db_query("insert into $sql_tbl[order_details] (orderid, productid, product_options, amount, price, provider) values ('$orderid','$product[productid]','".addslashes($product["product_options"])."','1','$product[price_period]','".addslashes($product["provider"])."')");

    $query = "update $sql_tbl[subscription_customers] set last_payed_date='".time()."', last_payed_orderid='$orderid'".$orderstatus_set." where subscriptionid='$subscriptionid'";
    db_query($query);

    $str .= "    order id:........".$orderid."\n";
    $str .= "    pay date:........".date("m/d/Y")."\n";
    $str .= "    login:...........$userinfo[login]\n";
    $str .= "    total cost:......$product[price_period]\n";
    $str .= "    card number:.....$userinfo[card_number]\n";
    $str .= "    card expire:.....$userinfo[card_expire]\n";
    $str .= "    billing address:.$userinfo[b_address]\n";
    $str .= "    first name:......$userinfo[firstname]\n";
    $str .= "    last name:.......$userinfo[lastname]\n";
    $str .= "    zip code:........$userinfo[b_zipcode]\n";
    $str .= "          Status:....$cc_result[status]\n\n";

    return $result;
}


$module_params = func_query_first("select * from $sql_tbl[ccprocessors] where processor='cc_authorizenet.php'");

$curdate = mktime(0,0,0,date("m"),date("d"),date("Y"));

$str = "-------------------------------------------------------------\n";
$str .= date("m/d/Y H:i:s",time())." - script launching time\n";


if (!empty($subscriptionid)) {

    #
    # Get info about subsription products
    #
    $query = "select p.productid, p.product from $sql_tbl[subscription_customers] as sc, $sql_tbl[products] as p where sc.subscriptionid='$subscriptionid' and sc.productid=p.productid";
    $product=func_query_first($query);

    $str .= "#$product[productid] $product[product]:\n";
    cc_processing($subscriptionid);
}
else {

#
# Get info about subsription products
#
$query = "select s.*, p.product from $sql_tbl[subscriptions] as s, $sql_tbl[products] as p where s.productid=p.productid";
$products=func_query($query);

if ($products) {

    foreach($products as $k=>$product) {

        $pay_dates = Unserialize($product[pay_dates]);
        $next_pay_date = "";
        if ($pay_dates) {
            foreach($pay_dates as $pay_date)
                if ($pay_date == $curdate) {
                    $next_pay_date = $pay_date;
                    break;
                }
            if ($next_pay_date) {

                $str .= "#$product[productid] $product[product]:\n";

                #
                # Get info about customers-subsribers
                #

                $query = "select o.status, sc.* from $sql_tbl[subscription_customers] as sc, $sql_tbl[orders] as o where sc.orderid=o.orderid and sc.productid='$product[productid]'";
                $customers=func_query($query);

                if ($customers)
                    foreach($customers as $customer) {
                        if (($customer[status] == "P" || $customer[status] == "C") && $customer[subscription_status] != "Unsubscribed") {
                        
                            if (!empty($subscriptionid) && $customer[subscriptionid] != $subscriptionid)
                                continue;
                            cc_processing($customer[subscriptionid]);
                          }
                    }
            }
        }
        else
            continue;
    }
}
}

$mail_smarty->assign ("str", $str);
$mail_smarty->assign ("lng", $admin_language);

func_send_mail($config["Company"]["orders_department"], "mail/recurring_notification_subj.tpl", "mail/recurring_notification_admin.tpl", $userinfo["email"], true, true);

$fp = fopen($logfile, "a+");
fwrite($fp, $str);
fclose($fp);
@chmod($logfile, 0666);

echo "<pre><tt>$str</tt></pre>";

?>
