<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: search.php,v 1.31.2.2 2003/03/17 07:06:19 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

$tmp=strstr($QUERY_STRING, "XCARTSESSID=");
if (!empty($tmp))
	$QUERY_STRING=ereg_replace("XCARTSESSID=([0-9a-zA-Z]*)", "", $QUERY_STRING);
	
if(!empty($QUERY_STRING)) {

	$objects_per_page = $config["General"]["products_per_page_admin"];

#
# Set % as reseved name for list mode of search script
#
	$substring=trim($substring);
	while(strstr($substring,"\\")){
	$substring=stripslashes($substring);
	}
	$substring=addslashes($substring);

	$substring_condition = ($substring==""?"":"($sql_tbl[products].product like '%$substring%' or $sql_tbl[products].descr like '%$substring%') and ");

	$productid_condition = ($search_productid==""?"":"($sql_tbl[products].productid='$search_productid') AND ");
#
# Category search condition
#
	$search_category_name = addslashes(array_pop(func_query_first("select category from $sql_tbl[categories] where categoryid='$search_category'")));
	if (!empty($search_category)) $category_condition="$sql_tbl[categories].category like '$search_category_name%' and "; else $category_condition="";

	$search_query = $category_condition.$substring_condition.$productid_condition."$sql_tbl[products].provider like '$provider_substring%'";

	$search_query_count = "select count(*) from $sql_tbl[products], $sql_tbl[categories] where $sql_tbl[products].categoryid=$sql_tbl[categories].categoryid and $search_query";
	
	$total_products_in_search =  array_pop(func_query_first($search_query_count));

    $total_nav_pages = ceil($total_products_in_search/$objects_per_page)+1;

    require "../include/navigation.php";

	$smarty->assign("first_item", $first_page+1);
	$smarty->assign("last_item", min($first_page+$objects_per_page, $total_products_in_search));
	$smarty->assign("total_items", $total_products_in_search);

    foreach($HTTP_GET_VARS as $k=>$v) {
            $ret_str .= "&$k=$v";
    }
    $ret_str = ereg_replace("^&","",$ret_str);

    $smarty->assign("navigation_script","search.php?$ret_str");


	$products = func_search_products($search_query." GROUP BY $sql_tbl[products].productid ORDER BY $sql_tbl[products].product LIMIT $first_page, $objects_per_page", $user_account['membership']);

	$smarty->assign("products",$products);
	$smarty->assign("items_count",$total_products_in_search);
}

require "../include/categories.php";

$smarty->assign("main","search");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
