<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: shipping_options.php,v 1.5.2.1 2003/01/14 08:20:02 basil Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#
# Check and update UPS configuration
####################################
#
# Fields:
#	param00:	Drop-off/Pickup
#	param01:	Packaging
#

if ($carrier == "UPS") {
	$check = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='UPS'");
	if (!$check)
		db_query ("INSERT INTO $sql_tbl[shipping_options] (carrier) VALUES ('UPS')");
		
	db_query ("UPDATE $sql_tbl[shipping_options] SET param00='$param00', param01='$param01' WHERE carrier='UPS'");
	header ("Location: shipping_options.php?ups_updated");
	exit;
}

if ($carrier == "FDX") {
	$check = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='FDX'");
	if (!$check)
		db_query ("INSERT INTO $sql_tbl[shipping_options] (carrier) VALUES ('FDX')");

	db_query ("UPDATE $sql_tbl[shipping_options] SET param00='$company_type', param01='$packaging', param02='$dropoff_type' WHERE carrier='FDX'");

	header ("Location: shipping_options.php?fdx_updated");
	exit;
}

if ($carrier == "USPS") {
	$check = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='USPS'");
	if (!$check)
		db_query ("INSERT INTO $sql_tbl[shipping_options] (carrier) VALUES ('USPS')");

	db_query ("UPDATE $sql_tbl[shipping_options] SET param00='$mailtype', param01='$package_size', param02='$machinable', param03='$container_express', param04='$container_priority' WHERE carrier='USPS'");
	header ("Location: shipping_options.php?usps_updated");
	exit;
}

if ($carrier == "INTERSHIPPER") {
	$check = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='INTERSHIPPER'");
	if (!$check)
		db_query ("INSERT INTO $sql_tbl[shipping_options] (carrier) VALUES ('INTERSHIPPER')");

	if($pickup) $pickup=implode('|',$pickup);
	$length=(double)$length; $width=(double)$width; $height=(double)$height;
	$codvalue=(double)$codvalue; $insvalue=(double)$insvalue; 

	db_query ("UPDATE $sql_tbl[shipping_options] SET param00='$delivery', param01='$pickup', param02='$length', param03='$width', param04='$height', param05='$dunit', param06='$packaging', param07='$contents', param08='$codvalue', param09='$insvalue' WHERE carrier='INTERSHIPPER'");
	header ("Location: shipping_options.php?intershipper_updated");
	exit;
}

#
# Check and update FEDEX options
################################
#
# Fields:
#	param00:
#	param01:
#

#
# Collect options for all carriers
#
$shipping_options = array ();

$shipping_options ["ups"] = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='UPS'");
$shipping_options ["fdx"] = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='FDX'");
$shipping_options ["usps"] = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='USPS'");

$shipping_options["intershipper"] = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='INTERSHIPPER'");
$shipping_options["intershipper"]["pickup"]=explode('|',$shipping_options["intershipper"]["param01"]);

$smarty->assign ("shipping_options", $shipping_options);

$smarty->assign("main","shipping_options");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
