<?
#
# $Id: upgrade.php,v 1.6 2002/11/14 11:59:13 novik Exp $
#

require "safe_mode.php";

$patch_result    = array();
$patch_log       = array();
$patch_errorcode = 1;
$sql_errorcode   = 1;

#
# First pass to update files patchlist
#
for ($i = 0; $i < count($patch_files); $i++) {

	if (file_exists("../".$patch_files[$i]["orig_file"])) {

		exec("../$patch_exe -C -R -f -s -F0 -N -E -l -O -o $patch_tmp_folder/".basename($patch_files[$i]["orig_file"])." -r $patch_tmp_folder/".basename($patch_files[$i]["orig_file"]).".rej ../".$patch_files[$i]["orig_file"]." ".$upgrade_repository."/".$target_version."/".$patch_files[$i]["diff_file"]." 2>&1", $patch_result_, $patch_errorcode_);
		
		if ($patch_errorcode_ == 0) {
			$patch_files[$i]["status"] = "<font color=blue>ALREADY PATCHED</font>";
		} else {
			@unlink("$patch_tmp_folder/".basename($patch_files[$i]["orig_file"]).".rej");
		}
	} else {
		$patch_files[$i]["status"] = "<font color=red>FILE NOT FOUND</font>";
	}
}

#
# Apply doff patches
#
for ($i = 0; $i < count($patch_files); $i++) {

	if ($patch_files[$i]["status"] != "OK")
		continue;

	$patch_result_ = array();

	exec("../$patch_exe -f -N -E -l -O -o $patch_tmp_folder/".basename($patch_files[$i]["orig_file"])." -r $patch_tmp_folder/".basename($patch_files[$i]["orig_file"]).".rej ../".$patch_files[$i]["orig_file"]." ".$upgrade_repository."/".$target_version."/".$patch_files[$i]["diff_file"]." 2>&1", $patch_result_, $patch_errorcode_);

	if ($patch_errorcode_) {
		$patch_errorcode = 0;
		$patch_files[$i]["status"] = "<font color=red>FAILED</font>";
		$patch_result[] = "<FONT color=red>PATCH FAILED AT FILE: ".$patch_files[$i]["orig_file"].", see PATCH LOG for details.</FONT>";
	} else {
		$patch_files[$i]["status"] = "<font color=green>OK</font>";
		$patch_result[] = "File ".$patch_files[$i]["orig_file"]." successfully patched";
	}

	$patch_log = array_merge($patch_log, $patch_result_);
}

if ($dir = @opendir($upgrade_repository."/".$target_version)) {
#
# Apply .sql patches
#
	if ($patch_errorcode == 1) {

#
# Check for DB version first
#
		$db_version = func_query_first("SELECT value AS version FROM $sql_tbl[config] WHERE name='version'");

		if (!empty($db_version)) {
			if ($db_version['version'] != str_replace($config['version']."-","",$target_version)) {
#
# Patch database
#
				$patch_lines = array();
				$sql_error   = array();

				while (($file = readdir($dir)) !== false) {
					if (substr($file,-4)==".sql") {
						$patch_lines = file("$upgrade_repository/$target_version/$file");

						if (!empty($patch_lines)) {
							$sql_error = ExecuteSqlQuery(implode("",$patch_lines));
						
							if (!empty($sql_error)) {
								$patch_result[] = "<FONT color=red>SQL PATCH FAILED AT QUERY:</FONT>";
								$patch_result[] = $sql_error;
								$sql_errorcode  = 0;
							} else {
								$patch_result[] = "The database was successfully patched!";
							}
						}	
					} 
				}

				if (empty($patch_lines))
					$patch_result[] = "<FONT color=blue>EMPTY SQL PATCH!</FONT>";

			} else {
				$patch_result[] = "<FONT color=blue>DATABASE HAS BEEN PATCHED ALREADY</FONT>";
			}
		} else {
			$patch_result[] = "<FONT color=red>WRONG X-CART DATABASE VERSION</FONT>";
			$sql_errorcode  = 0;
		}
	} else {
		$patch_result[] = "<FONT color=red>DIFF PATCH FAILED. NOT APPLYING SQL PATCH.</FONT>";
		$sql_errorcode  = 0;
	}
}

#
# Update version & upgrade history if files and sql DB are patched OK
#
if ($patch_errorcode == 1 && $sql_errorcode == 1) {
	$patch_result[] = "Updating DB version info.";
	db_query("UPDATE $sql_tbl[config] SET value='$config[upgrade_history]\n$target_version' WHERE name='upgrade_history'");
	db_query("UPDATE $sql_tbl[config] SET value='".str_replace($config["version"]."-","",$target_version)."' WHERE name='version'");
} else {
	$patch_result[] = "<FONT color=red>The database version has not been updated!</FONT>";
}

$smarty->assign("patch_files",  $patch_files);
$smarty->assign("patch_log",    $patch_log);
$smarty->assign("patch_phase",  "upgrade_final");
$smarty->assign("patch_result", $patch_result);
?>
