<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: download.php,v 1.11.2.3 2003/03/21 09:31:27 svowl Exp $
#
# This module adds support for downloading electronicaly distributed goods 
#

require "../smarty.php";
require "../config.php";
require	"./auth.php";

if (empty($id)) exit();

$chunk_size = 100*1024;  # 100 Kb

$query = "SELECT * FROM $sql_tbl[download_keys] WHERE download_key = '$id'";
$res = func_query_first($query);

# If there is corresponding key in database and not expired
if ((count($res) > 0) AND ($res['expires'] > time())) {
	# check if there is valid distribution for this product
	$productid = $res['productid'];

	$result = func_query_first("SELECT distribution, product, provider FROM $sql_tbl[products] WHERE productid = '$productid'");

	$distribution = $result['distribution'];
	$provider = $result['provider'];

	if (empty($provider) || $single_mode)
		$distribution = $files_dir_name.$distribution;
	else 
		$distribution = $files_dir_name."/$provider".$distribution;

	if ($fd = @fopen($distribution, "rb")) {

		$fname = basename($distribution);
		$size = filesize($distribution);

		header("Content-type: application/octet-stream");
		header("Content-disposition: attachment; filename=\"$fname\"");
		header("Content-length: $size");

		for($i=0; $i<=$size; $i+=$chunk_size) {
			$contents = fread ($fd, $i+$chunk_size);
			echo $contents;
		}
		fclose ($fd);

	} else {
		# If no such distributive
		$smarty->assign("product", $result['product']);
		$smarty->display("modules/Egoods/no_distributive.tpl");
		exit();
	}
} else {
	$smarty->display("modules/Egoods/wrong_key.tpl");
	exit;
}
?>
