<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: giftcert.php,v 1.19.2.4 2003/03/24 13:42:29 svowl Exp $
#

require "../smarty.php";
require "../config.php";
@include "./https.php";
require "./auth.php";

session_register("cart");

if (!$config["General"]["min_gc_amount"])
	$config["General"]["min_gc_amount"] = 1;

if (!$config["General"]["max_gc_amount"])
	$config["General"]["max_gc_amount"] = 100;

#
# Gift certificates module
#
if ($gcid && $login) {

	$gc_array = func_query_first("SELECT * FROM $sql_tbl[giftcerts] WHERE gcid='$gcid'");
	if (count($gc_array) == 0)
		$gc_array = "";
	$smarty->assign("gc_array", $gc_array);

}
elseif ($mode == "gc2cart")
{
	$fill_error = (empty($purchaser) || empty($recipient));
	$amount_error = (($config["General"]["min_gc_amount"] && $amount<$config["General"]["min_gc_amount"]) || ($config["General"]["max_gc_amount"] && $amount>$config["General"]["max_gc_amount"]));
		
#
# Add GC to cart
#
    if ($send_via == "E") {
#
# Send via Email
#
        $fill_error = ($fill_error || empty($recipient_email));

        $giftcert = array ("purchaser" => stripslashes($purchaser),
                           "recipient" => stripslashes($recipient),
                           "message" => stripslashes($message),
                           "amount" => $amount,
                           "send_via" => $send_via,
                           "recipient_email" => $recipient_email);
    }
    else {
#
# Send via Postal Mail
#
        $fill_error = ($fill_error || empty($recipient_firstname) || empty($recipient_lastname) || empty($recipient_address) || empty($recipient_city) || empty($recipient_zipcode) || empty($recipient_state) || empty($recipient_country));

        $giftcert = array ("purchaser" => stripslashes($purchaser),
                           "recipient" => stripslashes($recipient),
                           "message" => stripslashes($message),
                           "amount" => $amount,
                           "send_via" => $send_via,
                           "recipient_firstname" => stripslashes($recipient_firstname),
                           "recipient_lastname" => stripslashes($recipient_lastname),
                           "recipient_address" => stripslashes($recipient_address),
                           "recipient_city" => stripslashes($recipient_city),
                           "recipient_zipcode" => $recipient_zipcode,
                           "recipient_state" => $recipient_state,
                           "recipient_country" => $recipient_country,
                           "recipient_phone" => $recipient_phone);
    }
#
# If gcindex is empty - add
# overwise - update
#
    if (!$fill_error && !$amount_error) {

        if ($gcindex!="")
                $cart["giftcerts"][$gcindex] = $giftcert;
        else
          $cart["giftcerts"][] = $giftcert;

        header("Location: cart.php");
        exit;
    }

}
elseif($mode == "delgc") {
#
# Remove GC from cart
#
        array_splice($cart["giftcerts"],$gcindex,1);   
        header("Location: cart.php");
        exit;
} 

require "../include/categories.php";

require "../include/countries.php";
require "../include/states.php";

$smarty->assign("giftcert",$giftcert);

if (!$fill_error && !$amount_error) 
    $smarty->assign("giftcert",$cart["giftcerts"]["$gcindex"]);
else {
    $smarty->assign("fill_error",$fill_error);
    $smarty->assign("amount_error",$amount_error);
}

if ($login)
	$smarty->assign("userinfo", func_userinfo($login, "C"));
	
$smarty->assign("min_gc_amount", $config["General"]["min_gc_amount"]);
$smarty->assign("max_gc_amount", $config["General"]["max_gc_amount"]);

$smarty->assign("main","giftcert");
$smarty->display("customer/home.tpl"); 
?>
