<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: recommends.php,v 1.6.2.1 2003/03/28 09:18:26 svowl Exp $
#
# Recommends list
#


#
# Get products data for current category and store it into $products array
#

$products_id = func_query("SELECT productid FROM $sql_tbl[products] WHERE forsale='Y' and avail>0");

if ($config["Modules"]["select_recommends_list_randomly"] == "Y" && count($products_id)>0) {
    $str = "";
    $query_condition = " AND (";
    srand((double)microtime()*1000000);
    if ($products_id) 
		$rnd = rand(0, count($products_id)-1);
	else  $rnd=0;
    $query_condition .= "productid='".$products_id[$rnd][productid]."'";
    for($i = 0; $i < $config["Modules"]["number_of_recommends"] - 1; $i++) {
        if ($products_id)  $rnd = rand(0, count($products_id)-1); else  $rnd=0;
        if (!ereg("'".$products_id[$rnd][productid]."'", $query_condition)) {
            $query_condition .= " OR productid='".$products_id[$rnd][productid]."'";
        }
    }
    $query_condition .= ")";
    $query = "SELECT * FROM $sql_tbl[products] WHERE forsale='Y' AND avail>0".$query_condition;
}
else
    $query = "select distinct sp2.productid, p.* from $sql_tbl[stats_customers_products] as sp1, $sql_tbl[stats_customers_products] as sp2, $sql_tbl[products] as p where sp1.productid='$productid' and sp1.login=sp2.login and sp2.productid!='$productid' and p.productid=sp2.productid and p.forsale='Y' and p.avail>0 ORDER BY p.product LIMIT ".$config["Modules"]["number_of_recommends"];

$recommends = func_query($query);
$smarty->assign("recommends",$recommends);
?>
