<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: banner_stats.php,v 1.7 2002/12/05 13:10:39 alfiya Exp $
#

$banner_stats = array ();

$login_condition = ($current_area == "B")?"login='$login' AND":"";

# Get the current date, but one day before
$c_date = getdate (time()-24*60*60);

$banners = func_query("select distinct class from $sql_tbl[partner_views] where $login_condition 1 order by class");

if ($banners) {
    $cnt = 0;
    foreach($banners as $k=>$banner) {
        $banner_stats [$cnt]["class"] = $banner["class"];
    # Fetch banner views
        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition class='$banner[class]'");
        $banner_stats [$cnt]["views_total"] = $result ["amount"];

        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition class='$banner[class]' AND add_date>'".mktime(0,0,0,0,0,$c_date["year"])."'");
        $banner_stats [$cnt]["views_year"] = $result ["amount"];

        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition class='$banner[class]' AND add_date>'".mktime(0,0,0,$c_date["mon"],0,$c_date["year"])."'");
        $banner_stats [$cnt]["views_month"] = $result ["amount"];

        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition class='$banner[class]' AND add_date>'".mktime(0,0,0,$c_date["mon"],$c_date["mday"],$c_date["year"])."'");
        $banner_stats [$cnt]["views_day"] = $result ["amount"];

# Now fetch clicks
        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition class='$banner[class]'");
        $banner_stats [$cnt]["clicks_total"] = $result ["amount"];

        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition class='$banner[class]' AND add_date>'".mktime(0,0,0,0,0,$c_date["year"])."'");
        $banner_stats [$cnt]["clicks_year"] = $result ["amount"];

        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition class='$banner[class]' AND add_date>'".mktime(0,0,0,$c_date["mon"],0,$c_date["year"])."'");
        $banner_stats [$cnt]["clicks_month"] = $result ["amount"];

        $result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition class='$banner[class]' AND add_date>'".mktime(0,0,0,$c_date["mon"],$c_date["mday"],$c_date["year"])."'");
        $banner_stats [$cnt]["clicks_day"] = $result ["amount"];

        $cnt++;
    }

}

        
# Fetch banner views
$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition 1");
$all_banner_stats ["views_total"] = $result ["amount"];

$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition add_date>'".mktime(0,0,0,0,0,$c_date["year"])."'");
$all_banner_stats ["views_year"] = $result ["amount"];

$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition add_date>'".mktime(0,0,0,$c_date["mon"],0,$c_date["year"])."'");
$all_banner_stats ["views_month"] = $result ["amount"];

$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_views] WHERE $login_condition add_date>'".mktime(0,0,0,$c_date["mon"],$c_date["mday"],$c_date["year"])."'");
$all_banner_stats ["views_day"] = $result ["amount"];

# Now fetch clicks
$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition 1");
$all_banner_stats ["clicks_total"] = $result ["amount"];

$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition add_date>'".mktime(0,0,0,0,0,$c_date["year"])."'");
$all_banner_stats ["clicks_year"] = $result ["amount"];

$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition add_date>'".mktime(0,0,0,$c_date["mon"],0,$c_date["year"])."'");
$all_banner_stats ["clicks_month"] = $result ["amount"];

$result = func_query_first ("SELECT COUNT(*) AS amount FROM $sql_tbl[partner_clicks] WHERE $login_condition add_date>'".mktime(0,0,0,$c_date["mon"],$c_date["mday"],$c_date["year"])."'");
$all_banner_stats ["clicks_day"] = $result ["amount"];


$smarty->assign ("banner_stats", $banner_stats);
$smarty->assign ("all_banner_stats", $all_banner_stats);
?>
