<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: login.php,v 1.45.2.1 2003/03/07 06:13:26 svowl Exp $
#

require "../smarty.php";
require "../config.php";

if ($HTTP_POST_VARS["login"] || $HTTP_GET_VARS["login"] || $HTTP_COOKIE_VARS["login"] || $HTTP_POST_VARS["login_type"] || $HTTP_GET_VARS["login_type"] || $HTTP_COOKIE_VARS["login_type"]) {
    header("Location: ../customer/error_message.php?access_denied");
    exit();
}
		
session_register("login");
session_register("login_type");
session_register("logged");

session_register("login_attempt");
session_register("cart");
session_register("intershipper_recalc");

$login_error=false;


if($REQUEST_METHOD=="POST") {
	$intershipper_recalc = "Y";
    if($mode=="login") {


	$username = $HTTP_POST_VARS["username"];
	$password = $HTTP_POST_VARS["password"];


    $user_data=func_query_first("select * from $sql_tbl[customers] where login='$username' and usertype='$usertype' and status='Y'");

	if(!empty($user_data) && $password==text_decrypt($user_data["password"]) && !empty($password)) {
#
# Success login
#

		$login = $user_data[login];  //$username;
		$login_type = $usertype;
		$logged = "";
#   
# 1) generate $last_login by current timestamp and update database
# 2) insert entry into login history 
#
		$tm = time();
		db_query("update $sql_tbl[customers] set last_login='$tm' where login='$login'");
		db_query("insert into $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) values ('$username','$tm','$usertype','login','success','$REMOTE_ADDR')");

#
# Set cookie with username if Greet visitor module enabled 
#

		if($active_modules["Greet_Visitor"])
    		include "../modules/Greet_Visitor/set_cookie.php";
	

#
# If shopping cart is not empty then user is redirected to cart.php
# Default password alert
#
		$Simple_Mode=array_pop(func_query_first("select active from $sql_tbl[modules] where module_name ='Simple_Mode'"));

		$default_accounts_string="";
		$accounts=func_query("select login, password, usertype from $sql_tbl[customers] where usertype!='C' ");
		if ($accounts)
		foreach ($accounts as $account){
			if ( $account["login"]=="admin" and  text_decrypt($account["password"])=="admin" and $Simple_Mode=="N" and $login_type=="A"){
					$default_accounts_string.=" ".$account["login"]."/".text_decrypt($account["password"]);				
					$default_accounts[]=$account;
				}
			if ( ($account["login"]=="root" and  text_decrypt($account["password"])=="root") or ($account["login"]=="provider" and  text_decrypt($account["password"])=="provider") or ($account["login"]=="master" and  text_decrypt($account["password"])=="master") )
				if ($Simple_Mode=="Y" or $username==$account["login"]  or $login_type=="A")
				{
					$default_accounts_string.=" ".$account["login"]."/".text_decrypt($account["password"]);				$default_accounts[]=$account;
				}			
			}

		if (count($default_accounts)==1) {
			if ($Simple_Mode=="Y") 				$to_url="../admin/users.php?substring=&membership=&usertype=P";
			elseif ($default_accounts[0]["usertype"]=="A")  $to_url="../admin/users.php?substring=&membership=&usertype=A";
			elseif ($default_accounts[0]["usertype"]=="P" and $default_accounts[0]["usertype"]!=$login_type)  $to_url="../admin/users.php?substring=&membership=&usertype=P";
			elseif (!$Simple_Mode) $to_url="../provider/register.php?mode=update";
			else $to_url="../$redirect/register.php?mode=update";
			$default_accounts_string=" is".$default_accounts_string;
		}
		elseif  (count($default_accounts)>1){
			if ($Simple_Mode=="Y") 				
			$to_url="../admin/users.php?substring=&membership=&usertype=P";			
			else $to_url="../admin/users.php";			
			$default_accounts_string=" are".$default_accounts_string;
		}

		if ($login_type=="C") {
			if(!func_is_cart_empty($cart)) 
				header("Location: ../$redirect/cart.php");
			else
				header("Location: ../$redirect/home.php");
			exit;
		}
		if ( ($config["General"]["default_pwd"]=="Y") and (count($default_accounts)>0) and $admin_safe_mode==false) {
			echo"<SCRIPT language='JavaScript'>
			alert('Default passwords for one or more administrator/provider accounts are not changed. We recommend you to change default passwords for security reasons. The default X-cart accounts$default_accounts_string!');		
			self.location='$to_url';
			</SCRIPT>	";
		}
		else
			header("Location: ../$redirect/home.php");
		exit;
	}
	else {
#
# Login incorrect
#
		db_query("insert into $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) values ('$username','".time()."','$usertype','login','failure', '$REMOTE_ADDR')");
		if ($redirect=="admin") {
#
# Send security alert to website admin
#
			if (!$admin_language) 
				$admin_language = func_get_language ($config["default_admin_language"]);
				$mail_smarty->assign ("lng", $admin_language);

			func_send_mail($config["Company"]["site_administrator"], "mail/login_error_subj.tpl", "mail/login_error.tpl", $config["Company"]["site_administrator"], true);

		}
#
# After 3 failures redirects to Recover password page
#
		$login_attempt++;
		if($login_attempt>=3) {
			$login_attempt="";
			header("Location: ../$redirect/help.php?section=Password_Recovery");
		} else
		header("Location: ../$redirect/error_message.php?login_incorrect");
	}
	exit;
	}
}


if($mode=="logout") { 
#
# Insert entry into login_history
#
	db_query("insert into $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) values ('$login','".time()."','$login_type','logout','success','$REMOTE_ADDR')");

	$login=""; $login_type="";
 }

header("Location: ../$redirect/home.php");
?>
