<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: orders.php,v 1.20.2.3 2003/03/17 07:06:19 svowl Exp $
#

#
# Generate timestamp for first day of current month
#
$ctime = time() + $config["General"]["timezone_offset"];

$start_date = mktime (0,0,0,date("m",$ctime),1,date("Y",$ctime));
$end_date = $ctime;

$objects_per_page = $config["General"]["orders_per_page_admin"];

$tmp=strstr($QUERY_STRING, "XCARTSESSID=");
if (!empty($tmp))
	$QUERY_STRING=ereg_replace("XCARTSESSID=([0-9a-zA-Z]*)", "", $QUERY_STRING);

if($QUERY_STRING) {
#
# Set % as reserved name for list mode of search script
# Substring condition
#
    $substring_condition = ($substring==""?"":" and $sql_tbl[orders].login='$substring'");

        $status_condition = ($status?" and $sql_tbl[orders].status='$status'":"");
        $orderid_condition = ($orderid?" and $sql_tbl[orders].orderid='$orderid'":"");

#
# Generate timestamps and assign then to smarty
#
        if($StartMonth) {
                $start_date=mktime(0,0,0,$StartMonth,$StartDay,$StartYear);
                $end_date=mktime(23,59,59,$EndMonth,$EndDay,$EndYear);
        }

$o_date = "$sql_tbl[orders].date+'".$config["General"]["timezone_offset"]."'";

        $orders = func_query("select $sql_tbl[orders].*, $sql_tbl[order_details].provider from $sql_tbl[orders], $sql_tbl[order_details] where $sql_tbl[orders].orderid=$sql_tbl[order_details].orderid ".($provider?" and $sql_tbl[order_details].provider='$provider'":"")." and $o_date>=$start_date and $o_date<=$end_date".$substring_condition.$status_condition.$orderid_condition." order by $sql_tbl[orders].date desc");

		if(!$provider)
			$orders = array_merge($orders, func_query("select $sql_tbl[orders].*, $sql_tbl[giftcerts].gcid, $sql_tbl[giftcerts].purchaser, $sql_tbl[giftcerts].recipient, $sql_tbl[giftcerts].message, $sql_tbl[giftcerts].amount, $sql_tbl[giftcerts].debit, $sql_tbl[giftcerts].add_date, $sql_tbl[giftcerts].status as gc_status FROM $sql_tbl[orders], $sql_tbl[giftcerts] where $sql_tbl[orders].orderid=$sql_tbl[giftcerts].orderid and $o_date>=$start_date and $o_date<=$end_date ".$substring_condition.$status_condition.$orderid_condition." order by $sql_tbl[orders].date desc"));

#
# Do array multisort by orderid
#
		$orderids = array();

		if(!empty($orders)) {
			foreach($orders as $order)
				$orderids[]=$order["orderid"];

			array_multisort($orderids, SORT_DESC, $orders);
		}
#
# This routine removes duplications from $orders array
#
	$orders_string = array();
	if(!empty($orders))
		foreach($orders as $key=>$uniq_order)
			if ($uniq_order["orderid"] != $orders[$key+1]["orderid"]) {
				$new_orders[]=$uniq_order;
				$orders_string [] = $uniq_order["orderid"];
			}
			
	$orders=$new_orders;
	$total_orders = count($orders);

	if ($mode != 'export') {
#
# If orders do not exports, separate them on the pages
#
		$total_nav_pages = ceil($total_orders/$objects_per_page)+1;

		include "../include/navigation.php";

		if (is_array($orders))
			$orders = array_slice($orders, $first_page, $objects_per_page);
		$smarty->assign("first_item", $first_page+1);
		$smarty->assign("last_item", min($first_page+$objects_per_page, $total_orders));
		$smarty->assign("total_items", $total_orders);

	}
	
	if ($orders)
		foreach($orders as $k=>$v) {
			$orders[$k]["date"] += $config["General"]["timezone_offset"];
			if ($v["add_date"])
				$orders[$k]["add_date"] += $config["General"]["timezone_offset"];
		}
	
	foreach($HTTP_GET_VARS as $k=>$v) {
		if (!empty($v) && $k != "mode")
			$ret_str .= "&$k=$v";
	}
	$ret_str = ereg_replace("^&","",$ret_str);

	$smarty->assign("navigation_script","orders.php?$ret_str");

#
# Make orders_full array, that contains detailed information about orders
#
    $orders_full = array ();
 
    if ($orders) {
        foreach ($orders as $key=>$value) {
            $products_result = func_query ("SELECT * FROM $sql_tbl[order_details] WHERE orderid='$value[orderid]'");
            if ($products_result) {
                foreach ($products_result as $subkey=>$subvalue) {
                    $result = array_merge ($value, $subvalue);
                    $product_result = func_query_first ("SELECT * FROM $sql_tbl[products] WHERE productid='$subvalue[productid]'");
                    if ($product_result)
                        $result = array_merge ($result, $product_result);
 
                    $orders_full [] = $result;
                }
            }
 
            $gifts_result = func_query_first ("SELECT * FROM $sql_tbl[giftcerts] WHERE orderid='$value[orderid]'");
 
            if ($gifts_result) {
                $result = array_merge ($value, $gifts_result);
                $orders_full [] = $result;
            }
        }
    }

	if ($orders_string)
		$smarty->assign ("orders_string", urlencode(implode (",", $orders_string)));
	$smarty->assign("orders",$orders);
	$smarty->assign("items_count",count($orders));
	$smarty->assign("total_orders",$total_orders);
}

$smarty->assign("orders_full", $orders_full);

$smarty->assign("start_date",$start_date);
$smarty->assign("end_date",$end_date);
$smarty->assign("main","orders");

?>
