<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: orders_export.php,v 1.8.2.2 2003/03/17 08:23:24 svowl Exp $
#

$ctime = time() + $config["General"]["timezone_offset"];

$chunk_size = 10;

$start_date = mktime (0,0,0,date("m",$ctime),1,date("Y",$ctime));
$end_date = $ctime;

$tmp=strstr($QUERY_STRING, "XCARTSESSID=");
if (!empty($tmp))
    $QUERY_STRING=ereg_replace("XCARTSESSID=([0-9a-zA-Z]*)", "", $QUERY_STRING);

if($QUERY_STRING) {
#
# Set % as reserved name for list mode of search script
# Substring condition
#
    $substring_condition = ($substring==""?"":" and $sql_tbl[orders].login='$substring'");

    $status_condition = ($status?" and $sql_tbl[orders].status='$status'":"");
    $orderid_condition = ($orderid?" and $sql_tbl[orders].orderid='$orderid'":"");

#
# Generate timestamps and assign then to smarty
#
    if($StartMonth) {
        $start_date=mktime(0,0,0,$StartMonth,$StartDay,$StartYear);
        $end_date=mktime(23,59,59,$EndMonth,$EndDay,$EndYear);
    }

    $o_date = "$sql_tbl[orders].date+'".$config["General"]["timezone_offset"]."'";

    $search_orders_query = "select $sql_tbl[orders].*, $sql_tbl[order_details].provider from $sql_tbl[orders], $sql_tbl[order_details] where $sql_tbl[orders].orderid=$sql_tbl[order_details].orderid ".($provider?" and $sql_tbl[order_details].provider='$provider'":"")." and $o_date>=$start_date and $o_date<=$end_date".$substring_condition.$status_condition.$orderid_condition." GROUP BY $sql_tbl[orders].orderid ORDER BY $sql_tbl[orders].orderid desc";

    $orders_result = db_query($search_orders_query);

    if(!$provider) {
        $search_orders_gc_query = "select $sql_tbl[orders].*, $sql_tbl[giftcerts].gcid, $sql_tbl[giftcerts].purchaser, $sql_tbl[giftcerts].recipient, $sql_tbl[giftcerts].message, $sql_tbl[giftcerts].amount, $sql_tbl[giftcerts].debit, $sql_tbl[giftcerts].add_date, $sql_tbl[giftcerts].status as gc_status FROM $sql_tbl[orders], $sql_tbl[giftcerts] where $sql_tbl[orders].orderid=$sql_tbl[giftcerts].orderid and $o_date>=$start_date and $o_date<=$end_date ".$substring_condition.$status_condition.$orderid_condition." GROUP BY $sql_tbl[orders].orderid ORDER BY $sql_tbl[orders].orderid desc";
        $orders_gc_result = db_query($search_orders_gc_query);
    }

#
# Do array multisort by orderid
#
    $orderids = array();
    
    $total_lines = 0;

    if($orders_result) {
        $index = 0;
        while($row = db_fetch_array($orders_result)) {
            $orderids[$row["orderid"]][] = array($index++, "P");
            $total_lines++;
        }
    }
    if($orders_gc_result) {
        $index = 0;
        while($row = db_fetch_array($orders_gc_result)) {
            $orderids[$row["orderid"]][] = array($index++, "G");
            $total_lines++;
        }
    }

    if ($orderids) {
        ksort($orderids, SORT_DESC);

        header("Content-type: text/csv");
        header("Content-disposition: attachment; filename=orders.csv");

        $smarty->assign("delimiter", $delimiter);

        $_tmp_smarty_debug = $smarty->debugging;
        $smarty->debugging = false;

        $counter = 0;

        foreach($orderids as $orderid_item) {
        foreach($orderid_item as $orderid) {

            if ($orderid[1] == "P") {
                mysql_data_seek($orders_result, $orderid[0]);
                $row = db_fetch_array($orders_result);
            }
            elseif ($orderid[1] == "G") {
                mysql_data_seek($orders_gc_result, $orderid[0]);
                $row = db_fetch_array($orders_gc_result);
            }

            if ($row) {

                $row["date"] += $config["General"]["timezone_offset"];

                if ($orderid[1] == "P") {
                    $order_details = func_query("SELECT * FROM $sql_tbl[order_details] WHERE orderid='$row[orderid]'");
                    if (is_array($order_details)) {
                        foreach ($order_details as $k=>$v) {
                            $product_data = func_query_first("SELECT * FROM $sql_tbl[products] WHERE productid='$v[productid]'");
                            $product_data["add_date"] += $config["General"]["timezone_offset"];

                            if (is_array($product_data))
                                $orders_full[] = array_merge ($row, $product_data, $v);
                                unset($product_data);
                        }
                    }
                }
                elseif ($orderid[1] == "G") {

                    $giftcerts_details = func_query_first("SELECT * FROM $sql_tbl[giftcerts] WHERE orderid='$row[orderid]'");
                    $giftcerts_details["add_date"] += $config["General"]["timezone_offset"];

                    if (is_array($giftcerts_details)) {
                        $orders_full[] = array_merge ($row, $giftcerts_details);
                        unset($giftcerts_details);
                    }
                }

                $counter += count($orders_full);

                if ($counter%$chunk_size==0 || $counter>=$total_lines) {

                    if ($orders_full) {
                        foreach ($orders_full as $key => $value) {
                            foreach ($value as $subkey => $subvalue) {
                                if ($subkey == "details")
                                    $orders_full[$key][$subkey] = "\"" . eregi_replace ("\"", "\"\"", text_decrypt($orders_full [$key][$subkey])) . "\"";
                                elseif($subkey == "date")
                                    $orders_full[$key][$subkey]=date("d-m-Y H:i:s", $orders_full[$key][$subkey]);
                                else {
                                    $orders_full[$key][$subkey] = strtr($orders_full[$key][$subkey], "\r\n\t", "");
                                    $orders_full[$key][$subkey] = "\"" . eregi_replace ("\"", "\"\"", $orders_full[$key][$subkey]) . "\"";
                                }
                            }
                        }
                    }

                    $smarty->assign("orders", $orders_full);
                    $smarty->display("main/orders_export.tpl");
                    flush();
                    unset($orders_full);
                }

            }
		} # /for
        }
        $smarty->debugging = $_tmp_smarty_debug;
        exit;
    }
}
header("Location: $HTTP_REFERER");
exit;

?>
