<?
#
# X-Cart installation wizard
#
# $Id: install.php,v 1.63.2.4 2003/03/11 14:49:32 svowl Exp $
#

#
# Put access code here
# A person who do not know the auth code can not access the installation script
#
$installation_auth_code = "BG6GJH39";

#
# Changing some configuration parameters
#
set_magic_quotes_runtime(0);
error_reporting (E_ALL ^ E_NOTICE);
set_time_limit(300);
umask(0);

if (empty($HTTP_SERVER_VARS)) {
	$HTTP_GET_VARS = &$_GET;
	$HTTP_POST_VARS = &$_POST;
	$HTTP_SERVER_VARS = &$_SERVER;
}

#
# Predefined common variables
#

$templates_repository = "skin1_original";
$schemes_repository = "schemes";

$templates_directory = "skin1";

$min_ver = "4.0.6";

$directories_to_create = array(".pgp", "templates_c", "$templates_directory", "files", "catalog");
$directories_to_create[] = "files/master";

$files_to_create = array("files/.htaccess"=>"Deny from all");

$error = false;

#
# Modules array 
#

$modules = array (
	0 => array(
			"name" => "default",
			"comment" => "Licence agreement",
			"js_back" => 0,
			"js_next" => 1
		),
	1 => array(
			"name" => "check_cfg",
			"comment" => "Checking PHP configuration",
			"js_back" => 0,
			"js_next" => 0
		),
	2 => array(
			"name" => "cfg_install_db",
			"comment" => "Preparing to install X-Cart database",
			"js_back" => 0,
			"js_next" => 1
		),
	3 => array(
			"name" => "install_db",
			"comment" => "Installing X-Cart database",
			"js_back" => 0,
			"js_next" => 0
		),
	4 => array(
			"name" => "cfg_install_dirs",
			"comment" => "Color and layout settings",
			"js_back" => 0,
			"js_next" => 0
		),

	5 => array(
			"name" => "install_dirs",
			"comment" => "Setting up templates",
			"js_back" => 0,
			"js_next" => 0
		),
	6 => array(
			"name" => "install_done",
			"comment" => "Installation complete",
			"js_back" => 0,
			"js_next" => 0
		)
);

#
# start: Modules manager
#

# get working parameters

$current = (int)$HTTP_POST_VARS["current"];
$params = $HTTP_POST_VARS["params"];

if ($current < 0 || $current >= count($modules))
	die("invalid current");

# if (file_exists($templates_directory)) 
# die("X-Cart is already installed");

# start html output

?>
<HTML>
<HEAD>
<TITLE>X-Cart Installation Wizard</TITLE>

<STYLE type="text/css">

BODY,P,DIV,TH,TD,P,INPUT,SELECT {
	COLOR: #550000; FONT-FAMILY: Verdana, Arial, Helvetica; FONT-SIZE: 12px;
}
A {
	COLOR: #330000; TEXT-DECORATION: none;
}
A:hover {
	COLOR: #550000; TEXT-DECORATION: underline;
}

BODY { margin-top: 0px; margin-left: 0px; margin-right: 0px }

<?
if ($current == 0) {
?>
.background {
	BACKGROUND-COLOR: #FFFBD3; BACKGROUND-IMAGE: URL('http://www.x-cart.com/img/background_inst.gif');
}
<?
}else {
?>
.background {
	BACKGROUND-COLOR: #FFFBD3;
}
<?
}
?>
.TableTop {
	BACKGROUND-COLOR: #FFFBD3;
}
.Clr1 {
	BACKGROUND-COLOR: #DDDDDD;
}
.Clr2 {
	BACKGROUND-COLOR: #EEEEEE;
}

</STYLE>

<SCRIPT language="javascript">
<?



# show module's according scripts

# 'back' button's script
switch ($modules[$current]["js_back"]) {
	case 0:
		default_js_back();
		break;
	case 1:
		$func = "module_".$modules[$current]["name"]."_js_back";
		$func();
		break;
	default:
		die("Invalid js_back value for module ".$modules[$current]["name"]."!");
}

# 'next' button's script
switch ($modules[$current]["js_next"]) {
	case 0:
		default_js_next();
		break;
	case 1:
		$func = "module_".$modules[$current]["name"]."_js_next";
		$func();
		break;
	default:
}
?>
</SCRIPT>
</HEAD>

<BODY class="background">
<TABLE class="TableTop" width="100%" border=0 cellspacing=0 cellpadding=0>

<? /* common header */ ?>
<TR>
 <TD valign=bottom align=right width=284 height="60" background="./skin1_original/images/logo.gif">
  <FONT COLOR=#FFFFFF SIZE=1><B><? @readfile("VERSION"); ?></B></FONT>
 </TD>
<TD background="./skin1_original/images/top1.gif" align=right valign=top>
  <FONT COLOR=#FFFFFF size=+1><B>X-Cart Installation Wizard</B></FONT>&nbsp;&nbsp;<BR>
  <FONT COLOR=#FFFFFF><B>Step <? echo $current ?>: <? echo $modules[$current]["comment"] ?></B></FONT>&nbsp;&nbsp;
</TD>
</TR>
</TABLE>
<P>
<TABLE class="TableTop" width="90%" border=0 cellspacing=0 cellpadding=0 align=center>
<? /* common form */ ?>
<FORM method="POST" name="ifrm" action="<? echo $$HTTP_SERVER_VARS["PHP_SELF"] ?>">

<TR>
<TD>
<?
if (isset($force_current)) {
	if($auth_code!=$installation_auth_code) {
		message("Wrong auth code! You can not proceed.");
		exit;
	} else {
		$current=$force_current;
	}
}

# get full function's name to call according module
$func = "module_".$modules[$current]["name"];

# run module
$res = $func($params);
?>
</TD>
</TR>
<?

# show navigation buttons

$prev = $current;

if (!$res)
	$current += 1;

if ($current < count($modules)) {
?>

<TR>
 <TD align="center">
<?
if (!empty($params)) {
	foreach ($params as $key => $val) {
?>
  <INPUT type=hidden name="params[<? echo $key ?>]" value="<? echo $val ?>">
<?
	}
}
?>
  <INPUT type=hidden name="current" value="<? echo $current ?>">
  <INPUT type=button value="&lt; Back"<? echo ($prev > 0 ? "" : " disabled") ?> onClick="javascript:return step_back()">
  <INPUT type=button value="Next &gt;"<? echo ($error ? " disabled" : "") ?> onClick="javascript:if (step_next()) { ifrm.submit(); return true; } else { return false; }">
 </TD>
</TR>
<?
}
?>
</FORM>

<? /* common bottom */ ?>

</TABLE>
<BR>
<HR size=1 noshade>
<DIV ALIGN=right>
  <FONT size=1>
  Copyright 2001-2002 <A href="http://www.x-cart.com">X-Cart.com</A><BR>
  Copyright 2001-2002 <A href="http://www.rrfinc.com" target="_blank">RRF.ru development</A>
</DIV>
</BODY>
</HTML>
<?

#
# end: Modules manager
#

exit();

#
# start: default navigation buttons handlers
#

function default_js_back() {
?>
	function step_back() {
		history.back();
		return true;
	}
<?
}

function default_js_next() {
?>
	function step_next() {
		return true;
	}
<?
}

#
# end: default navigation buttons handlers
#

################################################################
#
# Common functions goes here
#
################################################################

function fatal_error($txt) {
?>
<CENTER>
<P>
 <B><FONT color=red>Fatal error: <? echo $txt ?>.<BR>Please correct the error(s) before proceeding to the next step.</FONT></B>
</P>
</CENTER>
<?
	return false;
}

function warning_error($txt) {
?>
<CENTER>
<P>
 <B><FONT color=red>Warning: <? echo $txt ?>.</FONT></B>
</P>
</CENTER>
<?
	return false;
}

function message($txt) {
?>
<B><FONT color=darkgreen><? echo $txt ?></FONT></B>
<?
}

function status($var) {
	return ($var ? "<FONT color=green>[OK]</FONT>" : "<FONT color=red>[FAILED]</FONT>");
}

function on_off($var) {
	return ($var ? "On" : "Off");
}

function query_upload($filename) {
#
# returned by zorg (for debug purposes)
#
# return true;

	$fp = fopen($filename, "rb");

	$command = "";
	$counter = 0;

	echo "<BR>Please wait ...<BR>\n";

	while (!feof($fp)) {
		$c = chop(fgets($fp, 1500000));
		$c = ereg_replace("^[ \t]*#.*", "", $c);

		$command .= $c;

		if (ereg(";$", $command)) {
			$command = ereg_replace(";$", "", $command);

			if (ereg("CREATE TABLE ", $command)) {
				$table_name = ereg_replace(" .*$", "", eregi_replace("^.*CREATE TABLE ", "", $command));
				echo "Creating table: [$table_name] ... "; flush();

				mysql_query($command);

				$myerr = mysql_error();
				if (!empty($myerr))
					break;
				else
					echo status(true)."<BR>\n";
			} else {
				mysql_query($command);

				$myerr = mysql_error();
				if (!empty($myerr))
					break;
				else {
					$counter++;

					if (!($counter % 20)) {
						echo "."; flush();
					}
				}
			}

			$command = "";
			flush();
		}
	}

	fclose($fp);

	if (!empty($myerr))
		echo status(false)." ".$myerr."<BR>\n";
	else {
		if ($counter > 19) echo "<BR>\n";
		echo status(empty($myerr))."<BR>\n";
	}

	return empty($myerr);
}

function update_pgp() {
#	if (!is_dir(".pgp")) {
#		if (!mkdir(".pgp", 0755))
#			return false;

		// we need to copy all files from .pgp.def to .pgp here!
		// code must be win32 safe!
#	}

	return true;
}

#
# Function to copy directory tree from skin1_original to skin1
#

function copy_files($dir, $parent_dir, $templates_repository) {
	global $templates_directory;

	$status = true;

	if (!$handle = @opendir($dir)) {
		echo status(false)."<BR>\n";
		return false;
	}

	while (($file = readdir($handle)) !== false) {
		if (is_file($dir."/".$file)) {
			if (!@copy("$templates_repository$parent_dir/$file", "$templates_directory$parent_dir/$file")) {
				echo "Copying $templates_repository$parent_dir/$file to $templates_directory$parent_dir/$file ... ".status(false)."<BR>\n";
				$status &= false;
			}

			flush();

		} else if (is_dir($dir."/".$file) && $file != "." && $file != "..") {
			echo "Creating directory $templates_directory$parent_dir/$file ... ";

			if(!file_exists("$templates_directory$parent_dir/$file")) {
				if(!@mkdir("$templates_directory$parent_dir/$file", 0777)) {
					echo status(false);
					$status &= false;
				} else
					echo status(true);
			} else
				echo "[Already exists]";

			echo "<BR>\n"; flush();

			$status &= copy_files($dir."/".$file, $parent_dir."/".$file, $templates_repository);
		}
	}

	closedir($handle);

	echo status($status)."<BR>\n";

	return $status;
}

function create_dirs($dirs) {
	$status = true;

	foreach ($dirs as $val) {
		echo "Creating directory: [$val] ... ";

		if (!file_exists($val)) {
			$res = @mkdir($val, 0777);
			$status &= $res;

			echo status($res);
		} else 
			echo "[Already exists]";

		echo "<BR>\n"; flush();
	}

	return $status;
}

function create_files($files_to_create) {
	if (is_array($files_to_create)) {
		foreach($files_to_create as $file=>$content) {
			if ($fd = @fopen($file,"w")) {
				@fwrite($fd, $content);
				@fclose($fd);
			}
			else
				return false;
		}
	}
	return true;
}

function change_config($params) {
	$current_directory = str_replace("\\", "/", realpath("."));
	$allfile = "";

	// Write data to config.php
	if (!($fp = fopen("config.php", "r+")))
		return false;

	while (!feof($fp)) {
		$buffer = fgets($fp, 4096);

		if (ereg('^\$sql_host *=', $buffer))
			$buffer = ereg_replace('=.*;', "='".$params["mysqlhost"]."';", $buffer);

		if (ereg('^\$sql_user *=', $buffer))
			$buffer = ereg_replace('=.*;', "='".$params["mysqluser"]."';", $buffer);

		if (ereg('^\$sql_db *=', $buffer))
			$buffer = ereg_replace('=.*;', "='".$params["mysqlbase"]."';", $buffer);

		if (ereg('^\$sql_password *=', $buffer))
			$buffer = ereg_replace('=.*;', "='".$params["mysqlpass"]."';", $buffer);

		if (ereg('^\$xcart_http_host *=', $buffer))
			$buffer = ereg_replace('=.*;', "=\"".$params["xcart_http_host"]."\";", $buffer);

		if (ereg('^\$xcart_https_host *=', $buffer))
			$buffer = ereg_replace('=.*;', "=\"".$params["xcart_https_host"]."\";", $buffer);

		if (ereg('^\$xcart_web_dir *=', $buffer))
			$buffer = ereg_replace('=.*;', "=\"".$params["xcart_web_dir"]."\";", $buffer);

		if (ereg('^\$reg_globals *=', $buffer))
			$buffer = ereg_replace('=.*;', "=\"".(int)!ini_get("register_globals")."\";", $buffer);

		$allfile .= $buffer;
	}

	ftruncate($fp, 0);
	rewind($fp);

	fwrite($fp, $allfile);

	fclose($fp);

	return true;
}

################################################################
#
# Modules goes here
#
################################################################

#
# start: Default module
# Shows Terms & Conditions
#

function module_default(&$params) {
	global $error, $templates_directory;
?>
<CENTER>
<? message("Thank you for choosing X-Cart.<BR>This wizard will provide you with the installation instructions and will handle most of the installation tasks for you.") ?>
<BR><BR>

<TEXTAREA name="copyright" cols=80 rows=22>
<? require "./COPYRIGHT" ?>
</TEXTAREA>

<P>
<? if (file_exists($templates_directory)) { ?>
<TABLE border=0>
<TD><input type=radio name=force_current value=1><TD><b>New installation</b></TD></TR>
<TD><input type=radio name=force_current value=4 checked></TD><TD><b>Re-install skin files</b></TD></TR>
<TR><TD colspan=2><b>Auth code: </b><INPUT type=text name=auth_code size=20><BR><FONT size=1>This is a protection from unauthorized<BR> use of installation script</FONT></TD></TR>
</TABLE>
<P>
<? } ?>
<INPUT type=checkbox name="agree"> I accept the License Agreement

<BR><BR>

</CENTER>

<BR>

<?
	return false;
}

#
# 'next' button handler. checks 'agree' button checked
#

function module_default_js_next() {
?>
	function step_next() {
		if (document.ifrm.agree.checked) {
			return true;
		} else {
			alert("Dear customer.\nIt is neccessary to agree with the License Agreement in order to use this software.\nOtherwise this software will be considered as illegal copy.");
		}
		return false;
	}
<?
}

#
# end: Default module
#

#
# start: Check_cfg module
# Get info about current php configuration
#

function module_check_cfg(&$params) {
	global $min_ver, $error;

?>
<CENTER>
<TABLE width="100%" border=0 cellspacing=0 cellpadding=2>

<TR>
 <TD width="50%">

<TABLE width="100%" border=0 cellspacing=0 cellpadding=4>

 <TR class="Clr2">
  <TD colspan=3 align=center><B>Checking results</B></TD>
 </TR>

 <TR class="Clr1">
  <TD align=center><B>Critical dependencies</B></TD>
  <TD width="1%">&nbsp;</TD>
  <TD width="1%" align=center><B>Status</B></TD>
 </TR>

<?
#
# PHP Version must be not less than $min_ver
#

	$ver = phpversion();
	$status = ($min_ver > $ver ? 0 : 1); 
	$ck_res = $status;
?>
 <TR class="Clr2">
  <TD nowrap>PHP Version (min <? echo $min_ver ?> required) ... <? echo $ver ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

<?

#
# PHP Safe mode must be Off
#

	$res = ini_get("safe_mode");
	$status = (!empty($res) ? 0 : 1);
	$ck_res &= $status;
?>
 <TR class="Clr1">
  <TD>PHP Safe mode is ... <? echo on_off(!$status) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

<?

#
# Disabled functions list ideally must be empty
#

	$res = ini_get("disable_functions");
	$status = (empty($res) ? 1 : 0);
?>
 <TR class="Clr2">
  <TD>Disabled functions list ... <? echo ($status ? "none" : $res) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

<?

#
# File uploads must be On
#

	$res = ini_get("file_uploads");
	$status = (!empty($res) ? 1 : 0);
	$ck_res &= $status;
?>
 <TR class="Clr1">
  <TD>File uploads is ... <? echo on_off($status) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

<?

#
# MySQL functions must present
#

	$status = function_exists('mysql_connect');
	$ck_res &= $status;
?>
 <TR class="Clr2">
  <TD>MySQL support is ... <? echo on_off($status) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

<?

#
# Magic Quotes Sybase must be Off
#

	$res = ini_get("magic_quotes_sybase");
	$status = (empty($res) ? 1 : 0);
	$ck_res &= $status;
?>
 <TR class="Clr1">
  <TD>Magic Quotes Sybase is ... <? echo on_off($res) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

 <TR class="Clr2">
  <TD align=center><B>Non critical dependencies</B></TD>
  <TD width="1%">&nbsp;</TD>
  <TD width="1%" align=center><B>Status</B></TD>
 </TR>

<?
	$res = ini_get("upload_max_filesize");
?>
 <TR class="Clr1">
  <TD>Maximum file size for upload is ... <? echo $res ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($res) ?></TD>
 </TR>

<?

#
# Register globals check
#

	$res = ini_get("register_globals");
	$status = (!empty($res) ? 1 : 0);
?>
 <TR class="Clr2">
  <TD>Register Globals is ... <? echo on_off($status) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

<?

#
# Magic quotes check
#

	$res = ini_get("magic_quotes_gpc");
	$status = (!empty($res) ? 1 : 0);
?>
 <TR class="Clr1">
  <TD>Magic Quotes GPC is ... <? echo on_off($res) ?></TD>
  <TD width="1%">-</TD>
  <TD width="1%" align=center><? echo status($status) ?></TD>
 </TR>

</TABLE>
</TD>

<TD valign=top>
<TABLE width="100%" border=0 cellspacing=0 cellpadding=4>

 <TR class="Clr1">
  <TD>Place description here</TD>
 </TR>

</TABLE>
</TD>
</TR>

<TR>
<TD colspan=2>
<BR><BR>
<P>
<? message("Before the installation starts, please ensure that you have properly configured file access permissions (UNIX only):") ?>
</P>

<FONT color="darkblue">
&gt; chmod 777 .<BR>
&gt; chmod 666 config.php<BR>
&gt; chmod 755 admin/spam.sh<BR>
&gt; chmod 755 payment/*.pl<BR>
</FONT>
</TD>
</TR>

</TABLE>

<? if ($ck_res) { ?><BR><? message("Push the \"Next\" button below to continue"); } ?>

</CENTER>

<BR>
<?
	$error = !$ck_res;
	return false;
}

#
# end: Check_cfg module
#

#
# start: Cfg_install_db module
# Get mysql server info and check it before installing db
#

function module_cfg_install_db(&$params) {
	global $HTTP_SERVER_VARS, $error, $schemes_repository;

	if (empty($params)) {
		$mysqlhost = "localhost";
		$mysqluser = "";
		$mysqlpass = "";
		$mysqlbase = "xcart";
?>
<CENTER>
<P>
 <B><FONT color="darkgreen">The Installation Wizard needs to know your web server details and MySQL database information:</FONT></B>
</P>

<TABLE width="100%" border=0 cellpadding=4>

 <TR class="Clr2">
  <TD width="70%"><B>Server host name</B><BR>Host name of your server (i.e. www.mywebstore.com)</TD>
  <TD><INPUT type="text" name="params[xcart_http_host]" size=30 value="<? echo $HTTP_SERVER_VARS["HTTP_HOST"]; ?>"></TD>
 </TR>

 <TR class="Clr1">
  <TD><B>Secure server host name</B><BR>Host name of your secure (HTTPS) server (i.e. secure.mywebstore.com)</TD>
  <TD><INPUT type="text" name="params[xcart_https_host]" size=30 value="<? echo $HTTP_SERVER_VARS["HTTP_HOST"]; ?>"></TD>
 </TR>

 <TR class="Clr2">
  <TD><B>X-Cart web directory</B><BR>Web directory where X-Cart files is located (i.e. /xcart)</TD>
  <TD><INPUT type="text" name="params[xcart_web_dir]" size=30 value="<? echo ereg_replace("/install(\.php)*", "", $HTTP_SERVER_VARS["PHP_SELF"]); ?>"></TD>
 </TR>

 <TR class="Clr1">
  <TD><B>MySQL host name</B><BR>Host name of MySQL server. It can be host name or IP address</TD>
  <TD><INPUT type="text" name="params[mysqlhost]" size=30 value="<? echo $mysqlhost; ?>"></TD>
 </TR>

 <TR class="Clr2">
  <TD><B>MySQL user name</B><BR>The name of the MySQL user</TD>
  <TD><INPUT name="params[mysqluser]" size=30 type=text value="<? echo $mysqluser; ?>"></TD>
 </TR>

 <TR class="Clr1">
  <TD><B>MySQL database name</B><BR>The name of the database you connect to</TD>
  <TD><INPUT name="params[mysqlbase]" size=30 type=text value="<? echo $mysqlbase; ?>"></TD>
 </TR>

 <TR class="Clr2">
  <TD><B>MySQL password</B><BR>Which password to use for MySQL</TD>
  <TD><INPUT name="params[mysqlpass]" size=30 type=text value="<? echo $mysqlpass; ?>"></TD>
 </TR>

</TABLE>

<BR><? message("Push the \"Next\" button below to continue") ?>

</CENTER>

<BR>
<?
		return true;
	} else {
#
# Now trying to check if there is already database named $params[mysqlbase]
#
		$ck_res = 1;

		$mylink = @mysql_connect($params["mysqlhost"], $params["mysqluser"], $params["mysqlpass"]);
		if (!$mylink)
			$ck_res &= fatal_error("Can't connect to the MySQL server. Press 'BACK' button and check database info again");
		else if (!@mysql_select_db($params["mysqlbase"]))
			$ck_res &= fatal_error("Installer couldn't find database \"".$params["mysqlbase"]."\". You should ask your system administrator to create one or choose another name");
		else if (!is_writable("config.php"))
			$ck_res &= fatal_error("Cannot open file \"config.php\" for writing. You should set UNIX permissions for file \"config.php\" to 0666");
		else {
			$mystring = "";
			$first = true;

			$res = @mysql_list_tables($params["mysqlbase"]);

			while ($row = @mysql_fetch_row($res)) {
				$ctable = $row[0];
				if ($ctable == "xcart_products")
					warning_error("Installation Wizard has found existing X-Cart tables in your database. If you continue, they will be deleted.");
			}

			@mysql_close ($mylink);
		}
?>

<CENTER>
<TABLE width="100%" border=0 cellpadding=4>

 <TR class="Clr2">
  <TD width="70%"><B>Server host name</B><BR>Host name of your server (i.e. www.mywebstore.com)</TD>
  <TD><? echo $params["xcart_http_host"] ?></TD>
 </TR>

 <TR class="Clr1">
  <TD><B>Secure server host name</B><BR>Host name of your secure (HTTPS) server (i.e. secure.mywebstore.com)</TD>
  <TD><? echo $params["xcart_https_host"] ?></TD>
 </TR>

 <TR class="Clr2">
  <TD><B>X-Cart web directory</B><BR>Web directory where X-Cart files is located (i.e. /xcart)</TD>
  <TD><? echo $params["xcart_web_dir"] ?></TD>
 </TR>

 <TR class="Clr1">
  <TD><B>MySQL host name</B><BR>Host name of MySQL server. It can be host name or IP address</TD>
  <TD><? echo $params["mysqlhost"] ?></TD>
 </TR>

 <TR class="Clr2">
  <TD><B>MySQL user name</B><BR>The name of the MySQL user</TD>
  <TD><? echo $params["mysqluser"] ?></TD>
 </TR>

 <TR class="Clr1">
  <TD><B>MySQL database name</B><BR>The name of the database you connect to</TD>
  <TD><? echo $params["mysqlbase"] ?></TD>
 </TR>

 <TR class="Clr2">
  <TD><B>MySQL password</B><BR>Which password to use for MySQL</TD>
  <TD><? echo $params["mysqlpass"] ?></TD>
 </TR>
 
 <TR class="Clr1">
  <TD><B>States table</B><BR>States of the country where the shop is located</TD>
  <TD>
   <SELECT name="params[states]">
    <OPTION value=US>USA</OPTION>
    <OPTION value=CA>Canada</OPTION>
    <OPTION value=UK>United Kingdom</OPTION>
	<OPTION value=US-CA>USA &amp; Canada</OPTION>
	<OPTION value=US-CA-UK>USA, Canada &amp; UK</OPTION>
    <OPTION value="">No states</OPTION>
   </SELECT>
  </TD>
 </TR>

 <TR class="Clr2">
  <TD><B>Sample categories/products</B><BR>Would you like to setup sample categories and products?</TD>
  <TD>
   <SELECT name="params[demo]">
    <OPTION value=1>Yes</OPTION>
    <OPTION value=0>No</OPTION>
   </SELECT>
  </TD>
 </TR>

</TABLE>

<? if ($ck_res) { ?><BR><? message("Push the \"Next\" button below to begin the installation"); } ?>

</CENTER>

<BR>
<?
		$error = !$ck_res;
		return false;
	}
}

function module_cfg_install_db_js_next() {
?>
	function step_next() {
		for (var i = 0; i < document.ifrm.elements.length; i++) {
			if (document.ifrm.elements[i].name.search("mysqlhost") != -1) {
				if (document.ifrm.elements[i].value == "") {
					alert ("You must enter MySQL host name");
					return false;
				}
			}

			if (document.ifrm.elements[i].name.search("mysqluser") != -1) {
				if (document.ifrm.elements[i].value == "") {
					alert ("You must enter MySQL user name");
					return false;
				}
			}

			if (document.ifrm.elements[i].name.search("mysqlbase") != -1) {
				if (document.ifrm.elements[i].value == "") {
					alert ("You must enter MySQL database name");
					return false;
				}
			}
		}
		return true;
	}
<?
}

#
# end: Cfg_install_db module
#

#
# start: Install_db module
#

function module_install_db(&$params) {
	global $error;
?>
</TD>
</TR>
</TABLE>

<SCRIPT language="javascript">
	loaded = false;

	function refresh() {
		window.scroll(0, 100000);

		if (loaded == false)
			setTimeout('refresh()', 1000);
	}

	setTimeout('refresh()', 1000);
</SCRIPT>

<?
	$ck_res = 1;

	$mylink = @mysql_connect($params["mysqlhost"], $params["mysqluser"], $params["mysqlpass"]);
	if (!$mylink) 
		$ck_res &= fatal_error("Cannot connect to MySQL server. This is unexpected error, so please start installation again.");
	else if (!@mysql_select_db($params["mysqlbase"]))
		$ck_res &= fatal_error("Couldn't find database \"".$params["mysqlbase"]."\". This is unexpected error, so please start installation again.");
	else if (!is_writable("config.php"))
		$ck_res &= fatal_error("Cannot open file \"config.php\" for writing. This is unexpected error, so please start installation again.");
	else {
		echo "<B>Creating tables...</B><BR>\n";

		$ck_res &= query_upload("sql/dbclear.sql");
		$ck_res &= query_upload("sql/xcart_tables.sql");

		echo "<BR><B>Importing data...</B><BR>\n"; flush();

		$ck_res &= query_upload("sql/xcart_data.sql");

#
# Importing states
#
		if (!empty($params["states"])) {
			echo "<BR><B>Importing states...</B><BR>\n"; flush();
			$country_codes = explode("-",$params["states"]);
			foreach($country_codes as $country_code)
				$ck_res &= query_upload("sql/states_".$country_code.".sql");
		}

#
# Importing sample data
#
		if ($params["demo"] == 1) {
			echo "<BR><B>Setting up sample categories and products...</B><BR>\n"; flush();

			$ck_res &= query_upload("sql/xcart_demo.sql");
		}

#
# Updating config.php file
#
		echo "<BR><B>Updating config.php file... </B><BR>\n"; flush();

		$res = change_config($params);
		echo status($res)."<BR>\n";

		if (!$res) 
			fatal_error("Can't open file \"config.php\" for reading\\writing");

		$ck_res &= $res;

#
		if (!$ck_res)
			fatal_error("Fatal error occured while installing database.<BR>Please, check all again and restart installation. Maybe you have not enought rights to that database");
	}
?>

<TABLE class="TableTop" width="100%" border=0 cellspacing=0 cellpadding=0>

<TR>
<TD>

<CENTER>
<? if ($ck_res) { ?><BR><? message("Push the \"Next\" button below to continue"); } ?>
</CENTER>

<BR>

<SCRIPT language="javascript">
	loaded = true;
</SCRIPT>

<?
	$error = !$ck_res;
	return false;
}

#
# end: Install_db module
#

#
# start: Cfg_install_dirs module
# Get color/layout settings
#

function module_cfg_install_dirs(&$params) {
	global $error, $schemes_repository;
?>
<CENTER>
<P>
 <B><FONT color="darkgreen">Select color/layout:</FONT></B>
</P>

<TABLE width="100%" border=0 cellpadding=4>
 <TR class="Clr2">
  <TD><B>Layout</B><BR>Select shop layout</TD>
  <TD>
   <SELECT name="params[layout]">
    <OPTION value="">3-columns (default)</OPTION>
<?
if ($dir = @opendir($schemes_repository."/templates")) {
    while (($file = readdir($dir)) !== false)
		if ($file!="." && $file!="..")
      		echo "<OPTION value=\"$file\">".str_replace("_"," ",$file)."</OPTION><BR>\n";
    closedir($dir);
  }
?>
   </SELECT>
  </TD>
 </TR>

 <TR class="Clr2">
  <TD><B>Color scheme</B><BR>Select color scheme</TD>
  <TD>
   <SELECT name="params[color]">
    <OPTION value="">orange (default)</OPTION>
<?
if ($dir = @opendir($schemes_repository."/colors")) {
    while (($file = readdir($dir)) !== false)
		if ($file!="." && $file!="..")
      		echo "<OPTION value=\"$file\">$file</OPTION><BR>\n";
    closedir($dir);
  }
?>
   </SELECT>
  </TD>
 </TR>
 <TR class="Clr2">
  <TD><B>Dingbats</B><BR>Select dingbats set</TD>
  <TD>
   <SELECT name="params[dingbats]">
    <OPTION value="">default</OPTION>
<?
if ($dir = @opendir($schemes_repository."/dingbats")) {
    while (($file = readdir($dir)) !== false)
		if ($file!="." && $file!="..")
      		echo "<OPTION value=\"$file\">$file</OPTION><BR>\n";
    closedir($dir);
  }
?>
   </SELECT>
  </TD>
 </TR>
</TABLE>
<P>
<TABLE border=1>
<TR><TH width=150 bgcolor=#DDDDDD>Color scheme</TH><TH bgcolor=#DDDDDD>Recommended dingbat sets</TH></TR>
<TR><TD>orange (default)</TD><TD>default, colortrans, redemboss, blackback, color</TD></TR>
<TR><TD>blue</TD><TD>colortrans, blackback, color, blue<font color=red>!</font></TD></TR>
<TR><TD>green</TD><TD>colortrans, greenround<font color=red>!</font>, blackback, color</TD></TR>
<TR><TD>grey</TD><TD>default, colortrans, redemboss, blackback, color</TD></TR>
<TR><TD>red</TD><TD>colortrans, redemboss, blackback, color</TD></TR>
<TR><TD>yellow</TD><TD>default, colortrans, greenround, redemboss, color, blue</TD></TR>
</TABLE>
<BR><? message("Push the \"Next\" button below to begin the installation");?><BR><BR>
<?
}
#
# end: Install_dirs module
#

#
# start: Install_dirs module
#

function module_install_dirs(&$params) {
	global $directories_to_create, $files_to_create, $templates_repository, $schemes_repository, $error;

?>
</TD>
</TR>
</TABLE>

<SCRIPT language="javascript">
	loaded = false;

	function refresh() {
		window.scroll(0, 100000);

		if (loaded == false)
			setTimeout('refresh()', 1000);
	}

	setTimeout('refresh()', 1000);
</SCRIPT>

<?
	$ck_res = 1;

#	echo "<BR><B>Preparing PGP directory... ";

	echo "<BR><B>Creating directories...</B><BR>\n";

	$ck_res &= create_dirs($directories_to_create);

	$ck_res &= create_files($files_to_create);

	echo "<BR><B>Copying templates...</B><BR>\n";

	$ck_res &= copy_files($templates_repository, "", $templates_repository);

	if(!empty($params["layout"])) {
		echo "<BR><B>Creating layout...</B><BR>\n";
		$ck_res &= copy_files($schemes_repository."/templates/".$params["layout"], "", $schemes_repository."/templates/".$params["layout"]);
	}

	if(!empty($params["color"])) {
		echo "<BR><B>Copying color scheme files...</B><BR>\n";
		$ck_res &= copy_files($schemes_repository."/colors/".$params["color"], "", $schemes_repository."/colors/".$params["color"]);
	}

	if(!empty($params["dingbats"])) {
		echo "<BR><B>Copying dingbats files...</B><BR>\n";
		$ck_res &= copy_files($schemes_repository."/dingbats/".$params["dingbats"], "", $schemes_repository."/dingbats/".$params["dingbats"]);
	}

	if (!$ck_res) {
		fatal_error("Fatal error occured while creating directories. Please check permissions and try again.");
	} else {
?>
<A name=preview>
<CENTER>
<H3>Color/layout preview (<a href="javascript: preview.location.reload()">click to refresh</a>)</H3>
<IFRAME src="customer/home.php" width="80%" height="400" scrolling="auto" frameborder="1" align=center name=preview>
</IFRAME>
<BR>
<BR>
</CENTER>
<?
	}
?>

<TABLE class="TableTop" width="100%" border=0 cellspacing=0 cellpadding=0>

<TR>
<TD>

<CENTER>
<? if ($ck_res) { ?><BR><? message("Push the \"Next\" button below to continue"); } ?>
</CENTER>

<INPUT type=hidden name="ck_res" value="<? echo (int)$ck_res ?>">

<BR>

<SCRIPT language="javascript">
	loaded = true;
</SCRIPT>

<?
	$error = !$ck_res;
	return false;
}

#
# end: Install_dirs module
#

#
# start: Install_done module
#

function module_install_done(&$params) {
	global $error, $installation_auth_code, $templates_repository;
?>
<CENTER>
<H3><? message("Installation complete.") ?></H3>
</CENTER>

Auth code (for accessing install.php in future): <B><? echo $installation_auth_code ?></B>
<P>
Before you proceed to using X-Cart, you must <P>
1) Remove install.php file<BR>
OR<BR>
2) Modify install.php by setting <b>$installation_auth_code</b> variable if you will be using it in the future. This will prevent from unauthorized access.
<P>
After that you must make sure that you setup secure file permissions:<BR>
chmod 644 config.php<BR>
chmod 755 .<BR>
<BR>
<? $xcart_package=(file_exists($templates_repository."/admin/home.tpl")?"PRO":"GOLD"); ?>
X-Cart has been successfully installed at the following URLs:<BR>
<OL>
<LI><U><A href="customer/home.php"><b>CUSTOMER FRONT-END</b></A></U></LI>
<? if ($xcart_package=="PRO") { ?>
<P>
<LI><U><A href="admin/home.php"><b>ADMINISTRATOR BACKOFFICE</b></A></U><BR></LI>
Username: admin<BR>
Password: admin<BR>
<? } ?>
<P>
<LI><U><A href="provider/home.php"><b><? echo ($xcart_package=="PRO"?"BACKOFFICE FOR PRODUCT PROVIDERS":"ADMINISTRATOR BACKOFFICE") ?></b></A></U><BR></LI>
Username: <? echo ($xcart_package=="PRO"?"provider":"master") ?><BR>
Password: <? echo ($xcart_package=="PRO"?"provider":"master") ?><BR>
<? if ($xcart_package=="PRO") { ?>
<BR>
Username: root<BR>
Password: root<BR>
<? } ?>
</OL>
<?
	return false;
}

#
# end: Install_done module
#

?>
