<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: display_stats.php,v 1.11 2002/12/09 14:49:33 svowl Exp $
#
# This module generates lists to be displayed in advanced statistics 
#

#
# Navigation code
#
$objects_per_page = 20;

$last_visited = "last_visited+'".$config["General"]["timezone_offset"]."'";

$res = func_query_first("SELECT COUNT(*) FROM $sql_tbl[referers] WHERE ($last_visited>='$start_date' AND $last_visited<='$end_date')");
$total_nav_pages = ceil($res["COUNT(*)"]/$objects_per_page)+1;

require "../include/navigation.php";



include "../include/categories.php";
# List of category views

$query = "SELECT category FROM $sql_tbl[categories] WHERE categoryid = '$cat'";
$res = func_query_first($query);
$cat_name = addslashes($res['category']);
$query = "SELECT c.categoryid, c.category, COUNT(ss.id) as views_stats FROM $sql_tbl[categories] as c, $sql_tbl[stats_shop] as ss WHERE ss.action='C' AND ss.id=c.categoryid AND c.category LIKE '$cat_name%' AND $date_condition GROUP BY c.categoryid ORDER BY views_stats DESC";
$category_viewes = func_query($query);
$max_category_viewes = 0;
if (is_array($category_viewes))
	foreach($category_viewes as $k=>$v) {
		$max_category_viewes = max($max_category_viewes, $v[views_stats]);
	}


# Select only categories from the current hierarchy level
$tmp = array();
if (is_array($category_viewes))
foreach($category_viewes as $key => $value)
	if (!strstr(substr($value['category'],strlen($cat_name)+1),"/"))  array_push($tmp, $value);
$category_viewes = $tmp;

# Make navigation bar

if (empty($cat_name)) $tmp = array();
	else $tmp = split("/", $cat_name);
$nav_bar = array();
$cur_cat_name = "";
foreach($tmp as $value){
	$cur_cat_name .= (empty($cur_cat_name)?"$value":"/$value");
	$query = "SELECT categoryid FROM $sql_tbl[categories] WHERE category = '$cur_cat_name'";
	$res = func_query_first($query);
	array_push($nav_bar, array("cat_name"=>stripslashes($value), "cat"=>$res['categoryid']));	
}

if ($cat_name != ""){
# List of product views
	$product_viewes = func_query("SELECT p.productid, p.product, COUNT(ss.id) as views_stats FROM $sql_tbl[products] as p, $sql_tbl[categories] as c, $sql_tbl[stats_shop] as ss WHERE (p.categoryid = c.categoryid) AND (c.category LIKE '$cat_name%') AND ss.id=p.productid AND ss.action='V' AND $date_condition GROUP BY p.productid ORDER BY views_stats DESC");

	$max_product_viewes = 0;
	if (is_array($product_viewes))
		foreach($product_viewes as $k=>$v) {
			$max_product_viewes = max($max_product_viewes, $v[views_stats]);
		}

# List of product sales 

	$product_sales = func_query("SELECT p.productid, p.product, COUNT(ss.id) as sales_stats FROM $sql_tbl[products] as p, $sql_tbl[categories] as c, $sql_tbl[stats_shop] as ss WHERE (p.categoryid = c.categoryid) AND (c.category LIKE '$cat_name%') AND ss.id=p.productid AND ss.action='S' AND $date_condition GROUP BY p.productid ORDER BY sales_stats DESC");

	$max_product_sales = 0;
	if (is_array($product_sales))
		foreach($product_sales as $k=>$v) {
			$max_product_sales = max($max_product_sales, $v[sales_stats]);
		}

# List of deleted from the cart products 

	$product_deleted = func_query("SELECT p.productid, p.product, COUNT(id) as del_stats FROM $sql_tbl[products] as p, $sql_tbl[categories] as c, $sql_tbl[stats_shop] as ss WHERE (p.categoryid=c.categoryid) AND (c.category LIKE '$cat_name%') AND ss.id=p.productid AND ss.action='D' AND $date_condition GROUP BY p.productid ORDER BY del_stats DESC");

	$max_product_deleted = 0;
	if (is_array($product_deleted))
		foreach($product_deleted as $k=>$v) {
			$max_product_deleted = max($max_product_deleted, $v[del_stats]);
		}

}

#
# Prepare statistics on referers
#

	$referers_array = func_query("SELECT * FROM $sql_tbl[referers] ORDER BY visits DESC LIMIT $first_page, $objects_per_page");
	$res = func_query_first("SELECT MAX(visits) FROM $sql_tbl[referers]");
	$max_visits = $res["MAX(visits)"];





$smarty->assign("category_viewes", $category_viewes);
$smarty->assign("product_viewes", $product_viewes);
$smarty->assign("product_sales", $product_sales);
$smarty->assign("product_deleted", $product_deleted);
$smarty->assign("referers_array", $referers_array);
$smarty->assign("max_category_viewes", $max_category_viewes);
$smarty->assign("max_product_viewes", $max_product_viewes);
$smarty->assign("max_product_sales", $max_product_sales);
$smarty->assign("max_product_deleted", $max_product_deleted);
$smarty->assign("max_visits", $max_visits);
$smarty->assign("cat_name", $cat_name);
$smarty->assign("nav_bar", $nav_bar);
$smarty->assign("navigation_script","statistics.php?cat={$cat}");

?>
