<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE Ruslan R. Fazliev TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE Ruslan R. Fazliev TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_2checkoutcom.php,v 1.11.2.3 2003/03/25 13:46:35 svowl Exp $
#

# Error reporting level:
# default: E_ALL ^ E_NOTICE
#
$cc_2checkout_defined = 1;

error_reporting (E_ALL ^ E_NOTICE);
$secureid=$x_invoice_num;
if ($x_invoice_num) {
	$HTTP_POST_VARS["XCARTSESSID"] = $x_invoice_num;
	include "../include/payment_method.php";

	session_register("secure_oid");
}

# this line protect us from empty orders
$bill_error=true; 

#
# Finish transaction
#
if ($x_response_code && $x_response_code!=1)
{
	func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
    relocate("/customer/error_message.php?error_ccprocessor_error");
}
elseif($x_response_code && $secureid && !$secure_oid)
{
	func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
    relocate("/customer/error_message.php?error_ccprocessor_baddata");
}
elseif($x_response_code && $secureid)
{
	func_change_order_status($secure_oid, "P");
	$_orderids = func_get_urlencoded_orderids ($secure_oid);
	session_unregister("secure_oid");

#
# Remove all from cart
#
	$cart="";

	relocate("/customer/cart.php?mode=order_message&orderids=$_orderids");
}

$checkout_login = $module_params["param01"];
	 
?>
<html>
<body onLoad="document.process.submit();">
  <form action="https://www.2checkout.com/cgi-bin/Abuyers/purchase.2c" method=POST name=process>
	 <input type=hidden name=x_login value="<?echo $checkout_login;?>">
	 <input type=hidden name=x_amount value="<?echo $cart["total_cost"];?>">
	 <input type=hidden name=x_Card_Num value="<?echo $userinfo["card_number"];?>">
	 <input type=hidden name=x_Exp_Date value="<?echo $userinfo["card_expire"];?>">
	 <input type=hidden name=x_invoice_num value="<?echo session_id();?>">
	 <input type=hidden name=x_First_Name value="<?echo addslashes($userinfo["firstname"]);?>">
	 <input type=hidden name=x_Last_Name value="<?echo addslashes($userinfo["lastname"]);?>">
	 <input type=hidden name=x_Phone value="<?echo $userinfo["phone"];?>">
	 <input type=hidden name=x_Email value="<?echo $userinfo["email"];?>">
	 <input type=hidden name=x_Address value="<?echo addslashes($userinfo["b_address"]);?>">
	 <input type=hidden name=x_City value="<?echo $userinfo["b_city"];?>">
	 <input type=hidden name=x_State value="<?echo ($userinfo["b_state"]?$userinfo["b_state"]:"n/a");?>">
	 <input type=hidden name=x_Zip value="<?echo $userinfo["b_zipcode"];?>">
	 <input type=hidden name=x_Country value="<?echo $userinfo["b_country"];?>">
	 <input type=hidden name=secureid value="<?echo $XCARTSESSID;?>">
	 <input type=hidden name=payment_method value="<?echo $payment_method;?>">
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>2checkout.com</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<? exit; 
function relocate($url){
?><html><head><body><script>
	document.location = "<?=$GLOBALS["http_location"].$url?>"
</script></body></html>
<?
}
?>
