<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_chargeit.php,v 1.5.2.1 2003/04/07 06:53:14 svowl Exp $
#

$accountid = $module_params ["param01"];
$testmode = $module_params ["param02"];

if ($testmode == "test") {
	$url = "https://www.gochargeit.com/cgi-bin/remotedemo.cgi";
} else {
	$url = "https://www.gochargeit.com/cgi-bin/remote.cgi";
}


# this line protect us from empty orders
$bill_error=true; 

#
# Finish transaction
#

if ($REQUEST_METHOD == "POST" and  $HTTP_POST_VARS ["POST2"])
{
	$response = $HTTP_POST_VARS ["POST2"];

	include("../smarty.php");
	include("../config.php");

	session_id($POST1);
	session_register("cart");
	session_register("order_secureid");
	session_register("secure_oid");
	session_register("userinfo");

    if (!defined("GET_LANGUAGE")) {
        $current_area = "C";
        include "../include/get_language.php";
    }
						
	if($response == md5($POST1+0xCAED))
	{
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);
		session_unregister("secure_oid");

		#
		# Remove all from cart
		#
		$cart="";
		header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids");

		exit;
	}
	elseif($response == md5($POST1+0xEFC3))
	{
		func_change_order_status($secure_oid, "F");
		header("Location: ../customer/error_message.php?error=error_ccprocessor_error&bill_message=".urlencode("Reason: Declined<br>"));
		session_register("secure_oid");
		exit;
	}
	else
	{
		func_change_order_status($secure_oid, "F");
		header("Location: ../customer/error_message.php?error=error_ccprocessor_error&bill_message=".urlencode("Reason: Processing Error<br>"));
		session_register("secure_oid");
		exit;
	}	
}
else
{
	$oid = func_get_urlencoded_orderids($secure_oid);
}

switch($userinfo["card_type"])
{ case "VISA":          $ctype="VISA";break;
  case "MC":            $ctype="MASTERCARD";break;
  case "AMEX":          $ctype="AMEX";break;
}
if($userinfo["card_name"] != "")$ctype=strtoupper($userinfo["card_name"]);

?>
<html>
<body onLoad="document.process.submit();">
  <form action="<? echo $url; ?>" method=POST name=process>
  	<INPUT type=hidden name=F_CCNAME value="<? echo "$userinfo[firstname] $userinfo[lastname]"; ?>">
	<INPUT type=hidden name=F_CCADDR value="<? echo $userinfo[b_address]; ?>">
	<INPUT type=hidden name=F_CCCITY value="<? echo $userinfo[b_city]; ?>">
	<INPUT type=hidden name=F_CCSTATE value="<? echo $userinfo[b_state]; ?>">
	<INPUT type=hidden name=F_CCZIP value="<? echo $userinfo[b_zipcode]; ?>">
	<INPUT type=hidden name=F_DESC value="X-Cart products">
	<INPUT type=hidden name=CARD value="<? echo $userinfo[card_number]; ?>">
	<INPUT type=hidden name=EXPIR value="<? echo $userinfo["card_expire"]; ?>">
	<INPUT type=hidden name=F_CCTYPE value="<? echo $ctype; ?>">
	<INPUT type=hidden name=AMOUNT value="<? echo $cart["total_cost"]; ?>">
	<INPUT type=hidden name=SID value="<? echo $oid; ?>">
	<INPUT type=hidden name=USERDEF4  value="<? echo session_id(); ?>">
	<INPUT type=hidden name=USERDEF5  value="<? echo $xcart_http_host.$xcart_web_dir; ?>">
  	<INPUT type=hidden name=TOTALLYREMOTE value=1>
	<INPUT type=hidden name=REMOTEURL value="<? echo "http://".$xcart_http_host.$xcart_web_dir."/payment/cc_chargeit_return.php"; ?>">
  	<INPUT type=hidden name=RETURNURL value="<? echo "http://www.gochargeit.com/".$accountid."/"; ?>chargelink.htm?returning">
  	<INPUT type=hidden name=ROUTE value="<? echo $accountid;?>">
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>GoChargeIt</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<?  exit; ?>


