<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_dpil.php,v 1.1 2002/12/18 11:35:02 sdg Exp $
#

set_time_limit(100);

#
# Based on cc_plugnpaycom.php
#

$pp_id   = $module_params["param01"];
$pp_pass = $module_params["param02"];
$pp_tran = $module_params["param03"];
$pp_test = $module_params["param04"];

$post = ""; $bill_output = "";
$post[] = "DPIAccountNum=".$pp_id;
$post[] = "password=".$pp_pass;
$post[] = "transactionCode=".$pp_tran;
$post[] = "orderNum=".$login;
$post[] = "customerNum=".func_get_urlencoded_orderids($secure_oid);
$post[] = "transactionAmount=".$cart["total_cost"];
$post[] = "cardHolderZip=".$userinfo["b_zipcode"];
$post[] = "cardHolderName=".$userinfo["firstname"]." ".$userinfo["lastname"];
$post[] = "cardHolderAddress=".$userinfo["b_address"];
$post[] = "cardHolderCity=".$userinfo["b_city"];
$post[] = "cardHolderState=".$userinfo["b_state"];
$post[] = "cardHolderPhone=".$userinfo["phone"];
$post[] = "cardHolderEmail=".$userinfo["email"];
$post[] = "eCommerce=Y";
$post[] = "testTransaction=".(($pp_test=="live")? "N" : "Y");
$post[] = "cardAccountNum=".$userinfo["card_number"];
$post[] = "expirationDate=".$userinfo["card_expire"];
$post[] = "CVV2=".$userinfo["card_cvv2"];

foreach($post as $k => $v) { list($a,$b)=split("=",$v); $post[$k] = $a."=".urlencode($b);}
exec ("./dpil.pl ".join("\&",$post)." 2>&1", $bill_output);
# return line like "A1|12345609|sale||1|4111111111111111|0203|5999|021217|072927|TO|9|sdg|||L|||||||||"
# 11th value is Transaction Status:  A two-digit value, which indicates the result of the authorization request. Used to determine if the card was authorized or declined.
$return = split("\|",$bill_output[0]);
$TSC = $return[10];

if((($TSC == "TO") || ($TSC == "00")) && ($return[11] == func_get_urlencoded_orderids($secure_oid)))
	$error_="1,Approved ".(($TSC == "TO")? " (TEST)" : "");
else
{

$errarr=array(
"01" => "Refer to issuer",
"02" => "Refer to issuer-Special condition",
"03" => "Invalid merchant ID",
"04" => "Pick up card",
"05" => "Do not honor",
"06" => "General error",
"06" => "General error",
"07" => "Pick up card-Special condition",
"13" => "Invalid Amount",
"14" => "Invalid card number",
"15" => "No such issuer",
"19" => "Re-enter transaction",
"21" => "Unable to back out transaction",
"28" => "File is temporarily unavailable",
"39" => "No credit account",
"41" => "Pickup card-Lost",
"43" => "Pickup card-Stolen",
"51" => "Insufficient funds",
"54" => "Expired card",
"57" => "Trans. Not permitted-Card",
"61" => "Exceeds withdrawal limit",
"62" => "Invalid service code, restricted",
"65" => "Activity limit exceeded",
"76" => "Unable to locate, no match",
"77" => "Inconsistent data, rev. or repeat",
"78" => "No account",
"80" => "Invalid date",
"85" => "No reason to decline",
"91" => "Issuer or switch is unavailable",
"93" => "Violation, cannot complete",
"96" => "System malfunction",
"98" => "No matching transaction to Void",
"L0" => "An error occurred - Contact DPI Account Executive.",
"L1" => "Invalid or missing account number",
"L2" => "The Password is missing or invalid",
"L3" => "Expiration Date is not formatted correctly",
"L4" => "Reference number not found",
"L6" => "The Order Number is required but missing",
"L7" => "Transaction Code must be either 30 for Authorization Only, or 32 for Authorize and Settle",
"L8" => "The Network Connection timed out due to a communication error.",
"L14" => "Invalid Card Number",
"S5" => "Settlement Request submitted for transaction that was previously settled.",
"S6" => "Settlement Request was submitted for a transaction that was not authorized.",
"S7" => "Settlement Request was submitted for a transaction that was declined.",
"V6" => "Transaction Type must equal 40 (Settlement) or 32 (Authorize & Settle)",
"V7" => "Void Request was submitted for a transaction that was declined.",
"V8" => "Void Request was submitted for a transaction that was previously voided.",
"V9" => "Void Request was submitted for a transaction that was already posted.  Must submit a Credit Request."
);
	$error_="2,".$errarr[$TSC];
}

list($bill_errorcode,$bill_message) = explode(",", $error_, 2);

if ($bill_errorcode == 2)
	$bill_error="error_ccprocessor_error";
elseif ($bill_errorcode != 1)
    $bill_error="error_ccprocessor_unavailable";

$bill_message="<h3><FONT COLOR=#000080>Reason:</FONT> ".$bill_message."</h3><br>";

?>
