<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_gestpay.php,v 1.8 2002/12/10 08:57:10 sdg Exp $
#

$cc_gestpay_debug = false;

if ($mode=="import_passwords") {
	require "../smarty.php";
	require "../config.php";
	require "../admin/auth.php";
	require "../include/security.php";

	function func_import_gestpay_passwords ($file, $name, $type) {
		global $file_temp_dir, $sql_tbl;
	
		move_uploaded_file ($file, "$file_temp_dir/$name");
		$file = "$file_temp_dir/$name";

		if ($fp = fopen ($file, "rt")) {
			
			while (!feof ($fp)) {
				$pass = fgets ($fp, 33);
				$pass = trim($pass);
				if ($pass) {
					db_query ("INSERT INTO $sql_tbl[cc_gestpay_data] (value, type) VALUES ('$pass', '$type')");
				}
			}
			
			fclose ($fp);
		}

		unlink ($file);
	}

	if ($delete_all == "Y") {
		db_query ("DELETE FROM $sql_tbl[cc_gestpay_data]");
	}

	if ($ric) {
		func_import_gestpay_passwords ($ric, $ric_name, "C");
	}
	if ($ris) {
		func_import_gestpay_passwords ($ris, $ris_name, "S");
	}

	header ("Location: $HTTP_REFERER&imported");
	exit;
}

# this line protect us from empty orders
$bill_error=true; 

#
# Finish transaction
#

if ($REQUEST_METHOD == "GET" and $QUERY_STRING)
{
	include "../include/payment_method.php";

	if ($cc_gestpay_debug) {
		$responses = array ();
		if ($QUERY_STRING) {
			$_responses = explode ("*", $b);
			if ($_responses) {
				foreach ($_responses as $value) {
					$r = explode ("=", $value);
					$k = $r[0];
					$v = $r[sizeof($r)-1];
					$responses [$k] = $v;
				}
			}
		}
		
		$result = $responses ["PAY1_TRANSACTIONRESULT"];
		$otp = $responses ["PAY1_OTP"];
	} else {
		$result = $HTTP_GET_VARS ["a"];
		$otp = $HTTP_GET_VARS ["c"];
	}
	
	#session_id($response["b"]);
	session_register("cart");
	session_register("order_secureid");
	session_register("userinfo");
	session_register("secure_oid");

	$success = false;

	if (strcasecmp ($result, "ko") != 0) {
		
		$res = func_query_first ("SELECT * FROM $sql_tbl[cc_gestpay_data] WHERE value='$otp' AND type='S'");

		if ($res) {
			$success = true;

			db_query ("DELETE FROM $sql_tbl[cc_gestpay_data] WHERE value='$otp' AND type='S'");
		}
	}
	
	if ($success) {
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);
		session_unregister("secure_oid");

		#
		# Remove all from cart
		#
		$cart="";
		header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids");

		exit;
	}
	else
	{	
		func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
		header("Location: ../customer/error_message.php?error_ccprocessor_error");
		exit;
	}	
}

$merchant_id = $module_params ["param01"];
$currency = $module_params ["param02"];
$terminal_id = $module_params ["param03"];
if ($terminal_id < 1)
	$terminal_id = 1;

session_register("order_secureid");

#
# Fetch OTP here
#
$res = func_query_first ("SELECT * FROM $sql_tbl[cc_gestpay_data] WHERE type='C'");
$otp = $res ["value"];

#
# Delete OTP from the database
#
if ($otp) {
	db_query ("DELETE FROM $sql_tbl[cc_gestpay_data] WHERE value='$otp' AND type='C'");
}

?>
<html>
<body onLoad="document.process.submit();">
  <form action="https://ecomm.sella.it/gestpay/pagam.asp" name=process>
  	<INPUT type=hidden name=a value="<? echo $merchant_id; ?>">
<?
	# PAY1_UICCODE = 18 - ITL, 242 - EUR

	if ($cc_gestpay_debug) {
?>
	<INPUT type=hidden name=b value="PAY1_OTP=<? echo $otp; ?>*P1*PAY1_AMOUNT=<? echo round ($cart["total_cost"] * $terminal_id, 2); ?>*P1*PAY1_UICCODE=<? echo $currency; ?>*P1*PAY1_SHOPTRANSACTIONID=<? echo $order_secureid; ?>">
<?
	} else {
?>
	<INPUT type=hidden name=b value=<? echo round ($cart["total_cost"]*$terminal_id, 2) ?>>
	<INPUT type=hidden name=c value="<? echo $otp; ?>">
	<INPUT type=hidden name=d value="<? echo $order_secureid; ?>">
<?
	}
?>
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>GestPay</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<? exit; ?>
