<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_paynet.php,v 1.1 2002/12/06 15:12:25 sdg Exp $
#

set_time_limit(100);

#
# Based on cc_plugnpaycom.php
#

$pp_payid = $module_params["param01"];
$pp_auth = $module_params["param02"];
$pp_curr = $module_params["param03"];

if(!file_exists("./paynet.pl")) {
	header("Location: ../customer/error_message.php?error_ccprocessor_notfound");
	exit;
}

$post = ""; $bill_output = "";
$post[] = "type=encode";
$post[] = "ccnr=".$userinfo["card_number"];
$post[] = "ccex=".$userinfo["card_expire"];
$post[] = "ccode=".$userinfo["card_cvv2"];

foreach($post as $k => $v) { list($a,$b)=split("=",$v); $post[$k] = $a."=".urlencode($b);}
exec ("./paynet.pl ".join("\&",$post)." 2>&1", $bill_output);

$a = urldecode(trim($bill_output[0]));
preg_match("/cced=([^\&]*)/",$a,$b);
$pp_cced = $b[1];
preg_match("/errm=([^\&]*)/",$a,$b);
$error_ = $b[1];

if(!$error_)
{
	$post = ""; $bill_output = "";
	$post[] = "type=".$pp_auth; // [ auth | sale ]
	$post[] = "totam=".$cart["total_cost"];
	$post[] = "curry=".$pp_curr;
	$post[] = "argnr=".$pp_payid;
	$post[] = "utref=".func_get_urlencoded_orderids($orderids);
	$post[] = "cced=".$pp_cced;
	foreach($post as $k => $v) { list($a,$b)=split("=",$v); $post[$k] = $a."=".urlencode($b);}
	exec ("./paynet.pl ".join("\&",$post)." 2>&1", $bill_output);

	$a = urldecode(trim($bill_output[0]));
	preg_match("/[^u]tref=([^&]*)/",$a,$b);
	$pp_tref = $b[1];
	preg_match("/errm=([^&]*)/",$a,$b);
	$error_ = $b[1];
}

if($error_)$error_ = "2,".$error_;

list($bill_errorcode,$bill_message) = explode(",",$error_,2);

if ($bill_errorcode == 2)
	$bill_error="error_ccprocessor_error";
elseif ($bill_errorcode != 1)
    $bill_error="error_ccprocessor_unavailable";

$bill_message="<h3><FONT COLOR=#000080>Reason:</FONT> ".$bill_message."</h3><br>";

?>
