<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_pgw.php,v 1.2 2002/12/05 10:11:06 sdg Exp $
#

set_time_limit(100);

#
# Based on cc_plugnpaycom.php
#

$pp_merch = $module_params["param01"];
$pp_auth  = $module_params["param02"];
$pp_test  = $module_params["param03"];

if(!file_exists("./pgw.pl")) {
	header("Location: ../customer/error_message.php?error_ccprocessor_notfound");
	exit;
}

$post[] = "account_token=".($pp_test=="test"?"TEST":"").$pp_merch;
$post[] = "charge_type=".$pp_auth;
$post[] = "bill_address_one=".$userinfo["b_address"];
$post[] = "bill_city=".$userinfo["b_city"];
$post[] = "bill_company=".$userinfo["company"];
$post[] = "bill_country_code=".$userinfo["b_country"];
$post[] = "bill_customer_title=".$userinfo["title"];
$post[] = "bill_email=".$userinfo["email"];
$post[] = "bill_first_name=".$userinfo["firstname"];
$post[] = "bill_last_name=".$userinfo["lastname"];
$post[] = "bill_middle_name=";
$post[] = "bill_note=X-Cart";
$post[] = "bill_phone=".$userinfo["phone"];
$post[] = "bill_postal_code=".$userinfo["b_zipcode"];
$post[] = "bill_state_or_province=".$userinfo["b_state"];
$post[] = "card_brand=".$userinfo["card_type"];
$post[] = "charge_total=".$cart["total_cost"];
$post[] = "credit_card_number=".$userinfo["card_number"];
$post[] = "expire_month=".(0+substr($userinfo["card_expire"],0,2));
$post[] = "expire_year=".(2000+substr($userinfo["card_expire"],2,2));
$post[] = "ship_address_one=".$userinfo["s_address"];
$post[] = "ship_city=".$userinfo["s_city"];
$post[] = "ship_country_code=".$userinfo["b_country"];
$post[] = "ship_customer_title=".$userinfo["title"];
$post[] = "ship_email=".$userinfo["email"];
$post[] = "ship_first_name=".$userinfo["firstname"];
$post[] = "ship_last_name=".$userinfo["lastname"];
$post[] = "ship_middle_name=";
$post[] = "ship_note=X-Cart";
$post[] = "ship_phone=".$userinfo["phone"];
$post[] = "ship_postal_code=".$userinfo["s_zipcode"];
$post[] = "ship_state_or_province=".$userinfo["s_state"];
$post[] = "transaction_type=CREDIT_CARD";
$post[] = "version_id=PHP Plug v1.6.1";


#
# Execute perl script
#

foreach($post as $k => $v) { list($a,$b)=split("=",$v); $post[$k] = $a."=".urlencode($b);}

exec ("./pgw.pl ".join("\&",$post)." 2>&1", $bill_output);

list($bill_errorcode,$bill_message) = explode(",",$bill_output[0],2);

if ($bill_errorcode == 2)
	$bill_error="error_ccprocessor_error";
elseif ($bill_errorcode != 1)
    $bill_error="error_ccprocessor_unavailable";

$bill_message="<h3><FONT COLOR=#000080>Reason:</FONT>".$bill_message."</h3><br>";

?>
