<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 RRF.ru development. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The RRF.RU DEVELOPMENT forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE RRF.RU DEVELOPMENT TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE RRF.RU DEVELOPMENT TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is RRF.ru development.           |
| Portions created by RRF.ru development are Copyright (C) 2001-2002          |
| RRF.ru development. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_saferpay.php,v 1.3.2.1 2003/01/22 07:33:54 svowl Exp $
#
# Merchant Manager CC processing module
#



$accoutid = $module_params["param01"];
$currency = $module_params["param02"];

# Path to file 'saferpay' & configuration dir
$safer_path="/home/sites/site70/saferpay/out/";

#
# To use authorize.net module please correctly enter -referer parameter
#
if(!file_exists($safer_path."saferpay")) {
	header("Location: ../customer/error_message.php?error_ccprocessor_notfound");
	exit;
}

if($resp_code == "")
{
	$self_url="http://".$xcart_http_host.$xcart_web_dir."/payment/cc_saferpay.php?XCARTSESSID=$XCARTSESSID&resp_code=";

	$attr=array("NachName \"".addslashes($userinfo["firstname"])."\"",
				"VorName \"".addslashes($userinfo["lastname"])."\"",
				"Strasse \"".$userinfo["b_address"]."\"",
				"plz \"".$userinfo["b_zipcode"]."\"",
				"ort \"".$userinfo["b_city"]."\"",
				"HomeCountryId \"".$userinfo["b_city"]."\"",
				"PAN \"".$userinfo["card_number"]."\"",
				"EXP \"".$userinfo["card_expire"]."\"",
				"CURRENCY \"".$currency."\"",
				"ACCOUNTID \"".$accoutid."\"",
				"orderid \"".func_get_urlencoded_orderids($secure_oid)."\"",
				"AMOUNT ".floor(100*$cart["total_cost"]),
				"BACKLINK \"".$self_url.md5($XCARTSESSID+0xBAC)."\"",
				"FAILLINK \"".$self_url.md5($XCARTSESSID+0xFA)."\"",
				"SUCCESSLINK \"".$self_url.md5($XCARTSESSID+0xCCE)."\"",
				"DESCRIPTION \"X-Cart Products\"",
				"DELIVERY \"no\"",
				"LANGID \"1033\"");

	$s_attr="-a ".join(" -a ",$attr);
#	print "[".$s_attr."]";

	$fp = popen($safer_path."saferpay -payinit -p ".$safer_path." ".$s_attr, "r");
	$payinit_url = fgets($fp, 4096);

?>
<html>
<body onLoad="javascript:location.href='<? print $payinit_url; ?>';">
<table width=100% height=100%>
<tr><td align=center valign=middle>Please wait while connecting to <b>Saferpay</b> payment gateway...</td></tr>
</table>
</body>
</html>
<?
	exit;
}
# Back Link 
elseif(md5($XCARTSESSID+0xBAC) == $resp_code)
{
	session_register("secure_oid");
	func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
	header("Location: ../customer/error_message.php?error_ccprocessor_error");
}
# Fail Link
elseif(md5($XCARTSESSID+0xFA) == $resp_code)
{
	session_register("secure_oid");
	func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
	header("Location: ../customer/error_message.php?error_ccprocessor_error");
}
# Success Link
elseif(md5($XCARTSESSID+0xCCE) == $resp_code)
{
	parse_str($QUERY_STRING);urldecode($DATA);urldecode($SIGNATURE);

	$fp = popen($safer_path."saferpay -payconfirm -p ".$safer_path." -d \"".$DATA."\" -s \"".$SIGNATURE."\" 2>&1", "r");
	$bill_error = fgets($fp, 4096);

	if($bill_error)
	{
		func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
		header("Location: ../customer/error_message.php?bill_message=".$bill_error);
	}
	else
	{
		require "../include/payment_method.php";
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);
		session_unregister("secure_oid");
		$cart="";
		header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=".$XCARTSESSID);
	}	
}
exit;

?>
