<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_skipjack.php,v 1.5.2.1 2003/02/20 07:01:35 svowl Exp $
#

$DEBUG_MODE = false;

if ($DEBUG_MODE) {
	$url = "https://developer.skipjackic.com/scripts/EvolvCC.dll?Authorize";
} else {
	$url = "https://www.skipjackic.com/scripts/EvolvCC.dll?Authorize";
}

# this line protect us from empty orders
$bill_error=true; 

#
# Finish transaction
#

if ($REQUEST_METHOD == "POST" and $szOrderNumber)
{
	$response = $HTTP_POST_VARS ["szIsApproved"];

	session_id($Ordernumber);
	session_register("cart");
	session_register("order_secureid");
	session_register("userinfo");
	session_register("secure_oid");

	if($response == 1)
	{
		include "../include/payment_method.php";
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);
		session_unregister("secure_oid");

		#
		# Remove all from cart
		#
		$cart="";
		header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids");

		exit;
	}
	else
	{
		func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
		header("Location: ../customer/error_message.php?error_ccprocessor_error");
		exit;
	}	
}

$serial_number = $module_params ["param01"];

session_register("order_secureid");

$expiry_month = substr($userinfo["card_expire"],0,2);
$expiry_year = substr($userinfo["card_expire"],2,2);;

?>
<html>
<body onLoad="document.process.submit();">
  <form action="<? echo $url; ?>" method=POST name=process>
  	<INPUT type=hidden name=sjname value="<? echo "$userinfo[firstname] $userinfo[lastname]"; ?>">
	<INPUT type=hidden name=Email value="<? echo $userinfo[email]; ?>">
	<INPUT type=hidden name=Streetaddress value="<? echo $userinfo[b_address]; ?>">
	<INPUT type=hidden name=Shiptostreetaddress value="<? echo $userinfo[s_address]; ?>">
	<INPUT type=hidden name=Country value="<? echo $userinfo[b_country]; ?>">
	<INPUT type=hidden name=Fax value="<? echo $userinfo[fax]; ?>">
	<INPUT type=hidden name=City value="<? echo $userinfo[b_city]; ?>">
	<INPUT type=hidden name=Shiptocity value="<? echo $userinfo[s_city]; ?>">
	<INPUT type=hidden name=State value="<? echo $userinfo[b_state]; ?>">
	<INPUT type=hidden name=Shiptostate value="<? echo $userinfo[s_state]; ?>">
	<INPUT type=hidden name=Zipcode value="<? echo $userinfo[b_zipcode]; ?>">
	<INPUT type=hidden name=Shiptozipcode value="<? echo $userinfo[s_zipcode]; ?>">
	<INPUT type=hidden name=Shiptocountry value="<? echo $userinfo[s_country]; ?>">
	<INPUT type=hidden name=Ordernumber value="<? echo session_id(); ?>">
	<INPUT type=hidden name=Accountnumber value="<? echo $userinfo[card_number]; ?>">
	<INPUT type=hidden name=Month value="<? echo $expiry_month; ?>">
	<INPUT type=hidden name=Year value="<? echo $expiry_year; ?>">
	<INPUT type=hidden name=Serialnumber value="<? echo $serial_number; ?>">
	<INPUT type=hidden name=Transactionamount value="<? echo $cart["total_cost"]; ?>">
<?
	$os = "";
	$string = array ();
	$prods = func_products_in_cart ($cart, $userinfo[membership]);
	foreach ($prods as $product) {
		$string [] = $product[productcode];
		$string [] = $product[product];
		$string [] = $product[price];
		$string [] = $product[amount];
		$string [] = "N";
		$os .= implode ("~", $string) . "~||";
	}
?>
	<INPUT type=hidden name=Orderstring value="<? echo $os; ?>">
	<INPUT type=hidden name=Shiptophone value="<? echo $userinfo[phone]; ?>">
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>SkipJack</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<? exit; ?>
