<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: ch_paybycheck.php,v 1.1.2.1 2003/01/22 07:33:54 svowl Exp $
#
# PayByCheck Check processing module
#

$pid = $module_params ["param01"];

#
# Filling $_location variable depending protocol value
#

$sessid = $HTTP_GET_VARS[XCARTSESSID];

if($HTTP_GET_VARS[resp_code] == md5($sessid+0xF08))
{
	require "../include/payment_method.php";
	$bill_message="<h3>Declined</h3><br>";
	func_change_order_status($secure_oid, "F");session_unregister("secure_oid");

?>

<HEAD>
<TITLE>Error</TITLE>
<SCRIPT language="javascript" type="text/javascript">
    setTimeout('RelocateToXcart()', 5);
    function RelocateToXcart(){
    document.location = '<?echo "$base_addr/customer/error_message.php?error=error_ccprocessor_error&bill_message=".urlencode($bill_message);?>';
    }
</SCRIPT>
</HEAD>
        <BODY>
        <CENTER>
        <H3>There was a error while processing your order:</H3>
        <BR>
        <H4>You will be relocated back to shop in 5 seconds</H4>
        <BR>
        <BR>
        <A href=<?echo"$base_addr/customer/error_message.php?error=error_ccprocessor_error&bill_message=".urlencode($bill_message);?>>Click this link to go to the shop immediately</A>
        <BR>
        </CENTER>
        </BODY>
<?
		exit;
}
elseif($HTTP_GET_VARS[resp_code] == md5($sessid+0xFF3))
{
		require "../include/payment_method.php";
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);
		session_unregister("secure_oid");
		session_unregister("ship_to");	
#
# Remove all from cart
# 

		$cart = "";
        //Relocate customer to x-cart site
?>

<HEAD>
<TITLE>Your order has been processed</TITLE>
<SCRIPT language="javascript" type="text/javascript">
    setTimeout('RelocateToXcart()', 5);
    function RelocateToXcart(){
    document.location = '<?echo "$base_addr/customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=$XCARTSESSID";?>';
    }
</SCRIPT>
</HEAD>
        <BODY>
        <CENTER>
        <H3>Your order has been successfuly processed:</H3>
        <BR>
        <BR>
        <H4>You will be relocated back to shop in 5 seconds</H4>
        <BR>
        <BR>
        <A href=<?echo"$base_addr/customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=$XCARTSESSID";?>>Click this link to go to the shop immediately</A>
        <BR>
        </CENTER>
        </BODY>

<?
		exit;
}
else
{
	$string = array();
	$prods = func_products_in_cart ($cart, $userinfo[membership]);
	foreach ($prods as $product)
		$string [] = $product[product]." (".$product[price]." x ".$product[amount].")";
}


?>
<html>
<body onLoad="document.process.submit();">
  <form action=https://paybycheck.com/ method=POST name=process>
  <INPUT type=hidden name=id value="<? echo $pid; ?>">
  <INPUT type=hidden name=item value="<? echo join("; ",$string); ?>">
  <INPUT type=hidden name=name value="<? echo "$userinfo[firstname] $userinfo[lastname]"; ?>">
  <INPUT type=hidden name=a value="<? echo $cart["total_cost"]; ?>">
  <INPUT type=hidden name=email value="<? echo $userinfo[email]; ?>">
  <INPUT type=hidden name=address1 value="<? echo $userinfo[b_address]; ?>">
  <INPUT type=hidden name=city value="<? echo $userinfo[b_city]; ?>">
  <INPUT type=hidden name=state value="<? echo $userinfo[b_state]; ?>">
  <INPUT type=hidden name=zip value="<? echo $userinfo[b_zipcode]; ?>">
  <INPUT type=hidden name=phone value="<? echo $userinfo[phone]; ?>">
  <INPUT type=hidden name=s value="http://<? print $xcart_http_host.$xcart_web_dir."/payment/ch_paybycheck.php?XCARTSESSID=ITEM&resp_code=".md5(session_id()+0xFF3); ?>">
  <INPUT type=hidden name=f value="http://<? print $xcart_http_host.$xcart_web_dir."/payment/ch_paybycheck.php?XCARTSESSID=ITEM&resp_code=".md5(session_id()+0xF08); ?>">
  <INPUT type=hidden name=lock value=true>
</form>
<table width=100% height=100%>
<tr><td align=center valign=middle>Please wait while connecting to <b>PayByCheck</b> payment gateway...</td></tr>
</table>
</body>
</html>
<? exit; ?>
