<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: payment_cc.php,v 1.24.2.6 2003/04/07 06:00:52 svowl Exp $
#
# CC processing payment module
#

require "../include/payment_method.php";

if ($REQUEST_METHOD=="POST") {

	$order_details = "Cardholder's name:$card_name\nCard type: $card_type\nCard number: $card_number\nExp. date: $card_expire";
	if (empty($config["active_payment_processor"]) && $store_cvv2)
		$order_details.="\nCVV2: ".$card_cvv2;
	$order_details.=$ship_to;
#
# Only logged users can submit orders
#
	if ($config["active_payment_processor"]) {
#
# Get active processor's data
#
    	$processor_data = func_query_first("select * from $sql_tbl[ccprocessors] where module_name='".addslashes($config[active_payment_processor])."'");
#
# Get module parameters
#
		$module_params = func_query_first("select * from $sql_tbl[ccprocessors] where processor='".$processor_data["processor"]."'");

# Put order in table
	if((!$secure_oid) || ($secure_oid_cost != $cart["total_cost"]))
	{	$orderids = func_place_order("$payment_method (".$processor_data["module_name"].")", "I", ($store_cc) ? $order_details : $ship_to);
		$secure_oid = $orderids;
		session_register("secure_oid");
		$secure_oid_cost = $cart["total_cost"];
		session_register("secure_oid_cost");
	}

#
# This line includes cc_processor's code so that it
# executes inside _this_ script
#
       	require $processor_data["processor"];
#
# This code reports error and inserts order
#
    	$order_status = ($bill_error) ? "F" : "P";

		func_change_order_status($orderids, $order_status);
		$_orderids = func_get_urlencoded_orderids ($orderids);
		session_unregister("secure_oid");

		if ($bill_error) {
        	header("Location: ../customer/error_message.php?error=$bill_error&bill_message=".urlencode($bill_message)."&XCARTSESSID=$XCARTSESSID");
			exit;
		} else {
#
# If successful - Store CC number in database
#
			if ($store_cc)
				db_query("update $sql_tbl[customers] set card_type='$card_type', card_number='".text_crypt($card_number)."', card_expire='$card_expire' where login='$login' and usertype='$login_type'");

#
# Unset cart
#
			$cart="";
			header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=$XCARTSESSID");
			exit;
		}
	}
	else {
#
# If active_processor is empty do manual processing
#

		$orderids = func_place_order($payment_method." (manual processing)","Q",$order_details);
		$_orderids = func_get_urlencoded_orderids ($orderids);
		$cart="";

#
# If successful - Store CC number in database
#
			if ($store_cc)
				db_query("update $sql_tbl[customers] set card_type='$card_type', card_number='".text_crypt($card_number)."', card_expire='$card_expire' where login='$login' and usertype='$login_type'");


		header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=$XCARTSESSID");
	}
}
	
?>
