#!/usr/bin/perl

#
# $Id: plugnpay_com.pl,v 1.3 2002/09/17 06:11:37 sdg Exp $
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));
#use MD5;

sub urldecode
{
	local($val2)=@_;
	$val2=~ s/\+/ /g;
	$val2=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C',hex($1))/ge;
	return $val2;
}



$script="/payment/pnpremote.cgi";
$port="443";

if (($#ARGV+1)==0) 
{
 print <<EOF;
 Usage: plugnpay_com.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
     -bname         +     Name as it appear on Credit Card
     -baddr         +     Billing Street Address
     -bcity         +     Billing City Address
     -bstate        +     Billing State Address (required for US only)
     -bzip          +     Billing Zip Address
     -bcountry      +     Billing 2 Character Country Code
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -publisher     +     Merchant's username 
     -pemail        +     Merchant's email
 ---- Product's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -desc          -     Product description 
 ---- Host's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -host          +     Payment server
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}
### --- Check for required parameters
if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "")
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}

if ($arg{'-bname'} eq "")
{
	print "2,Invalid '-bname' value";
	exit;
}

if ($arg{'-baddr'} eq "")
{
	print "2,Invalid '-baddr' value";
	exit;
}

if ($arg{'-bcity'} eq "")
{
	print "2,Invalid '-bcity' value";
	exit;
}

#if ($arg{'-bstate'} eq "")
#{
#	print "2,Invalid '-bstate' value";
#	exit;
#}

if ($arg{'-bzip'} eq "")
{
	print "2,Invalid '-bzip' value";
	exit;
}

if ($arg{'-bcountry'} eq "")
{
	print "2,Invalid '-bcountry' value";
	exit;
}

if ($arg{'-publisher'} eq "")
{
	print "2,Invalid '-publisher' value";
	exit;
}

if ($arg{'-pemail'} eq "")
{
	print "2,Invalid '-pemail' value";
	exit;
}

if ($arg{'-host'} eq "")
{
	print "2,Invalid '-host' value";
	exit;
}

if (($arg{'-host'}=~ /https/))
{
	$arg{'-host'}=~ s/https:\/\///;
}

##------------------------------------------------------------------


($page, $response, %reply_headers)=post_https($arg{'-host'}, $port, $script,
 make_headers(
  'User-Agent' => 'X-Cart'
 ),
 make_form (
 'publisher-name' => $arg{'-publisher'},
 'card-amount' => $arg{'-ccamount'},
 'card-name' => $arg{'-bname'},
 'card-address1' => $arg{'-baddr'},
 'card-city' => $arg{'-bcity'},
 'card-state' => $arg{'-bstate'},
 'card-zip' => $arg{'-bzip'},
 'card-country' => $arg{'-bcountry'},
 'card-number' => $arg{'-ccnum'},
 'card-exp' => $arg{'-ccexpdate'},
 'publisher-email' => $arg{'-pemail'},
 'description#' => $rg{'-desc'}
));
@lines=split ('&',$page);

#print "publisher-name=".$arg{'-publisher'}."\n";

foreach $item (@lines)
{
	($key, $val) = split('=',$item);
	if ($key ne "")
	{
		$key1=urldecode($key);
		$val1=urldecode($val);
		$resp{$key1}=$val1;
#		print "$key1=$val1\n"; 
	}
}
if ($resp{'FinalStatus'} eq "success")
{
	print "1,Success";
}
else
{
	print "2,".$resp{'MErrMsg'};
}
