<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: countries.php,v 1.15.2.1 2003/01/16 12:17:17 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#   
# Use this condition when single mode is disabled
#
$provider_condition=($single_mode?"":"and provider='$login'");

if ($REQUEST_METHOD=="POST") {

    foreach($HTTP_POST_VARS as $key=>$val) {
#
# Update country_tax table
#
		if (strstr($key, "-")) {
			list($field, $code, $taxid) = split("-", $key);
			$taxes_array[$code][$field] = doubleval($val);
		}
	}

    db_query ("DELETE FROM $sql_tbl[country_tax] WHERE 1 $provider_condition");
   
    foreach($taxes_array as $k=>$v) {
        if ($v["tax_percent"] || $v["tax_flat"]) {
            db_query("INSERT INTO $sql_tbl[country_tax] (code, provider, tax_percent, tax_flat) VALUES('$k', '$login', '$v[tax_percent]', '$v[tax_flat]')");
        }
    }

    header("Location: countries.php");
	exit;
}

#
# Obtain countries and taxes
#
$countries = func_query("select $sql_tbl[country_tax].taxid, $sql_tbl[country_tax].code, $sql_tbl[country_tax].provider, $sql_tbl[countries].code, $sql_tbl[countries].country, greatest($sql_tbl[country_tax].tax_flat,0) as tax_flat, greatest($sql_tbl[country_tax].tax_percent,0) as tax_percent from $sql_tbl[countries] LEFT JOIN $sql_tbl[country_tax] on $sql_tbl[countries].code=$sql_tbl[country_tax].code $provider_condition order by $sql_tbl[countries].country");

$smarty->assign("countries",$countries);
$smarty->assign("main","countries");

@include "../modules/gold_display.php";
$smarty->display("provider/home.tpl");
?>
