<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: import_images.php,v 1.5 2002/12/04 06:39:14 matr Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#
# CSV import facility, default delimiter '\t'
#
$quote_symbol="'";

if (substr ($images_directory, -1, 1) != '/')
	$images_directory .= '/';

$insert_main_string = "INSERT INTO $sql_tbl[images] (";

if ($cols) foreach($cols as $k=>$v) {
	if ($v == "") continue;

	if (ereg("product",$v))
		$insert_main_string .= "productid, ";
	else
		$insert_main_string .= "$v, ";
}

$insert_main_string = ereg_replace("\, $", ", image_type, image_x, image_y, image_size) VALUES(", $insert_main_string);


if ($REQUEST_METHOD=="POST") {

#
# Generate insert string
#
	$provider_condition=($single_mode?"":" and products.provider='$login'");
	
	
#
# Read file line by line
#
# Then explode by delimiter, chop first and last ", remove "" dups, add slashes
# and append to $insert_string
#
	$entries=0;
	if ($localfile)
		$userfile = $localfile;
	if($fp = @fopen($userfile,"r")) {
		while ($columns[] = fgetcsv ($fp, 65536, $delimiter));
		fclose($fp);

		foreach($columns as $k=>$v) {
			
			$flag = false;
			$no_product = false;
			if (is_array($v)) {
				$flag = true;
				$insert_string = $insert_main_string;
				foreach($v as $k1=>$column) {
					if ($cols[$k1] == "") continue;
//				echo "$k1=>$column, ";
					if (ereg("product",$cols[$k1])) {
						$query = "SELECT productid FROM $sql_tbl[products] WHERE ".$cols[$k1]."='$column'";
						$res = func_query($query);
						if ($res) {
							$productid = array_pop(func_query_first("SELECT productid FROM $sql_tbl[products] WHERE ".$cols[$k1]."='$column'"));
							$insert_string .= $quote_symbol.$productid.$quote_symbol.", ";		
							continue;
						}
						else {
							$no_product = true;
							$columns[$k][error] = 1;
							continue;
						}	
					}
					if ($cols[$k1] == "image") {
						$ifp = @fopen ($images_directory.$column, "rb");
	                    if ($ifp) {
	                   		$image_content = fread ($ifp, 300000);
							fclose($ifp);
					        list($image_size, $image_x, $image_y) = func_get_image_size($images_directory.$column);
							list($image_x, $image_y) = GetImageSize($images_directory.$column);
							$image_ext = substr ($column, -3, 3);
	                        if (strcasecmp ($image_ext, "jpg") == 0)
    	                        $image_type = "image/jpeg";
        	                elseif (strcasecmp ($image_ext, "gif") == 0)
            	                $image_type = "image/gif";
                	        else
                    	        $image_type = "image/$image_ext";
							$column = $image_content;

							$image_string = "'$image_type', '$image_x', '$image_y', '$image_size', "; 
						}
						else {
							$no_product = true;
							$columns[$k][error] = 2;
							continue;
						}
					}
					$insert_string .= $quote_symbol.addslashes($column).$quote_symbol.", ";
				}
			}
			if ($no_product) continue;
			$insert_string .= $image_string;
			$insert_string = ereg_replace("\, $", ")", $insert_string);
			if ($flag) {
//				echo "$insert_string<br>";
				db_query($insert_string);
				$entries++;
			}	
		}	
		
	}
	else {

		header("Location: error_message.php?import_error"); 
		exit;
	}

	header("Location: import_images.php?mode=imported&entries=$entries");
	exit;
}

#
# Obtain columns from table products
#

$columns = func_query("show columns from $sql_tbl[images]");

foreach($columns as $key => $column) {
	if ($column["Field"]!="imageid" && $column["Field"]!="image_type" && $column["Field"]!="image_x" && $column["Field"]!="image_y" && $column["Field"]!="image_size") 
		$mycolumns[]=$column;
}

require "../include/categories.php";

$smarty->assign("columns",$mycolumns);
$smarty->assign("main","import_images");

@include "../modules/gold_display.php";
$smarty->display("provider/home.tpl");
?>
