<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: shipping_rates.php,v 1.21 2002/12/06 07:13:34 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#
# Shipping rates - D (defined rates)
# Shipping markups - R (for realtime methods only)
#
if ($type != "R")
	$type = "D";

$type_condition = " AND type='$type'";


$provider_condition=($single_mode?"":"and provider='$login'");

if ($REQUEST_METHOD=="POST") {
	while(list($key,$val)=each($HTTP_POST_VARS))
	{
#
# Update shipping table
#
    	if (strstr($key,"-")) {
        	list($field,$rateid)=split("-",$key);
        	db_query("update $sql_tbl[shipping_rates] set $field='$val' where rateid='$rateid' $provider_condition $type_condition");
    	}
	}
#
# Add new shipping rate
#
    if ($shippingid_new) 
		db_query("insert into $sql_tbl[shipping_rates] (shippingid, maxweight, maxamount, maxtotal, rate, item_rate, rate_p, weight_rate, provider, zoneid, type) values ('$shippingid_new','$maxweight_new','$maxamount_new','$maxtotal_new','$rate_new','$item_rate_new','$rate_p_new','$weight_rate_new','$login','$zoneid_new','$type')");

	header("Location: shipping_rates.php?zoneid=$zoneid&shippingid=$shippingid&type=$type");
}

if ($mode=="delete") {
#
# Delete shipping option
#
    db_query("delete from $sql_tbl[shipping_rates] where rateid='$rateid' $provider_condition $type_condition");
}

$zone_condition = ($zoneid!=""?"and $sql_tbl[shipping_rates].zoneid='$zoneid'":"");
$method_condition = ($shippingid!=""?"and $sql_tbl[shipping_rates].shippingid='$shippingid'":"");

$realtime_condition = ($config["Shipping"]["realtime_shipping"]=="Y"?"and $sql_tbl[shipping].code=''":"");

$shipping_rates = func_query("select $sql_tbl[shipping_rates].*, $sql_tbl[shipping].shipping_time from $sql_tbl[shipping], $sql_tbl[shipping_rates] where $sql_tbl[shipping_rates].shippingid=$sql_tbl[shipping].shippingid $provider_condition $type_condition $zone_condition $method_condition ".($type=="R"?" AND code!='' ":$realtime_condition)." order by $sql_tbl[shipping].orderby, $sql_tbl[shipping_rates].maxweight");

#
# Prepare zones list
#
$zones = func_shipping_zones();

$shipping = func_query("select * from $sql_tbl[shipping] where active='Y' ".($type=="R"?" AND code!='' ":$realtime_condition)." order by orderby");
$smarty->assign("shipping", $shipping);

$smarty->assign("zones", $zones);
$smarty->assign("shipping_rates", $shipping_rates);
$smarty->assign("type", $type);

if ($type == "R")
	$smarty->assign("main","shipping_markups");
else
	$smarty->assign("main","shipping_rates");

@include "../modules/gold_display.php";
$smarty->display("provider/home.tpl");
?>
