<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: shipping_zones.php,v 1.10.2.1 2003/02/20 10:48:11 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

$provider_condition=($single_mode?"":"and provider='$login'");

#
# provider condition is always enabled potomuchto esli ee otrubit' - eto pizda
#

if($REQUEST_METHOD=="POST") {
#
# Calculate the last zone
#
	$last_country_zone=array_pop(func_query_first("select max(zoneid) from $sql_tbl[country_zones] where 1 $provider_condition"));
	$last_state_zone=array_pop(func_query_first("select max(zoneid) from $sql_tbl[state_zones] where 1 $provider_condition"));
	$last_zone=1+max($last_country_zone,$last_state_zone);

	if (!empty($zone_countries))
		foreach($zone_countries as $zone_country)
			if ($newzoneid!="" && $newzoneid==0) {
				db_query("delete from $sql_tbl[country_zones] where code='$zone_country' and zoneid='$zoneid' $provider_condition");
			}
			elseif($newzoneid!=0 && $newzoneid!="") {
				@db_query("insert into $sql_tbl[country_zones] (code,zoneid,provider) values ('$zone_country','$newzoneid','$login')");
				db_query("update $sql_tbl[country_zones] set zoneid='$newzoneid' where zoneid='$zoneid' and code='$zone_country' $provider_condition");
			}
			else {
				db_query("delete from $sql_tbl[country_zones] where code='$zone_country' and zoneid='$zoneid' $provider_condition");
				db_query("insert into $sql_tbl[country_zones] (zoneid,code,provider) values ('$last_zone','$zone_country','$login')");
			}

	if (!empty($zone_states))
		foreach($zone_states as $zone_state)
			if ($newzoneid!="" && $newzoneid==0) {
				db_query("delete from $sql_tbl[state_zones] where code='$zone_state' and zoneid='$zoneid' $provider_condition");
			}
			elseif($newzoneid!=0 && $newzoneid!="") {
				@db_query("insert into $sql_tbl[state_zones] (code,zoneid,provider) values ('$zone_state','$newzoneid','$login')");
				db_query("update $sql_tbl[state_zones] set zoneid='$newzoneid' where zoneid='$zoneid' and code='$zone_state' $provider_condition");
			}
			else {
				db_query("delete from $sql_tbl[state_zones] where code='$zone_state' and zoneid='$zoneid' $provider_condition");
				db_query("insert into $sql_tbl[state_zones] (zoneid,code,provider) values ('$last_zone','$zone_state','$login')");
			}
	if ($zoneid > 0) {
		$is_empty_zone = array_pop(func_query_first("SELECT COUNT(*) FROM $sql_tbl[state_zones] WHERE zoneid='$zoneid'")) + array_pop(func_query_first("SELECT COUNT(*) FROM $sql_tbl[country_zones] WHERE zoneid='$zoneid'"));
		if ($is_empty_zone == 0) {
			db_query("DELETE FROM $sql_tbl[shipping_rates] WHERE zoneid='$zoneid'");
			db_query("DELETE FROM $sql_tbl[tax_rates] WHERE zoneid='$zoneid'");
		}
	}
	header("Location: shipping_zones.php?rand=".rand(10,99));
	exit();
}

#
# Prepare zones list
#
$country_zones=func_query("select $sql_tbl[countries].code, $sql_tbl[countries].country, greatest($sql_tbl[country_zones].zoneid,0) as zoneid from $sql_tbl[countries] LEFT JOIN $sql_tbl[country_zones] on $sql_tbl[countries].code=$sql_tbl[country_zones].code $provider_condition order by country");

$state_zones=func_query("select $sql_tbl[states].code, $sql_tbl[states].state, greatest($sql_tbl[state_zones].zoneid,0) as zoneid from $sql_tbl[states] LEFT JOIN $sql_tbl[state_zones] on $sql_tbl[states].code=$sql_tbl[state_zones].code $provider_condition order by state");

#
# Prepare all zones list (gather zones from country_zones and state_zones
#
$all_zones = func_shipping_zones();

$smarty->assign("country_zones", $country_zones);
$smarty->assign("state_zones", $state_zones);
$smarty->assign("all_zones", $all_zones);
$smarty->assign("shipping_rates", $shipping_rates);
$smarty->assign("main","shipping_zones");

@include "../modules/gold_display.php";
$smarty->display("provider/home.tpl");
?>
