<?

$params = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='FDX'");
if ($config["Company"]["location_country"] == "US") {
	}

                # Company type (company_type): FedEx Express (Express)/FedEx Ground (Ground)/FedEx Home Delivery (Home)
                # Packaging (packaging): 1-My Packaging/2-Fedex Express Pak/3-Fedex Express Box/4-Fedex Express Tube/6-FedEx Express Envelope
                # Weight units (weight_units): lbs/kgs
                # Dim units (dim_units): in/cm
                # Dropoff (dropoff_type) : Dropoff at FedEx location (4)/Give to sheduled courier (1)/Schedule a pickup (2)
                switch ($config["Shipping"]["intershipper_weightunits"]) {
                        case "LBS":
                        case "LB":
                        case "lb":
                        case "lbs":
                                $du = "lbs";
                                break;
                        case "KGS":
                        case "kgs":
                        case "Kgs":
                        case "kg":
                        case "KG":
                                $du = "kgs";
                                break;
                        default:
                                $du = "lbs";
                }

$FEDEX_FOUND = false;
foreach ($allowed_shipping_methods as $key=>$value)
	if ($value["code"] == "FDX")
			$FEDEX_FOUND = true;
                                
if ($FEDEX_FOUND) {

global $cart;
$zipNotReq=array("AR"=>1, "AU"=>1, "AT"=>1, "BE"=>1, "BR"=>1, "BG"=>1, "CA"=>1, "CN"=>1, "CZ"=>1, "DK"=>1,
				 "FI"=>1, "FR"=>1, "DE"=>1, "GR"=>1, "GU"=>1, "HU"=>1, "IN"=>1, "ID"=>1, "IT"=>1, "JP"=>1,
				 "KR"=>1, "LA"=>1, "LI"=>1, "MY"=>1, "MH"=>1, "MX"=>1, "FM"=>1, "MC"=>1, "MN"=>1, "NL"=>1,
				 "NC"=>1, "NZ"=>1, "NO"=>1, "PW"=>1, "PH"=>1, "PT"=>1, "RU"=>1, "SM"=>1, "SG"=>1, "SK"=>1,
				 "ZA"=>1, "ES"=>1, "LK"=>1, "SE"=>1, "CH"=>1, "TW"=>1, "TH"=>1, "GB"=>1, "US"=>1, "UY"=>1,
				 "VN"=>1, "PR"=>1);
$supportHome=array('US'=>1,'CA'=>1);
$supportGrnd=array('US'=>1,'CA'=>1,'PR'=>1);

$host = "www.fedex.com";
$post_url = "/ratefinder/shipInfo";
$ozip = (!$zipNotReq[$config["Company"]["location_country"]]) ? ("Not+Required") : ($config["Company"]["location_zipcode"]);
$dzip = (!$zipNotReq[$userinfo[s_country]]) ? ("Not+Required") : ($userinfo[s_zipcode]);
$s2res = ($supportHome[$userinfo[s_country]]) ? ($params[param02]) : ("false");
$ctyp = ($supportGrnd[$userinfo[s_country]]) ? ($params[param00]) : ("Express");
$isex = ($ctyp == "Express") ? ("true") : ("false");
$isgr = ($ctyp == "Ground" && $s2res != "true") ? ("true") : ("false");

#print join(" - ",array($ozip,$dzip,$userinfo[s_country],$s2res,$ctyp,$isex,$isgr));

# Step ONE
list($a,$b,$c)=func_http_post_request($host,$post_url,"","");
preg_match("/JSESSIONID=(.*);/",$a["SET-COOKIE"],$c);$cookies = $c[0];
$post_url.=";$cookies";

# Step TWO
$post_str = "cc=US&language=en&locId=123&origCountry=".$config["Company"]["location_country"]."&origZip=".$ozip."&destCountry=".$userinfo[s_country]."&destZip=".$dzip."&shipDate=".date("mdY",time()+7*3600)."&shipToResidence=".$s2res."&companyType=".$ctyp."&submitShipInfo=Continue";
list($a,$b,$c)=func_http_post_request($host,$post_url,$post_str,$cookies);

# Step THREE
$post_str = "weightUnit=".$du."&dimUnit=cm&dimLength=&dimWidth=&dimHeight=&isExpress=".$isex."&isGround=".$isgr."&cc=US&language=en&locId=123&declaredValue=".(int)($cart["sub_total"])."&groundCOD=false&packageType=".$params["param01"]."&weight=".$weight."&submitGetRates=Get+Rates";
list($a,$b,$c)=func_http_post_request($host,$post_url,$post_str,$cookies);

#print $b;

$b=strtr($b,"\t\n\r","   ");
preg_match("/<B>Service<\/B>(.*)<\/TABLE>/Ui",$b,$a);
preg_match_all("/<Td(.*)>(.*)<\/td>/Ui",$a[1],$result);

while(list($a,$b)=each($result[2]))
{ $b=strip_tags($b);
  preg_match("/FedEx(.*)\&/i",$b,$c);
  if($c[1] != "")
	{	each($result[2]);
		list($a,$b)=each($result[2]);
		preg_match("/^(.*)\&/i",$b,$a);
		#print "Found: ".$c[1]." (".$a[1].")<br>";
			foreach ($allowed_shipping_methods as $sk=>$sv) {
				if ($sv["code"]=="FDX" && stristr($sv["shipping"],$c[1])) $intershipper_rates[]= array ("methodid"=>$sv["subcode"], "rate"=>$a[1]);
			}
	}
}
}
?>
