{* $Id: edit_dir.tpl,v 1.20.2.2 2003/04/07 09:30:05 svowl Exp $ *}
{if ($what_to_edit eq "files")}
{include file="location.tpl" last_location="Browse files"}
This section allows you to browse, add, delete files which afterwards may be used in your store. 
{else}
{include file="location.tpl" last_location="Browse templates"}
This section allows you to edit templates from which your store is built. As the templates engine is very flexible and extremely configurable, you may change the store's look and feel so that it will fit <b>any design layout</b>. But be careful! The powerful flexibility requires basic HTML knowledge and experience. If "$admin_safe_mode" is set to "true" then template editor is write-protected.
{if $smarty.get.dir eq ""}
<p>
<b>Note:</b> You will probably want to use 'X-Cart debug console' together with template editor. You can activate 'X-Cart debug console' under 'General settings' menu.
<p>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=&file=%2F{$skin_config}">Config file ({$skin_config})</a><br>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=&file=%2F{#CSSFile#}">CSS file ({#CSSFile#})</a><br>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=%2Fbuttons">Buttons</a><br>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=%2Fhelp">Help files</a><br>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=%2Fmain">Error messages</a><br>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=%2Fmail">Mail templates</a><br>
<img src="{$ImagesDir}/rarrow.gif" width=9 height=9> <a href="{$action_script}?dir=&file=%2Ftoday_news.tpl">Today News</a>
{/if}
{/if}
<p>
{capture name=dialog}
<FORM method=POST action="{$action_script}" name=fm_form enctype="multipart/form-data">
<INPUT type=hidden name=dir value="{if $smarty.get.dir ne ""}{$smarty.get.dir}{else}{$smarty.post.dir}{/if}">
<INPUT type=hidden name=mode>
<INPUT type=hidden name=MAX_FILE_SIZE value=500000000>
<INPUT type=hidden name=my_files value="{$my_files}">
<TABLE width="100%" border=0 cellpadding=2 cellspacing=0>
<TR valign=top><TD width="50%">
{section name=dir_entry loop=$dir_entries}
{if $dir_entries[dir_entry].filetype eq "dir"}
<INPUT type=radio name=filename {if $dir_entries[dir_entry].file eq ".."} disabled {/if} value="{$dir_entries[dir_entry].href}">
<a href="{$action_script}?dir={$dir_entries[dir_entry].href|escape:"url"}">
<img src="{$ImagesDir}/folder.gif" width=16 height=16 border=0>
{$dir_entries[dir_entry].file|truncate:25}/</a>
{else}
{if ($what_to_edit eq "files")}
<INPUT type=radio name=filename value="{$dir_entries[dir_entry].href}">
<a href="{$dir_entries[dir_entry].file_href|replace:" ":"%20"}">
<img src="{$ImagesDir}/doc.gif" width=16 height=16 border=0>
{$dir_entries[dir_entry].file|truncate:25}</a>
{else}
<INPUT type=radio name=filename value="{$dir_entries[dir_entry].href}">
<a href="{$action_script}?dir={$smarty.get.dir|escape:"url"}&file={$dir_entries[dir_entry].href|escape:"url"}">
<img src="{$ImagesDir}/doc.gif" width=16 height=16 border=0>
{$dir_entries[dir_entry].file|truncate:25}</a>
{/if}
{/if}<br>
{if ($smarty.section.dir_entry.index eq $dir_entries_half)}</TD><TD width="50%">{/if}
{/section}
</TD></TR></TABLE>
<HR width="100%" align=center>
{literal}
<P><INPUT type=button value="Delete" onClick='javascript: if (confirm ("Delete selected file or directory?")) {document.fm_form.mode.value="Delete"; document.fm_form.submit ()};'></P>
{/literal}
{if ($what_to_edit ne "files")}
<P><INPUT type=button value="New file" onClick='javascript: document.fm_form.mode.value="New file"; document.fm_form.submit ();'>&nbsp;<INPUT type=text size=15 name=new_file value=""></P>
{/if}
<P><INPUT type=button value="New dir" onClick='javascript: document.fm_form.mode.value="New directory"; document.fm_form.submit ();'>&nbsp;<INPUT type=text size=15 name=new_directory value=""></P>
<P><INPUT type=button value="Copy to" onClick='javascript: document.fm_form.mode.value="Copy to"; document.fm_form.submit ();'>&nbsp;<INPUT type=text size=15 name=copy_file value=""></P>
<P><INPUT type=button value="Upload" onClick='javascript: document.fm_form.mode.value="Upload"; document.fm_form.submit ();'>&nbsp;<INPUT type=file name=userfile>&nbsp;<INPUT type=checkbox name="rewrite_if_exists" value="Y" checked>Overwrite file if exists</P>
</FORM>
{if $what_to_edit eq "templates" and $smarty.get.dir eq ""}
<FORM method=POST action="{$action_script}" name=rc_form>
<INPUT type=hidden name=mode>
If you wish to restore all templates from the repository click the button below.
<br>
<b>WARNING:</b> ALL CHANGES MADE TO ALL TEMPLATES WILL BE LOST<br>
<INPUT type=button value="Restore All" onClick='javascript: document.rc_form.mode.value="restore_all"; document.rc_form.submit ();'></P>
<P>
If you do not need the multi-language templates we recommend to perform compilation (i.e. automatically replacing language variables with the values). This would be very helpful in editing templates process. 
<br>
<b>Note:</b> compilation process could take several minutes, please be patient.<br>
<br> 
<INPUT type=button value="Compile templates" onClick='javascript: document.rc_form.mode.value="compile_all"; document.rc_form.submit ();'>
&nbsp;
Language: <SELECT name=language>
{section name=li loop=$languages}
<OPTION value="{$languages[li].code}">{$languages[li].language}</OPTION>
{/section}
</SELECT>
<P>
<b>Note:</b> if you wish to switch back to the multi-language templates, use "Restore All" function.<br>
{/if}
</FORM>
{/capture}
{if ($what_to_edit eq "files")}
{include file="dialog.tpl" title="Browse files" content=$smarty.capture.dialog extra="width=100%"}
{else}
{include file="dialog.tpl" title="Browse templates" content=$smarty.capture.dialog extra="width=100%"}
{/if}


