{* $Id: shipping.tpl,v 1.19 2002/12/06 09:49:21 svowl Exp $ *}
{include file="location.tpl" last_location="Shipping methods"}
This section allows you to define shipping methods that you wish to be available to customers. Once a shipping method has been created, product vendors will be allowed to setup shipping charge calculations for it.
<p>Real-time shipping calculations can be activated/deactivated under 'General settings' menu ('Shipping options' submenu).
<p>
<b>Note:</b> If you set Destination field to 'National' then this shipping method will not be available to international customers or customers who are not logged in.
<p>
{capture name=dialog}
<p>
<table border="0">
<form action="shipping.php" method="POST">
{section name=prod_num loop=$shipping}
{if $shipping[prod_num].code ne ""}
{if %prod_num.first%}
<tr><td class=AdminTitle colspan=5>Real-time calculated shipping methods</td></tr>
<tr>
<td class=TableHead>Shipping method</td>
<td class=TableHead>Period</td>
<td class=TableHead>Destination</td>
<td class=TableHead>Weight limit ({$config.General.weight_symbol})</td>
<td class=TableHead>Pos.</td>
<td class=TableHead>Active</td>
</tr>
{/if}
<tr>
<td>{$shipping[prod_num].shipping}</td>
<td><input type=text name=shipping_time-{$shipping[prod_num].shippingid} size=8 value="{$shipping[prod_num].shipping_time}"></td>
<td>
{if $shipping[prod_num].destination eq "L"}National{else}International{/if}
</td>
<td><input type=text size=8 name="weight_limit-{$shipping[prod_num].shippingid}" value="{$shipping[prod_num].weight_limit}"></td>
<td><input type=text name=orderby-{$shipping[prod_num].shippingid} size=4 value="{$shipping[prod_num].orderby}"></td>
<td>
<input type=checkbox name=active-{$shipping[prod_num].shippingid} {if $shipping[prod_num].active eq "Y"}checked{/if}>
</td>
</tr>
{/if}
{/section}
<tr><td class=AdminTitle colspan=5><br>Defined shipping methods</td></tr>
<tr>
<td class=TableHead>Shipping method</td>
<td class=TableHead>Period</td>
<td class=TableHead>Destination</td>
<td class=TableHead>Weight limit ({$config.General.weight_symbol})</td>
<td class=TableHead>Pos.</td>
<td class=TableHead>Active</td>
</tr>
{section name=prod_num loop=$shipping}
{if $shipping[prod_num].code eq ""}
<tr>
<td><input type=text name=shipping-{$shipping[prod_num].shippingid} size=32 value="{$shipping[prod_num].shipping}"></td>
<td><input type=text name=shipping_time-{$shipping[prod_num].shippingid} size=8 value="{$shipping[prod_num].shipping_time}"></td>
<td>
<select name=destination-{$shipping[prod_num].shippingid}>
<option value="I" {if $shipping[prod_num].destination eq "I"}selected{/if}>International</option>
<option value="L" {if $shipping[prod_num].destination eq "L"}selected{/if}>National</option>
</select>
</td>
<td><input type=text size=8 name="weight_limit-{$shipping[prod_num].shippingid}" value="{$shipping[prod_num].weight_limit}"></td>
<td><input type=text name=orderby-{$shipping[prod_num].shippingid} size=4 value="{$shipping[prod_num].orderby}"></td>
<td nowrap>
<input type=checkbox name=active-{$shipping[prod_num].shippingid} {if $shipping[prod_num].active eq "Y"}checked{/if}>
<input type=button value=Delete onClick="self.location='shipping.php?mode=delete&shippingid={$shipping[prod_num].shippingid}'">
</td>
</tr>
{/if}
{/section}
<tr><td class=AdminTitle colspan=5><br>Add shipping method</td></tr>
<tr>
<td><input type=text name=shipping_new size=32></td>
<td><input type=text name=shipping_time_new size=8></td>
<td>
<select name=destination_new>
<option value="I">International</option>
<option value="L">National</option>
</select>
</td>
<td><input type=text name=shipping_weight_limit_new size=8></td>
<td><input type=text name=orderby_new size=4></td>
<td>
</td>
</tr>
<tr>
<td colspan=5><br><input type=submit value="Update"></td>
</tr>
</form>
</table>
<p>
{/capture}
{include file="dialog.tpl" title="Edit shipping methods" content=$smarty.capture.dialog extra="width=100%"}
