{* $Id: check_cc_number_script.tpl,v 1.2 2002/10/07 08:45:22 basil Exp $ *}
{literal}
<script language="JavaScript1.2">


/*
* This function cheks the checksum of CreditCard
* @param cc - the string with credit card number
* @param accepted - the array of allowed CC types
* if(accepted==null) { all CC types are allowed }
*/

function isCreditCard(cc,accepted) {

  cc=String(cc);

  if(cc.length<4 || cc.length>30) return false;

  // Start the Mod10 checksum process...
  var checksum=0;

  // Add even digits in even length strings or odd digits in odd length strings.
  for (var location=1-(cc.length%2); location<cc.length; location+=2) {
    var digit=parseInt(cc.substring(location,location+1));
    if(isNaN(digit)) return false;
    checksum+=digit;
  }

  // Analyze odd digits in even length strings 
  // or even digits in odd length strings.
  for (var location=(cc.length%2); location<cc.length; location+=2) {
    var digit=parseInt(cc.substring(location,location+1));
    if(isNaN(digit)) return false;
    if(digit<5) checksum+=digit*2;
    else checksum+=digit*2-9;
  }

  if(checksum%10!=0) return false;

  if(accepted!=null) {
    var t=parseInt(cc.substring(0,4)), l=cc.length;
    var type;
    if(t>=3000 && t<3060 && l==14) type="Diners Club";
    else if(t>=3400 && t<3500 && l==15) type="American Express";
    else if(t>=3528 && t<3590 && l==16) type="JCB";
    else if(t>=3600 && t<3700 && l==14) type="Diners Club";
    else if(t>=3700 && t<3800 && l==15) type="American Express";
    else if(t>=3800 && t<3890 && l==14) type="Diners Club";
    else if(t>=3890 && t<3900 && l==14) type="Carte Blanche";
    else if(t>=4000 && t<5000 && (l==13 || l==16)) type="Visa";
    else if(t>=5100 && t<5600 && l==16) type="MasterCard";
    else if(t==5610 && l==16) type="Australian BankCard";
    else if(t==6011 && l==16) type="Discover/Novus";
    else type=null;
    var accept=false;
    for(var i in accepted) {
      var val=accepted[i];
      if(val==type || val=="All") { accept=true; break; }
    }
    if(accept==false) return false;
  }
  
  return true;

}


function checkCCNumber(field_cc,field_accepted) {
{/literal}
  var card_types=new Array();
  {section name=card_type loop=$card_types}
    card_types["{$card_types[card_type].code}"]="{$card_types[card_type].type}";
  {/section}
{literal}
  var cc=field_cc.value;
  var accepted=null;
  if(field_accepted!=null) {
    accepted=new Array(card_types[field_accepted.value]);
  }
  if (isCreditCard(cc,accepted)) {
    return true;
  } else {
{/literal}
	alert("{$lng.txt_cc_number_invalid}");
{literal}
	field_cc.focus();
	field_cc.select();
	return false;
  }
}


</script>
{/literal}

