<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_processing.php,v 1.16.2.3 2003/02/07 14:59:55 svowl Exp $
#
# For explanation of cc processing please refer to 
# X-Cart developer's documentation
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

#
# Generate module files array
#

$cc_module_files = func_query("select module_name, disable_ccinfo from $sql_tbl[ccprocessors] order by module_name");
$ch_module_files = func_query("select module_name, disable_chinfo from $sql_tbl[chprocessors] order by module_name");

$smarty->assign("cc_modules",$cc_module_files);
$smarty->assign("ch_modules",$ch_module_files);
$smarty->assign("main","cc_processing");

#
# Setup paramxx in ccprocessors table
#
if ($REQUEST_METHOD=="POST" && empty($mode)) {
	include "./safe_mode.php";

	foreach($HTTP_POST_VARS as $key=>$value)
		if(!empty($cc_processor))
			db_query("update $sql_tbl[ccprocessors] set $key='$value' where module_name='".stripslashes($cc_processor)."'");
		elseif(!empty($ch_processor))
			db_query("update $sql_tbl[chprocessors] set $key='$value' where module_name='$ch_processor'");
	$smarty->assign("main","cc_processing_message");
}

#
# $cc_processing_module
#
if ($mode=="update") {
	include "./safe_mode.php";

	if(!empty($cc_processor))
	{
		$disablecc = "N";
		foreach($cc_module_files as $k => $v)
			if($v["module_name"]==$cc_processor)
				$disablecc = $v["disable_ccinfo"];

		db_query("update $sql_tbl[config] set value='$cc_processor' where name='active_payment_processor'");
		db_query("update $sql_tbl[config] set value='".$disablecc."' where name='disable_ccinfo'");

		$config["active_payment_processor"] = $cc_processor;
		$config["disable_ccinfo"] = $disablecc;
		$cc_processing_module = func_query_first("select * from $sql_tbl[ccprocessors] where module_name='$cc_processor'");
	}
	elseif(!empty($ch_processor))
	{
       $disablech = "N";
        foreach($ch_module_files as $k => $v)
            if($v["module_name"]==$ch_processor)
                $disablech = $v["disable_chinfo"];

        db_query("update $sql_tbl[config] set value='$ch_processor' where name='active_checkpayment_processor'");
        db_query("update $sql_tbl[config] set value='".$disablech."' where name='disable_chinfo'");

        $config["active_checkpayment_processor"] = $ch_processor;
        $config["disable_chinfo"] = $disablech;
        $ch_processing_module = func_query_first("select * from $sql_tbl[chprocessors] where module_name='$ch_processor'");
	}
	elseif(isset($ch_processor))
	{
		db_query("update $sql_tbl[config] set value='' where name='active_checkpayment_processor'");
		db_query("update $sql_tbl[config] set value='N' where name='disable_chinfo'");
		$config["active_checkpayment_processor"] = "";
		$config["disable_chinfo"] = "N";
	}
	elseif(isset($cc_processor))
	{
		db_query("update $sql_tbl[config] set value='' where name='active_payment_processor'");
		db_query("update $sql_tbl[config] set value='N' where name='disable_ccinfo'");
		$config["active_payment_processor"] = "";
		$config["disable_ccinfo"] = "N";
	}
}

$smarty->assign("config",$config);

if($cc_processing_module) {
	$smarty->assign("module_data",$cc_processing_module);
	$smarty->assign("processing_module",$cc_processing_module["template"]);
}
elseif($ch_processing_module) {
	$smarty->assign("module_data",$ch_processing_module);
	$smarty->assign("processing_module",$ch_processing_module["template"]);
}
else
	$smarty->assign("processing_module","admin/main/cc_processing.tpl");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");

?>
