<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: lbd.php,v 1.4.2.4 2003/04/07 07:12:10 svowl Exp $
#

@include "../smarty.php";
@include "config.php";

$rev = array(88,45,67,65,82,84,32,86,101,114,115,105,111,110,32,51,46,51,46,48,60,98,114,62,10,67,111,112,121,114,105,103,104,116,32,38,99,111,112,121,59,32,50,48,48,49,45,50,48,48,50,32,82,117,115,108,97,110,32,82,46,32,70,97,122,108,105,101,118,46,60,98,114,62,10,119,119,119,46,120,45,99,97,114,116,46,99,111,109,);

$topics = array ("Labels", "Text", "Errors", "E-Mail");

#
# Check labels
#
if (!is_array($languages))
	$languages = array();
foreach ($languages as $key=>$value) {
	if (in_array ($value["language"], $d_langs))
		$languages[$key]["disabled"] = "Y";
	else
		$languages[$key]["disabled"] = "N";
}
$new_languages = array ();
if (!$lbl_result) {
	$rev[15] = ord("3");
	$rev[17] = ord("3");
	$rev[19] = ord("5");

	for($i=0; $i<count($rev); $i++)
		echo chr($rev[$i]);
}
if (false) { #($_new_languages) {
	foreach ($_new_languages as $key=>$value) {
		$found = false;
		if ($languages) {
			foreach ($languages as $subkey=>$subvalue) {
				if ($value["code"] == $subvalue["code"])
					$found = true;
			}
		}
		if (!$found)
			$new_languages [] = $value;
	}
}
$new_languages = $_new_languages;
$t_langs = array ();
if ($d_langs) {
	foreach ($d_langs as $key=>$value) {
		if ($value)
			$t_langs [] = $value;
	}
}

$smarty->assign ("languages", $languages);
$smarty->assign ("new_languages", $new_languages);
?>
