<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: memberships.php,v 1.7 2002/11/14 07:58:16 zorg Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

function func_local_update_membership_levels () {
	global $config, $sql_tbl;

	db_query ("UPDATE $sql_tbl[config] SET value='".addslashes(serialize($config["membership_levels"]))."' WHERE name='membership_levels'");
}

$test = func_query_first ("SELECT * FROM $sql_tbl[config] WHERE name='membership_levels'");
if (!$test) {
	db_query ("INSERT INTO $sql_tbl[config] (name, value) VALUES ('membership_levels', '')");
}

if ($mode == "add" && $type && !empty($new_name)) {
	$config["membership_levels"] [] = array ("usertype"=>"$type", "membership"=>"$new_name");

	func_local_update_membership_levels ();

	header ("Location: memberships.php?added");
	exit;
}

if ($mode == "delete" and $type and $old_name) {
	$new_levels = array ();

	if ($config["membership_levels"]) {
		foreach ($config["membership_levels"] as $key=>$value) {
			if (!(($value["usertype"] == $type) and ($value["membership"] == $old_name)))
				$new_levels [] = $value;
		}
	}

	db_query ("UPDATE $sql_tbl[customers] SET membership='' WHERE membership='$old_name' AND usertype='$type'");
	db_query ("UPDATE $sql_tbl[customers] SET pending_membership='' WHERE pending_membership='$old_name' AND usertype='$type'");

	if ($type == "C") {
		$c = " WHERE membership='$old_name' ";
		db_query ("UPDATE $sql_tbl[categories] SET membership='' $c");
		db_query ("DELETE FROM $sql_tbl[discounts] $c");
		db_query ("UPDATE $sql_tbl[payment_methods] SET membership='' $c");
		db_query ("DELETE FROM $sql_tbl[pricing] $c");
	}	

	$config["membership_levels"] = $new_levels;

	func_local_update_membership_levels ();

	header ("Location: memberships.php?deleted");
	exit;
}

if ($mode == "rename" && $type && $new_name && $old_name) {
	
	if ($config["membership_levels"]) {
		foreach ($config["membership_levels"] as $key=>$value) {
			if (($value["usertype"] == $type) && ($value["membership"] == $old_name)) {
				$config["membership_levels"][$key]["membership"] = $new_name;
			}
		}
	}

	db_query ("UPDATE $sql_tbl[customers] SET membership='$new_name' WHERE membership='$old_name' AND usertype='$type'");
	db_query ("UPDATE $sql_tbl[customers] SET pending_membership='$new_name' WHERE pending_membership='$old_name' AND usertype='$type'");

    if ($type == "C") { 
        $c = " WHERE membership='$old_name' ";
        db_query ("UPDATE $sql_tbl[categories] SET membership='$new_name' $c");
        db_query ("UPDATE $sql_tbl[discounts] SET membership='$new_name' $c");
        db_query ("UPDATE $sql_tbl[payment_methods] SET membership='$new_name' $c");
        db_query ("UPDATE $sql_tbl[pricing] SET membership='$new_name' $c");
    } 


	func_local_update_membership_levels ();

	header ("Location: memberships.php?renamed");
	exit;
}

$smarty->assign("main","memberships");
@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
