<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: users.php,v 1.21.2.2 2003/04/04 06:26:48 svowl Exp $
#

require "../smarty.php";
require "../config.php";
require "./auth.php";
require "../include/security.php";

if(strstr($QUERY_STRING,"substring")) {
#
# Generate users list
#

$objects_per_page = $config["General"]["users_per_page_admin"];

#
# Set % as reseved name for list mode of search script
#
    $substring_condition = ($substring=="%"?"":" and ($sql_tbl[customers].login like '%$substring%' or $sql_tbl[customers].firstname like '%$substring%' or $sql_tbl[customers].lastname like '%$substring%')");
	if ($membership == "pending_membership") $membership_condition = " and ($sql_tbl[customers].membership <> $sql_tbl[customers].pending_membership)";
	elseif ($membership != "") $membership_condition = " and ($sql_tbl[customers].membership = '$membership')";
	else $membership_condition = "";
	
	if ($registration_type=="1") $registration_condition =" and $sql_tbl[customers].login like '$anonymous_username_prefix%' ";
	elseif ($registration_type=="2") $registration_condition =" and $sql_tbl[customers].login not like '$anonymous_username_prefix%' ";
	else $registration_condition = "";

	$search_query = "select $sql_tbl[customers].*, count($sql_tbl[products].productid) as products_in_stock from $sql_tbl[customers] left join  $sql_tbl[products] on $sql_tbl[products].provider=$sql_tbl[customers].login where $sql_tbl[customers].usertype='$usertype'".$substring_condition.$membership_condition. $registration_condition." group by $sql_tbl[customers].login";

	$users = func_query($search_query);

	$total_items = count($users);

    $total_nav_pages = ceil($total_items/$objects_per_page)+1;

    require "../include/navigation.php";

	if (is_array($users))
		$users = array_slice($users, $first_page, $objects_per_page);;

	if ($users) 
		foreach($users as $k=>$v) {
			if ($v["last_login"])
				$users[$k]["last_login"] += $config["General"]["timezone_offset"];
			$users[$k]["first_login"] += $config["General"]["timezone_offset"];
		}
		
    foreach($HTTP_GET_VARS as $k=>$v) {
            $ret_str .= "&$k=$v";
    }
    $ret_str = ereg_replace("^&","",$ret_str);

    $smarty->assign("navigation_script","users.php?$ret_str");

	$smarty->assign("users",$users);
	$smarty->assign("registration_type",$registration_type);
	$smarty->assign("total_items",$total_items);
	$smarty->assign("first_item", $first_page+1);
	$smarty->assign("last_item", min($first_page+$objects_per_page, $total_items));
}

#
# Assign Smarty variables and show template
#

$smarty->assign("main","users");

@include "../modules/gold_display.php";
$smarty->display("admin/home.tpl");
?>
