<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: payment_method.php,v 1.13.2.7 2003/03/17 07:06:20 svowl Exp $
#
# CC processing payment module
#
require "../smarty.php";
require "../config.php";
require "../customer/auth.php";

session_register("cart");
session_register("order_secureid");
session_register("ship_to");


if ($HTTP_POST_VARS["action"] == "place_order") {
#
# Check if products in cart is in stock yet
#
	$products = func_products_in_cart($cart, $userinfo["membership"]);

	if (is_array($products)) {
		if (count($products) < count($cart["products"])) {
			foreach($products as $k=>$v)
				$prodids[] = $v["productid"];
			if (is_array($prodids)) {
				foreach($cart["products"] as $k=>$v)
					if (in_array($v["productid"], $prodids))
						$cart_prods[$k] = $v;
				$cart["products"] = $cart_prods;
			}
			else
				$cart = "";
			header("Location: ../customer/error_message.php?product_in_cart_expired");
			exit();
		}
	}
}

if(empty($ship_to))
{	$ship_to="";
	if ($Ship_To_name !="") $ship_to.="\nShip to: ".$Ship_To_name;
}


#
# Get userinfo and cart products and output an error if empty
#
if (!empty($login)) $userinfo = func_userinfo($login, $login_type);

if (empty($userinfo) || func_is_cart_empty($cart)) {
	if($cc_2checkout_defined)
		relocate("/customer/error_message.php?error_ccprocessor_baddata");
	else
		header("Location: ../customer/error_message.php?error_ccprocessor_baddata");
	exit;
}

$userinfo = array_merge($userinfo,$HTTP_POST_VARS);

#
# Discount coupons (needed for func_place_order)
#
#if($active_modules["Discount_Coupons"])
	#include "../modules/discount_coupons.php";

?>
