<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: process_product.php,v 1.8 2002/11/14 07:58:19 zorg Exp $
#

$product_info = func_select_product($productid, $user_account['membership']);

if ($mode == "update") {
	if ($product_avail) {
		foreach ($product_avail as $key=>$value)
			db_query ("UPDATE $sql_tbl[products] SET avail='$value' WHERE productid='$key' $provider_condition");
    }

	if ($product_price) {
		foreach ($product_price as $key1 => $value)
			db_query ("UPDATE $sql_tbl[pricing] SET price='$value' WHERE productid='$key1' AND quantity='1' AND membership=''");
	}

	if ($product_orderby) {
		foreach ($product_orderby as $key1 => $value)
			db_query ("UPDATE $sql_tbl[products] SET orderby='$value' WHERE productid='$key1'");
	}

	header ("Location: search.php?substring=$substring&search_category=$search_category&search_productid=$search_productid&updated");
	exit;
}

if ($mode == "clone") {
	if ($product_info)
		$new_pid = func_clone_product($productid);

	header("Location: product_modify.php?productid=$new_pid");
	exit;
}
elseif($mode=="details") {
#
# Show product details
#
	header("Location: product.php?productid=$productid");
	exit;
}
elseif($mode=="modify") {
#
# Modify product
#
	header("Location: product_modify.php?productid=$productid");
	exit;
}
elseif($mode=="delete") {
#
# Delete product
#   
	if($confirmed=="Y") {
		if($product_info) {
#
# Delete product from database
#
            func_delete_product($productid);
        }
		$smarty->assign("main","product_delete_message");

    } else {

		$smarty->assign("main","product_delete_confirmation");
		$smarty->assign("product",$product_info);

    }
}
?>
