<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 RRF.ru development. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The RRF.RU DEVELOPMENT forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE RRF.RU DEVELOPMENT TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE RRF.RU DEVELOPMENT TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is RRF.ru development.           |
| Portions created by RRF.ru development are Copyright (C) 2001-2002          |
| RRF.ru development. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: subscription_modify.php,v 1.4 2002/12/05 13:10:39 alfiya Exp $
#

$subscription_periods = array("Annually"=>"365", "Quarterly"=>"90", "Monthly"=>"30", "Weekly"=>"7", "By Period"=>"45");

$smarty->assign("subscription_periods",$subscription_periods);
            
if ($REQUEST_METHOD=="POST" && $mode=="subscription_modify" && !empty($product_info)) {

    $res = db_query("select * from $sql_tbl[subscriptions] where productid='$productid'");

    if ($subscription[pay_period_type] == 'By Period') {
        $pay_period_type = $pay_period;
    }
    else {
        $pay_period_type = $subscription[pay_period_type];
    }
    
    if (!mysql_num_rows($res)) { # Insert subscription info if it not exist
        db_query("insert into $sql_tbl[subscriptions](productid) values('$productid')");
    }
    
    db_query("update $sql_tbl[subscriptions] set pay_period_type='$pay_period_type', price_period='$subscription[price_period]', oneday_price='$subscription[oneday_price]', days_as_period='$subscription[days_as_period]' where productid='$productid'");

    header("Location: product_modify.php?productid=$productid#subscription");
    exit;
} elseif ($REQUEST_METHOD=="POST" && $mode=="subscription_delete" && !empty($product_info)) {

    db_query("delete from $sql_tbl[subscriptions] where productid='$productid'");
    header("Location: product_modify.php?productid=$productid#subscription");
    exit;
}


$subscription=func_query_first("select * from $sql_tbl[subscriptions] where productid='$productid'");

if (is_numeric($subscription[pay_period_type])) {
    $pay_period = $subscription[pay_period_type];
    $subscription[pay_period_type] = "By Period";
}   

if ($subscription[pay_period_type] == "Annually") {
    $days_in_year = (checkdate(2,29,date("Y"))?366:365);
    if (date("z") >= $subscription[days_as_period])
        $subscription[days_remain] = 0;
    else
        $subscription[days_remain] = $days_in_year - date("z");
} 
elseif ($subscription[pay_period_type] == "Quarterly") {
    if (date("m") >= 10) {
        $days_in_quarter = 92;
        $days_max = date("z",mktime(0,0,0,12,31,date("Y")));
    } elseif (date("m") >= 7) {
        $days_in_quarter = 92;
        $days_max = date("z",mktime(0,0,0,9,30,date("Y")));
    } elseif (date("m") >= 4) {
        $days_in_quarter = 91;
        $days_max = date("z",mktime(0,0,0,6,30,date("Y")));
    } else {
        $days_in_quarter = 62 + checkdate(2,29,date("Y"))?29:28;
        $days_max = date("z",mktime(0,0,0,3,31,date("Y")));
    }
    $cday = $days_max - date("z");
    
    if ($cday >= $subscription[days_as_period])
        $subscription[days_remain] = 0;
    else
        $subscription[days_remain] = $days_in_quarter - $cday;
}
elseif ($subscription[pay_period_type] == "Monthly") {
    if (checkdate(date("m"),31,date("Y")))
        $days_in_month = 31;
    elseif (checkdate(date("m"),30,date("Y")))
        $days_in_month = 30;
    elseif (checkdate(date("m"),29,date("Y")))
        $days_in_month = 29;
    else
        $days_in_month = 28;
    if (date("j") >= $subscription[days_as_period])
        $subscription[days_remain] = 0;
    else
        $subscription[days_remain] = $days_in_month - date("j");
}
elseif ($subscription[pay_period_type] == "Weekly") {
    $days_in_week = 7;
    if (date("w") >= $subscription[days_as_period])
        $subscription[days_remain] = 0;
    else
        $subscription[days_remain] = $days_in_week - date("w");
}
elseif ($subscription[pay_period_type] == "By Period") {
    $subscription[days_remain] = $pay_period;    #    ˮ ŵ
}

$smarty->assign("pay_period", $pay_period);
$smarty->assign("subscription", $subscription);
?>
