<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 RRF.ru development. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The RRF.RU DEVELOPMENT forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE RRF.RU DEVELOPMENT TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE RRF.RU DEVELOPMENT TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is RRF.ru development.           |
| Portions created by RRF.ru development are Copyright (C) 2001-2002          |
| RRF.ru development. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: subscriptions.php,v 1.4.2.1 2003/04/07 06:00:52 svowl Exp $
#

function get_subscription_info($login) {
	global $sql_tbl;

    $query = "select sc.*,p.product,o.date,o.status,s.* from $sql_tbl[subscription_customers] as sc, $sql_tbl[products] as p, $sql_tbl[orders] as o, $sql_tbl[subscriptions] as s where sc.productid=p.productid and sc.orderid=o.orderid and sc.productid=s.productid and sc.login='$login'";
//    echo "$query<br>";
    $subscription=func_query($query);
    return $subscription;

}

$sub_status = array("Active","Unsubscribed","Disabled");
    
if ($current_area != "C") {

    if ($REQUEST_METHOD == "POST") {

        if ($charge == "Y") {
            header("Location: ../admin/pay_subscriptions.php?subscriptionid=$subscriptionid");
            exit();
        }
        
        $query = "update $sql_tbl[subscription_customers] set subscription_status='$subscription_status' where subscriptionid='$subscriptionid'";
        db_query($query);
        header("Location: orders.php?$QUERY_STRING");
        exit();
    }
    
    if ($action == "listall") {
        $search_productid = $search_producttitle = $search_customerlogin = "";
        $action = "search";
    }
    if ($action == "search") {
    
        $productid_condition = (!empty($search_productid)?" and s.productid='$search_productid'":"");
        $producttitle_condition = (!empty($search_producttitle)?" and p.product like '%$search_producttitle%'":"");
        $customerlogin_condition = (!empty($search_customerlogin)?"and sc.login like '%$search_customerlogin%'":"");

        
        $query = "select s.*, p.product from $sql_tbl[subscriptions] as s, $sql_tbl[products] as p where s.productid=p.productid".$productid_condition.$producttitle_condition;
        $products = func_query($query);
    
        if ($products)
            foreach($products as $k=>$product) {

                $pay_dates = Unserialize($product["pay_dates"]);
                $products[$k]["next_pay_date"] = "undefined";
                if ($pay_dates)
                    foreach($pay_dates as $pay_date)
                        if ($pay_date >= mktime(0,0,0,date("m"),date("d"),date("Y"))) {
                            $products[$k]["next_pay_date"] = date("m/d/Y", $pay_date);
                            break;
                        }
                $query = "select count(*) from $sql_tbl[subscription_customers] where productid='$product[productid]'";
                $res = func_query_first($query);
                $products[$k][subscribers_num] = $res[0];
            
                $query = "select sc.*, o.status, o.date from $sql_tbl[subscription_customers] as sc, $sql_tbl[orders] as o where sc.orderid=o.orderid and sc.productid='$product[productid]' ".$customerlogin_condition." order by sc.login";
                $customers = func_query($query);
                if ($customers)
                foreach ($customers as $k1=>$customer) {
                    $query = "select status from $sql_tbl[orders] where orderid='$customer[last_payed_orderid]'";
                    $res = func_query_first($query);
                    $customers[$k1]["last_payed_order_status"] = $res[0];
                    $customers[$k1]["date"] = date("m/d/Y", $customer["date"]+$config["General"]["timezone_offset"]);
                    $customers[$k1]["last_payed_date"] = date("m/d/Y", $customer["last_payed_date"]+$config["General"]["timezone_offset"]);
                }
                $products[$k]["customers"] = $customers;
            }
        if ($products)
            foreach ($products as $product) {
//                if ($product[customers])
                    $subscriptions[] = $product; 
            }
    }   
    $smarty->assign("products_num", !empty($action)?count($subscriptions):"No");
    $smarty->assign("sub_status", $sub_status);
}
else {

    if ($REQUEST_METHOD == "POST") {

        if ($unsubscribe_info)
            foreach($unsubscribe_info as $k=>$v) {
                $query = "update $sql_tbl[subscription_customers] set subscription_status='Unsubscribed' where subscriptionid='$v'";
                db_query($query);
            }
        $query = "select count(*) from $sql_tbl[subscription_customers] where login='$login' and subscription_status!='Unsubscribed'";
        $subscription=func_query_first($query);
        if ($subscription[0]>0)
            header("Location: orders.php?$QUERY_STRING");
        else
            header("Location: home.php");
        exit();
    }

    $subscriptions = get_subscription_info($login);

    for ($i = 0; $i < count($subscriptions); $i++) {

        $subscriptions[$i]["date"] = date("m/d/Y", $subscriptions[$i]["date"]);
        $subscriptions[$i]["last_payed_date"] = date("m/d/Y", $subscriptions[$i]["last_payed_date"]);
        $query = "select status from $sql_tbl[orders] where orderid='".$subscriptions[$i]["last_payed_orderid"]."'";
        $res = func_query_first($query);
        $subscriptions[$i][last_payed_orderstatus] = $res[0];
        $subscriptions[$i]["next_pay_date"] = "undefined";
        $pay_dates = Unserialize($subscriptions[$i]["pay_dates"]);
		if ($pay_dates)
            foreach($pay_dates as $pay_date)
                if ($pay_date >= mktime(0,0,0,date("m"),date("d"),date("Y"))) {
                    $subscriptions[$i]["next_pay_date"] = date("m/d/Y", $pay_date);
                        break;
                }
    }
}


$smarty->assign("main","subscriptions");
$smarty->assign("subscriptions_info",$subscriptions);

?>
