<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: wishlist.php,v 1.9.2.2 2003/02/10 11:03:35 svowl Exp $
#

if ($mode == "add2wl" && $productid) {
#
# Add to wish list
#
        db_query("insert into $sql_tbl[wishlist] (login, productid, amount) values ('$login', '$productid', '$amount')");
        header("Location: cart.php?mode=wishlist");
}
elseif ($mode == "wldelete" && $productid) {
#
# Delete from wish list
#
        db_query("delete from $sql_tbl[wishlist] where login='$login' and productid='$productid'");
        header("Location: cart.php?mode=wishlist");
        exit;
}
elseif ($mode == "wlclear") {
#
# Clear wish list
#
        db_query("delete from $sql_tbl[wishlist] where login='$login'");
        header("Location: cart.php?mode=wishlist");
        exit;
}
elseif ($mode == "wishlist") {
#
# Obtain wishlist from database
#
	$wl_data = func_query("select productid, amount from $sql_tbl[wishlist] where login='$login'");

	$membership = $user_account['membership'];
	if($wl_data)
		foreach($wl_data as $wl_data_entry) {
			$amount = $wl_data_entry["amount"];
			$products_array = func_query_first("select $sql_tbl[products].*, min($sql_tbl[pricing].price) as price, $amount as amount, $amount*price as total from $sql_tbl[products], $sql_tbl[pricing] where $sql_tbl[pricing].productid=$sql_tbl[products].productid and $sql_tbl[pricing].quantity<=$amount and ($sql_tbl[pricing].membership='$membership' or $sql_tbl[pricing].membership='') and $sql_tbl[products].productid='$wl_data_entry[productid]' and $sql_tbl[products].avail>='$amount' group by $sql_tbl[products].productid order by $sql_tbl[pricing].quantity desc");

#
# Get delivery options and add to WL products array
#
			if ($products_array) {
				$products_array["delivery"] = func_select_product_delivery($wl_data_entry["productid"]);
				$wl_products[] = $products_array;
			}
		}

		$smarty->assign("wl_products",$wl_products);
		$smarty->assign("main","wishlist");

} elseif (!empty($login) and ($mode == 'send_friend') and (!empty ($friend_email))) {
	$product = func_select_product($productid, $user_account['membership']);
	$mail_smarty->assign ("product", $product);
	$mail_smarty->assign ("userinfo", $userinfo);
	func_send_mail ($friend_email, "mail/wishlist_send2friend_subj.tpl", "mail/wishlist_send2friend.tpl", $userinfo["email"], false);
	header ("Location: cart.php?mode=wishlist&send2friend=success");
	exit;
} elseif (!empty($login) and ($mode == 'send_friend') and (empty($friend_email))) {
	header ("Location: cart.php?mode=wishlist&send2friend=failed");
	exit;
}

?>
