<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_bank.php,v 1.3 2002/12/10 08:57:10 sdg Exp $
#

# this line protect us from empty orders
$bill_error=true; 

#
# Finish transaction
#

if ($REQUEST_METHOD == "GET" and $HTTP_GET_VARS["IOC_merchant_shopper_id"])
{

	include "../include/payment_method.php";
	$session = $HTTP_GET_VARS ["IOC_merchant_shopper_id"];
	$response = $HTTP_GET_VARS ["IOC_response_code"];
	session_id($session);
	session_register("cart");
	session_register("order_secureid");
	session_register("userinfo");
	session_register("secure_oid");

	if(!$response)
	{
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);

		#
		# Remove all from cart
		#
		$cart="";
		header("Location: ../customer/cart.php?mode=order_message&orderids=$_orderids");

		exit;
	}
	else
	{
		func_change_order_status($secure_oid, "D");
		$error=array(
		"-1" => "Authorization system not responding. Order accepted in Faith mode.",
		"1" => "Authorization system not responding. Please retry transaction.",
		"2" => "Authorization declined. Please retry with different credit card.",
		"3" => "No response from issuing institution. Order not accepted. Please retry.",
		"4" => "Authorization declined. Invalid credit card. Please retry with different credit card.",
		"5" => "Authorization declined. Invalid amount. Please retry.",
		"6" => "Authorization declined. Expired credit card. Please retry with different credit card.",
		"7" => "Authorization declined. Invalid transaction. Please retry with different credit card.",
		"8" => "Received unexpected reply. Order not accepted. Please retry.",
		"9" => "Authorization declined. Duplicate transaction.",
		"10" => "Other issue. Order not accepted. Please retry."
		);
		header("Location: ../customer/error_message.php?error=error_ccprocessor_error&bill_message=".urlencode($error[$response]."<br>"));
		exit;
	}	
}

$id = $module_params ["param01"];
$cvv = $module_params ["param02"];

session_register("order_secureid");

$expiry_month = substr($userinfo["card_expire"],0,2);
$expiry_year = substr($userinfo["card_expire"],2,2);;

?>
<html>
<body onLoad="document.process.submit();">
  <form action="https://cart.bamart.com/payment.mart?i=<? echo rand();?>" method=POST name=process>
    <INPUT type=hidden name=ioc_merchant_id value="<? echo $id; ?>">
	<INPUT type=hidden name=ioc_merchant_shopper_id value="<? echo session_id(); ?>">
	<INPUT type=hidden name=ioc_merchant_order_id value="<? echo func_get_urlencoded_orderids ($secure_oid); ?>">
	<INPUT type=hidden name=ioc_order_total_amount value="<? echo $cart["total_cost"]; ?>">
  	<INPUT type=hidden name=ecom_payment_card_name value="<? echo "$userinfo[firstname] $userinfo[lastname]"; ?>">
	<INPUT type=hidden name=ecom_payment_card_number value="<? echo $userinfo[card_number]; ?>">
	<INPUT type=hidden name=ecom_payment_card_expdate_month value="<? echo (0+$expiry_month); ?>">
	<INPUT type=hidden name=ecom_payment_card_expdate_year value="<? echo (2000+$expiry_year); ?>">
	<INPUT type=hidden name=ioc_cvv_indicator value="<? echo $cvv; ?>">
	<INPUT type=hidden name=ecom_payment_card_verification value="<? echo $userinfo["card_cvv2"]; ?>">
  	<INPUT type=hidden name=ecom_billto_postal_name_first value="<? echo $userinfo[firstname]; ?>">
  	<INPUT type=hidden name=ecom_billto_postal_name_last value="<? echo $userinfo[lastname]; ?>">
	<INPUT type=hidden name=ecom_billto_postal_street_line1 value="<? echo $userinfo[b_address]; ?>">
	<INPUT type=hidden name=ecom_billto_postal_city value="<? echo $userinfo[b_city]; ?>">
	<INPUT type=hidden name=ecom_billto_postal_stateprov value="<? echo $userinfo[b_state]; ?>">
	<INPUT type=hidden name=ecom_billto_postal_countrycode value="<? echo $userinfo[b_country]; ?>">
	<INPUT type=hidden name=ecom_billto_postal_postalcode value="<? echo $userinfo[b_zipcode]; ?>">
	<INPUT type=hidden name=ecom_billto_online_email value="<? echo $userinfo[email]; ?>">
	<INPUT type=hidden name=ecom_billto_telecom_phone_number value="<? echo $userinfo[phone]; ?>">
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>Bank of America</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<? exit; ?>
