<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY Ruslan R. Fazliev ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL Ruslan R. Fazliev OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_paysystems.php,v 1.3.2.5 2003/04/07 06:44:24 svowl Exp $
#

# this line protect us from empty orders
$bill_error=true; 
$pp_companyid = $module_params["param01"];

#
# Finish transaction
#

if ($orderid && $cc_status=="pass")
{
	require "../smarty.php";
	require "../config.php";

	session_id($option1);
	session_register("cart");
	session_register("secure_oid");

	if (!defined("GET_LANGUAGE")) {
        $current_area = "C";
        include "../include/get_language.php";
    }

	if (!empty($login)) $userinfo = func_userinfo($login, $login_type);

	func_change_order_status($secure_oid, "P");
	$_orderids = func_get_urlencoded_orderids ($secure_oid);
	session_unregister("secure_oid");

	$cart="";
	header("Location: ../customer/cart.php?XCARTSESSID=".$option1."&mode=order_message&orderids=".$_orderids);
	exit;
}
elseif($cc_status!="pass" && $cc_status)
{
	require "../smarty.php";
	require "../config.php";

    if (!defined("GET_LANGUAGE")) {
        $current_area = "C";
        include "../include/get_language.php";
    }

	func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
	header("Location: ../customer/error_message.php?XCARTSESSID=".$option1."&error=error_ccprocessor_error&bill_message=".urlencode("Order was declined."));
	exit;
}
else
{	$string = array();
	$prods = func_products_in_cart ($cart, $userinfo[membership]);
	foreach ($prods as $product)
		$string [] = " - ".$product[product]." (".$product[price]." x ".$product[amount].")";


	$returnurl="http://".$xcart_http_host.$xcart_web_dir."/payment/cc_paysystems.php";
 
?>
<html>
<body onLoad="document.process.submit();">
  <form action="https://secure.paysystems1.com/cgi-v310/payment/onlinesale-tpppro.asp" method=POST name=process>
    <INPUT type=hidden name=companyid value="<? echo $pp_companyid; ?>">
    <INPUT type=hidden name=total value="<? echo $cart["total_cost"]; ?>">
    <INPUT type=hidden name=product1 value="<? echo join("<br>",$string); ?>">
	<INPUT type=hidden name=b_firstname value="<? echo $userinfo[firstname]; ?>">
	<INPUT type=hidden name=s_firstname value="<? echo $userinfo[firstname]; ?>">
	<INPUT type=hidden name=b_middlename value="">
	<INPUT type=hidden name=s_middlename value="">
	<INPUT type=hidden name=b_lastname value="<? echo $userinfo[lastname]; ?>">
	<INPUT type=hidden name=s_lastname value="<? echo $userinfo[lastname]; ?>">
	<INPUT type=hidden name=email value="<? echo $userinfo[email]; ?>">
	<INPUT type=hidden name=b_address value="<? echo $userinfo[b_address]; ?>">
	<INPUT type=hidden name=s_address value="<? echo $userinfo[s_address]; ?>">
	<INPUT type=hidden name=b_city value="<? echo $userinfo[b_city]; ?>">
	<INPUT type=hidden name=s_city value="<? echo $userinfo[s_city]; ?>">
	<INPUT type=hidden name=b_country value="<? echo $userinfo[b_country]; ?>">
	<INPUT type=hidden name=s_country value="<? echo $userinfo[s_country]; ?>">
	<INPUT type=hidden name=b_zip value="<? echo $userinfo[b_zipcode]; ?>">
	<INPUT type=hidden name=s_zip value="<? echo $userinfo[s_zipcode]; ?>">
	<INPUT type=hidden name=b_state value="<? echo $userinfo[b_state]; ?>">
	<INPUT type=hidden name=s_state value="<? echo $userinfo[s_state]; ?>">
	<INPUT type=hidden name=b_tel value="<? echo $userinfo[phone]; ?>">
	<input type=hidden name=delivery value="N">
	<input type=hidden name=formget value="N">
	<input type=hidden name=option1 value="<? echo session_id(); ?>">
	<INPUT type=hidden name=redirect value="<? echo $returnurl; ?>">
	<INPUT type=hidden name=redirectfail value="<? echo $returnurl; ?>">
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>PaySystems</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<? 
	exit;
}
?>
