<?
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2002 Ruslan R. Fazliev. All rights reserved.            |
+-----------------------------------------------------------------------------+
| The Ruslan R. Fazliev forbids, under any circumstances, the unauthorized   |
| reproduction of software or use of illegally obtained software. Making      |
| illegal copies of software is prohibited. Individuals who violate copyright |
| law and software licensing agreements may be subject to criminal or civil   |
| action by the owner of the copyright.                                       |
|                                                                             |
| 1. It is illegal to copy a software, and install that single program for    |
| simultaneous use on multiple machines.                                      |
|                                                                             |
| 2. Unauthorized copies of software may not be used in any way. This applies |
| even though you yourself may not have made the illegal copy.                |
|                                                                             |
| 3. Purchase of the appropriate number of copies of a software is necessary  |
| for maintaining legal status.                                               |
|                                                                             |
| DISCLAIMER                                                                  |
|                                                                             |
| THIS SOFTWARE IS PROVIDED BY THE Ruslan R. Fazliev TEAM ``AS IS'' AND ANY  |
| EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED |
| WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE      |
| DISCLAIMED.  IN NO EVENT SHALL THE Ruslan R. Fazliev TEAM OR ITS           |
| CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       |
| EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         |
| PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; |
| OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    |
| WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     |
| OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF      |
| ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                  |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev.           |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2002          |
| Ruslan R. Fazliev. All Rights Reserved.                                    |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: cc_worldpay.php,v 1.12.2.2 2003/02/13 11:24:27 svowl Exp $
#
if (isset($HTTP_POST_VARS["cartId"]))
    $HTTP_POST_VARS["XCARTSESSID"] = $HTTP_POST_VARS["cartId"];

include_once "../include/payment_method.php";

$base_addr = $http_location;
	
# this line protect us from empty orders
$bill_error=true; 

#
# Finish transaction
#

if ($REQUEST_METHOD == "POST")
{
	if ($transStatus && $transStatus == "C")
	{
		func_change_order_status($secure_oid, "F");session_unregister("secure_oid");
?>
<HEAD>
<TITLE>Your order has failed</TITLE>
<SCRIPT language="javascript" type="text/javascript">
    setTimeout('RelocateToXcartError()', 5);
    function RelocateToXcartError(){
    document.location = '<?echo "$base_addr/customer/error_message.php?error_ccprocessor_error";?>';
    }
</SCRIPT>
</HEAD>
        <BODY>
        <CENTER>
        <H3>Your order has failed:</H3>
        <BR>
        <BR>
        <H4>You will be relocated back to shop in 5 seconds</H4>
        <BR>
        <BR>
        <A href=<?echo"$base_addr/customer/error_message.php?error_ccprocessor_error";?>Click this link to
go to the shop immediately</A>
        <BR>
        </CENTER>
        </BODY>
<?		
		exit;
	}
	elseif($transStatus && $transStatus == "Y")
	{
		func_change_order_status($secure_oid, "P");
		$_orderids = func_get_urlencoded_orderids ($secure_oid);
		session_unregister("secure_oid");

		#
		# Remove all from cart
		#
		$cart="";
        //Relocate customer to x-cart site
?>

<HEAD>
<TITLE>Your order has been processed</TITLE>
<SCRIPT language="javascript" type="text/javascript">
    setTimeout('RelocateToXcart()', 5);
    function RelocateToXcart(){
    document.location = '<?echo "$base_addr/customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=$XCARTSESSID";?>';
    }
</SCRIPT>
</HEAD>
        <BODY>
        <CENTER>
        <H3>Your order has been successfuly processed:</H3>
        <BR>
        <BR>
        <H4>You will be relocated back to shop in 5 seconds</H4>
        <BR>
        <BR>
        <A href=<?echo"$base_addr/customer/cart.php?mode=order_message&orderids=$_orderids&XCARTSESSID=$XCARTSESSID";?>>Click this link to go to the shop immediately</A>
        <BR>
        </CENTER>
        </BODY>

<?
		exit;
	}
}

$worldpay_login = $module_params["param01"];
$worldpay_currency = $module_params["param02"];
$worldpay_workmode = $module_params["param03"];
session_register("order_secureid");
?>
<html>
<body onLoad="document.process.submit();">
  <form action="https://select.worldpay.com/wcc/purchase" method=POST name=process>
	 <input type=hidden name=instId value="<?echo $worldpay_login;?>">
	 <input type=hidden name=cartId value="<?echo session_id();?>">
	 <input type=hidden name=amount value="<?echo $cart["total_cost"];?>">
	 <input type=hidden name=currency value="<?echo $worldpay_currency;?>">
	 <input type=hidden name=testMode value="<?echo $worldpay_workmode;?>">
	 <input type=hidden name=name value="<?echo addslashes($userinfo["firstname"])." ". addslashes($userinfo["lastname"]);?>">
	 <input type=hidden name=tel value="<?echo $userinfo["phone"];?>">
	 <input type=hidden name=email value="<?echo $userinfo["email"];?>">
	 <input type=hidden name=desc value="<?
					$cart_products = func_products_in_cart($cart, $userinfo["membership"]);
					while (list($key, $cart_product) = each($cart_products))
					{
						$desc.=$cart_product["product"];
					}
					echo $desc;
					?>">
	 <input type=hidden name=address value="<?echo addslashes($userinfo["b_address"])." ".$userinfo["b_city"];?>">
	 <input type=hidden name=postcode value="<?echo $userinfo["b_zipcode"];?>">
	 <input type=hidden name=country value="<?echo $userinfo["b_country"];?>">
	</form>
	<table width=100% height=100%>
	 <tr><td align=center valign=middle>Please wait while connecting to <b>worldpay.com</b> payment gateway...</td></tr>
	</table>
 </body>
</html>
<? exit; ?>
