#!/usr/bin/perl

#
# $Id: mm.pl,v 1.4.4.1 2003/02/12 12:34:10 svowl Exp $
#

push(@INC,".");
require Net::SSLeay;
Net::SSLeay->import ( qw(get_https post_https sslcat make_headers make_form));
#use MD5;


sub urldecode
{
	local($val)=@_;
	$val=~s/\+/ /g;
	$val=~s/%([0-9A-H]{2})/pack('C',hex($1))/ge;
	return $val;
}

$host="secure1.merchantmanager.com";
$script="/ccgateway.asp";
$port="443";

if (($#ARGV+1)==0) 
{
 print <<EOF;
 Usage: mm.pl <parameters> 
 Where parameters is:
 ---- Credit card info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -ccnum         +     Credit card number
     -ccexpdate     +     Credit card expiration date 
     -ccamount      +     Amount
 ---- Merchant's info ----
     Parameter  Required  Description
     ---------  --------  -----------
     -merchantid    +     Merchant's ID 
	 -referer		+	  Referer
     ---------  --------  -----------
     -bname     	+     Client's name
EOF
exit;
}
foreach $item (@ARGV)
{
	$key="";
	$val="";
	($key,$val)=split('=',$item);
	if ($key ne "")
	{
		$val=~ s/\"//; 
		$arg{$key}=$val;
	}
}

if ($arg{'-ccnum'} eq "" or $arg{'-ccnum'}=~ /([a-z]|[A-Z])./ or $arg{'-ccnum'}=~ / ./)
{
	print "2,Invalid '-ccnum' value";
	exit;
}
else
{
	$CC_Num=$arg{'-ccnum'};
}

if ($arg{'-ccexpdate'}=~ /([a-z]|[A-Z])./ or $arg{'-ccexpdate'}=~ / ./ or $arg{'-ccexpdate'} eq "" or length($arg{'-ccexpdate'})!=4)
{
	print "2,Invalid '-ccexpdate' value";
	exit;
}
else
{
	$expmo=substr($arg{'-ccexpdate'},0,2);
	$expye=substr($arg{'-ccexpdate'},2,2);
} 

if ($arg{'-ccamount'} eq "" or $arg{'-ccamount'}=~ /([a-z]|[A-Z])./)
{
	print "2,Invalid '-ccamount' value";
	exit;
}
else
{
	$amount=$arg{'-ccamount'};
}

if ($arg{'-referer'} eq "")
{
	print "2,Invalid '-referer' value";
	exit;
}
else
{
	$referer=$arg{'-referer'};
}


if ($arg{'-merchantid'} eq "")
{   
	print "2,Invalid '-merchantid' value";
	exit;
}
else
{   
	$merchantid=$arg{'-merchantid'};
}

if ($arg{'-bname'} eq "")
{
	print "2,Invalid '-bname' value";
  	exit;
}
else
{
  $bname=$arg{'-bname'};
}

##------------------------------------------------------------------


($page, $response, %reply_headers)=post_https($host, $port, $script,
 make_headers(
  'User-Agent' => 'F-Cart',
  'Referer' => $referer 
 ),
 make_form (
 'REQUESTTYPE' => "APPROVALONLY",
 'MERCHANTID' => $merchantid,
 'AMOUNT' => $amount,
 'CCNUMBER' => $CC_Num,
 'EXPMO' => $expmo,
 'EXPYE' => $expye,
 'bNAME' => $bname
));
@lines=split ('&',$page);

foreach $item (@lines)
{
	($key, $val) = split('=',$item);
	if ($key ne "")
	{
		$val=urldecode($val);
	 	$resp{$key}=$val;	
	}
}

if ($resp{'approved'} eq "Y")
{
	print "1,Successsfully processed";
}
if ($resp{'approved'} eq "N")
{
	print "2,".$resp{'msg'};
}

