<?
#
# $Id: intershipper.php,v 1.13.2.3 2003/02/07 06:56:50 basil Exp $
#

#
# This function Get shipping rates from Intershipper service
#

function dummy_http_get_request($host, $post_url, $post_str) {
        global $HTTP_COOKIE_VARS;

        $cookie = "";

        $result = "";
        $header_passed = false;

        $fp = fsockopen($host, 80, $errno, $errstr, 30);
        if (!$fp) {
                return array ("", "");
        } else {
                fputs ($fp, "GET $post_url?$post_str HTTP/1.0\r\n");
                fputs ($fp,"\r\n");

                $http_header = array ();
                $http_header["ERROR"] = chop(fgets($fp,4096));
                $cookies = array ();

                while (!feof($fp)) {
                        if (!$header_passed)
                                $line = fgets($fp, 4096);
                        else
                                $result = fread($fp, 65536);

                        if ($header_passed == false && ($line == "\n" || $line == "\r\n")) {
				$header_passed = true;
				continue;
			}

			if ($header_passed == false) {
				$header_line = explode(": ", $line, 2);
				$header_line[0] = strtoupper($header_line[0]);
				$http_header[$header_line[0]] = chop($header_line[1]);

				if ($header_line[0] == 'SET-COOKIE')
					array_push($cookies, chop($header_line[1]));
			}
		}

		fclose($fp);
		}

        func_parse_cookie_array($cookies);

        return array($http_header, $result);
}



function func_shipper($weight,$debug="N") {
        global $allowed_shipping_methods, $intershipper_rates;
        global $login, $login_type;
		global $sql_tbl;
        global $config;

		global $userinfo;

        if ($login && $debug!="Y") {
            $userinfo = func_userinfo($login, $login_type);
        } elseif ($config["General"]["apply_default_country"]=="Y" || $debug=="Y") {
            $userinfo["s_country"] = $config["General"]["default_country"];
			$userinfo["s_state"] = $config["General"]["default_state"];
			$userinfo["s_zipcode"] = $config["General"]["default_zipcode"];
			$userinfo["s_city"] = $config["General"]["default_city"];
		} else return(array());

		$servername="www.intershipper.com";
		$scriptname="/scripts/Intershipper/IntershipperXML.jsp";
		$username=$config["Shipping"]["intershipper_username"];
		$password=$config["Shipping"]["intershipper_password"];

		$params = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='INTERSHIPPER'");

        $wunit=$config["Shipping"]["intershipper_weightunits"];
		if(empty($wunit)) $wunit="LB";
		$wunit=strtoupper(substr($wunit,0,2));

		$delivery=$params["param00"];

		$pickup=explode('|',$params["param01"]);
		$pickup_string="";
		if($pickup) foreach($pickup as $k => $v) {
		  if($k>0) $pickup_string.="&"; 
		  $i=$k+1;
		  $pickup_string.="pickup$i=$v";
		}

        $ZO=$config["Company"]["location_zipcode"];
        $ZD=$userinfo["s_zipcode"];

		$length=(double)$params["param02"];
		$width=(double)$params["param03"];
		$height=(double)$params["param04"];
		$dunit=$params["param05"];

		$packaging=$params["param06"];
		$contents=$params["param07"];

		$codvalue=(double)$params["param08"];
		$insvalue=(double)$params["param09"];

		$allowed_shipping_methods = func_query ("SELECT * FROM $sql_tbl[shipping] WHERE active='Y'");

        $intershipper_rates = array ();

        $carriers = func_query("select distinct(code) from $sql_tbl[shipping] where code!='' and active='Y'");

		$carriers_string="";
		foreach($carriers as $k => $v) {
		  if($k>0) $carriers_string.="&";
		  $i=$k+1;
		  $carriers_string.="carrier$i=$v[code]";
		}

        if(!$carriers || !$username || !$password) return(array());

		$query="TotalPackage=1&userid=$username&password=$password&classofservice1=GND&classofservice2=1DY&classofservice3=2DY&classofservice4=3DY&$carriers_string&delivery=$delivery&$pickup_string&origpostal=$ZO&destpostal=$ZD&boxid1=box1&weight1=$weight&wunit1=$wunit&length1=$length&dunit1=$dunit&width1=$width&height1=$height&packaging1=$packaging&contents1=$contents&codvalue1=$codvalue&insvalue1=$insvalue&Submit=Get+Quote";

		list($header,$result)=dummy_http_get_request($servername,$scriptname,$query);

		$result=eregi_replace("[<][?]xml[ \t][^?]*[?][>]","",$result);


  	    global $intershipper_carrier,$intershipper_service,$intershipper_rate;
		global $tag_name;

		$tag_name="";
  	    $intershipper_carrier=""; $intershipper_service=""; $intershipper_rate="";

	    function startElement($parser, $name, $attrs) { 
		  global $tag_name;
		  $tag_name=$name;
	    }

	    function characterData($parser, $data) { 
  	      global $intershipper_carrier,$intershipper_service,$intershipper_rate;
		  global $tag_name;
          global $allowed_shipping_methods, $intershipper_rates;
		  if($tag_name=="CARRIER") $intershipper_carrier=$data;
		  if($tag_name=="CLASSOFSERVICE") $intershipper_service=$data;
		  if($tag_name=="RATE") $intershipper_rate=(double)$data/100.0;
		  if($intershipper_carrier && $intershipper_service && $intershipper_rate) {
			switch(strtoupper($intershipper_carrier)) {
			  case "U.S. POSTAL SERVICE": $intershipper_carrier="USPS"; break;
			  case "FEDERAL EXPRESS": $intershipper_carrier="FDX"; break;
			  case "UNITED PARCEL SERVICE": $intershipper_carrier="UPS"; break;
			  case "DHL WORLD WIDE EXPRESS": $intershipper_carrier="DHL"; break;
			}

  	    	foreach ($allowed_shipping_methods as $sk=>$sv) {
	      	  if($sv["code"]==$intershipper_carrier && $sv["destination"]=="L" && stristr($sv["shipping"],$intershipper_service)) {
				$intershipper_rates[$sv["subcode"]]=$intershipper_rate;
			  }
	    	}
  	    	$intershipper_carrier=""; $intershipper_service=""; $intershipper_rate="";
		  }
		  $tag_name="";
	    }

	    function endElement($parser, $name) { }

	    $xml_parser = xml_parser_create();
        xml_set_element_handler($xml_parser,"startElement","endElement");
	    xml_set_character_data_handler($xml_parser,"characterData");
	    xml_parse($xml_parser, $result);
	    xml_parser_free($xml_parser); 

		if($intershipper_rates) {
		  $ish_r=$intershipper_rates;
		  $intershipper_rates=array();
		  foreach($ish_r as $k => $v) {
			$intershipper_rates[]= array ("methodid"=>$k, "rate"=>$v);
		  }
		}

		if($debug=="Y") {
		  print("<H1>InterShipper Debug Information</H1>");
		  if($query) {
		    $query=preg_replace("/([&?])(userid[=][^&]*)/i","\\1userid=xxx",$query);
		    $query=preg_replace("/([&?])(password[=][^&]*)/i","\\1password=xxx",$query);
		    print("<H2>InterShipper Request</H2>"); 
		    print("<PRE>"); print(htmlspecialchars($query)); print("</PRE>");
		    print("<H2>InterShipper Responce</H2>"); 
		    print("<PRE>"); print(htmlspecialchars($result)); print("</PRE>");
		    print("<H1>Shipping Rates</H1>");
		  } else {
			print("It seems, you have forgotten to fill in an InterShipper account information.");
		  }
		}

		if($debug=="Y") {
		    foreach($intershipper_rates as $rate) {
		      $method=func_query_first("select shipping from $sql_tbl[shipping] where subcode='$rate[methodid]'");
		      print("<p>$method[shipping] (\$$rate[rate])"); 
		    }
		}

		return $intershipper_rates;

}

?>
