<?
	$pounds=0;
	$ounces=ceil(func_weight_in_grams($weight)/28);
	
	$params = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='USPS'");

	$mailtype=$params["param00"];
	$package_size=$params["param01"];
	$machinable=$params["param02"];
	$container_express=$params["param03"];
	$container_priority=$params["param04"];

	$USPS_FOUND = false;
	foreach ($allowed_shipping_methods as $key=>$value) if ($value["code"] == "USPS") $USPS_FOUND = true;

	$USPS_username=$config["Shipping"]["USPS_username"];
	$USPS_password=$config["Shipping"]["USPS_password"];
	$USPS_servername=$config["Shipping"]["USPS_servername"];

	if (empty($USPS_username) || empty($USPS_password) || empty($USPS_servername))
		$USPS_FOUND = false;
	
	if($USPS_FOUND) {

	  $dst_country=func_query_first ("SELECT * FROM $sql_tbl[countries] WHERE code='$userinfo[s_country]'");
      $dst_country = $dst_country["country"];

	  $USPS_file=($USPS_servername=="testing.shippingapis.com")? "/ShippingAPITest.dll" : "/ShippingAPI.dll";

	  if ($userinfo[s_country] != $config["Company"]["location_country"]) {
		$query=<<<EOT
<IntlRateRequest USERID="$USPS_username" PASSWORD="$USPS_password">
  <Package ID="0">
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <MailType>$mailtype</MailType>
    <Country>$dst_country</Country>
  </Package>
</IntlRateRequest>
EOT;
		$get="API=IntlRate&XML=".urlencode($query);

	    list ($header, $result) = func_http_get_request ($USPS_servername, $USPS_file, $get);
  	    global $mod_USPS_service,$mod_USPS_postage;
	    $mod_USPS_service=""; $mod_USPS_postage="";

	    function USPS_intl_startElement($parser, $name, $attrs) { 
  	      global $mod_USPS_service,$mod_USPS_postage;
		  if($name=="SVCDESCRIPTION") $mod_USPS_service="*";
		  if($name=="POSTAGE") $mod_USPS_postage="*";
	    }

	    function USPS_intl_characterData($parser, $data) { 
		  global $allowed_shipping_methods, $intershipper_rates;
  	      global $mod_USPS_service,$mod_USPS_postage;
		  if($mod_USPS_postage=="*") $mod_USPS_postage=$data;
		  if($mod_USPS_service=="*") {
  	    	foreach ($allowed_shipping_methods as $sk=>$sv) {
	      		if ($sv["code"]=="USPS" && $sv["destination"]=="I" && stristr($sv["shipping"],$data)) $intershipper_rates[]= array ("methodid"=>$sv["subcode"], "rate"=>$mod_USPS_postage);
	    	}
	        $mod_USPS_service=""; $mod_USPS_postage="";
		  }
	    }

	    function USPS_intl_endElement($parser, $name) { }

	    $xml_parser = xml_parser_create();
        xml_set_element_handler($xml_parser, "USPS_intl_startElement", "USPS_intl_endElement");
	    xml_set_character_data_handler($xml_parser, "USPS_intl_characterData");
	    xml_parse($xml_parser, $result);
	    xml_parser_free($xml_parser); 
	  } else {
		$ZO=$config["Company"]["location_zipcode"];
		$ZD=$userinfo["s_zipcode"];
		$query=<<<EOT
<RateRequest USERID="$USPS_username" PASSWORD="$USPS_password">
  <Package ID="0">
    <Service>EXPRESS</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>$container_express</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
  <Package ID="1">
    <Service>FIRST CLASS</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>None</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
  <Package ID="2">
    <Service>PRIORITY</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>$container_priority</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
  <Package ID="3">
    <Service>PARCEL</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>None</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
  <Package ID="4">
    <Service>BPM</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>None</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
  <Package ID="5">
    <Service>LIBRARY</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>None</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
  <Package ID="6">
    <Service>MEDIA</Service>
    <ZipOrigination>$ZO</ZipOrigination>
    <ZipDestination>$ZD</ZipDestination>
    <Pounds>$pounds</Pounds>
    <Ounces>$ounces</Ounces>
    <Container>None</Container>
    <Size>$package_size</Size>
    <Machinable>$machinable</Machinable>
  </Package>
</RateRequest>
EOT;
		$get="API=Rate&XML=".urlencode($query);

 		list ($header, $result) = func_http_get_request ($USPS_servername, $USPS_file, $get);

  	    global $mod_USPS_service,$mod_USPS_postage;
	    $mod_USPS_service=""; $mod_USPS_postage="";

	    function USPS_dom_startElement($parser, $name, $attrs) { 
  	      global $mod_USPS_service,$mod_USPS_postage;
		  if($name=="SERVICE") $mod_USPS_service="*";
		  if($name=="POSTAGE") $mod_USPS_postage="*";
	    }

	    function USPS_dom_characterData($parser, $data) { 
		  global $allowed_shipping_methods, $intershipper_rates;
  	      global $mod_USPS_service,$mod_USPS_postage;
		  if($mod_USPS_service=="*") $mod_USPS_service=$data;
		  if($mod_USPS_postage=="*") {
  	    	foreach ($allowed_shipping_methods as $sk=>$sv) {
	      		if ($sv["code"]=="USPS" && $sv["destination"]=="L" && stristr($sv["shipping"],$mod_USPS_service)) $intershipper_rates[]= array ("methodid"=>$sv["subcode"], "rate"=>$data);
	    	}
	        $mod_USPS_service=""; $mod_USPS_postage="";
		  }
	    }

	    function USPS_dom_endElement($parser, $name) { }


	    $xml_parser = xml_parser_create();
        xml_set_element_handler($xml_parser, "USPS_dom_startElement", "USPS_dom_endElement");
	    xml_set_character_data_handler($xml_parser, "USPS_dom_characterData");
	    xml_parse($xml_parser, $result);
	    xml_parser_free($xml_parser); 

	  }

	}

	if($debug=="Y") {
		print("<H1>USPS Debug Information</H1>");
		if($query) {
		  $query=preg_replace("/(USERID[=][^ \t<>]*)/i","USERID=\"xxx\"",$query);
		  $query=preg_replace("/(PASSWORD[=][^ \t<>]*)/i","PASSWORD=\"xxx\"",$query);
		  print("<H2>USPS Request</H2>"); 
		  print("<PRE>"); print(htmlspecialchars($query)); print("</PRE>");
		  print("<H2>USPS Responce</H2>"); 
		  print("<PRE>"); print(htmlspecialchars($result)); print("</PRE>");
	    } else {
		  print("It seems, you have forgotten to fill in an USPS account information.");
		}
	}

?>
