{* $Id: discounts.tpl,v 1.12 2002/12/04 11:31:01 zorg Exp $ *}
{include file="location.tpl" last_location="Discounts"}
This page allows you to define purchase discounts you want to be active for your store. Purchase discounts apply to all customer orders and do not require the customer to enter any type of "code" to receive the discount. These are normally used to provide automatic savings for every customer order that is over a certain amount. 
<p>
 The "Order Amount" is the total amount of the customer order before sales tax and discounts charges. If you also take coupons, the coupon savings amount will be deducted before this calculation is done. Based on the order amount, the store will check the information below to see if a purchase discount needs to be calculated and applied to their order.
<p>
{capture name=dialog}
<p>
<table border="0">
<form action="discounts.php" method="POST">
<tr class=TableHead><td>Order total</td><td>Discount</td><td>Discount type</td><TD>Membership</TD><td>&nbsp;</td></tr>
{section name=prod_num loop=$discounts}
<tr>
<td><input type=text name=minprice-{$discounts[prod_num].discountid} size=10 value="{$discounts[prod_num].minprice}"></td>
<td><input type=text name=discount-{$discounts[prod_num].discountid} size=10 value="{$discounts[prod_num].discount}"></td>
<td>
<select name=discount_type-{$discounts[prod_num].discountid}>
<option value=absolute {if $discounts[prod_num].discount_type eq "absolute"}selected{/if}>Absolute, {$config.General.currency_symbol}</option>
<option value=percent {if $discounts[prod_num].discount_type eq "percent"}selected{/if}>Percent, %</option>
</select>
</td>
<TD>
<SELECT name=membership-{$discounts[prod_num].discountid}>
<OPTION value="" {if $discounts[prod_num].membership eq ""}selected{/if}>All</OPTION>
{section name=level loop=$membership_levels}
{if $membership_levels[level].usertype eq "C"}
<OPTION value="{$membership_levels[level].membership}" {if $discounts[prod_num].membership eq $membership_levels[level].membership}selected{/if}>{$membership_levels[level].membership}</OPTION>
{/if}
{/section}
</SELECT>
</TD>
<td><input type="button" value="Delete" onClick="document.location='discounts.php?mode=delete&discountid={$discounts[prod_num].discountid}'"></td>
</tr>
{/section}
<tr><td colspan=5 class=AdminTitle>Add new discount</td></tr>
<tr>
<td><input type=text name=minprice_new size=10 value="0.00"></td>
<td><input type=text name=discount_new size=10 value="0.00"></td>
<td>
<select name=discount_type_new>
<option value=absolute>Absolute, {$config.General.currency_symbol}</option>
<option value=percent>Percent, %</option>
</select>
</td>
<TD>
<SELECT name=discount_membership_new>
<OPTION value="">All</OPTION>
{section name=level loop=$membership_levels}
{if $membership_levels[level].usertype eq "C"}
<OPTION value="{$membership_levels[level].membership}">{$membership_levels[level].membership}</OPTION>
{/if}
{/section}
</SELECT>
</TD>
<td><input type="submit" value="Add/Update"></td>
</tr>
</form>
</table>
<p>
{/capture}
{include file="dialog.tpl" title="Edit purchase discounts" content=$smarty.capture.dialog extra="width=100%"}
