{* $Id: shipping_rates.tpl,v 1.22.2.1 2003/02/13 10:56:24 svowl Exp $ *}
{include file="location.tpl" last_location="Shipping charges"}
This section allows you to define the shipping rates for each shipping method defined for your store.<p>
Shipping formula:<br>
<b><font class=Star>SHIPPING</font></b> = <font class=Star>Rate + TOTAL_WEIGHT*Weight_Rate +<br>
+ ITEMS*Item_Rate + SUM*Percent_Rate/100</font>

<p>
<b>Flat shipping charge:</b><br>
If you want customer orders to be subject to a flat amount shipping charge regardless of the number of ordered products or the weight of the products, enter the amount into "Flat" field.
<br>
<b>Charge as % of the Total Amount Ordered:</b><br>
If you want the shipping charges calculated as a percentage of the total amount of products ordered, enter a value into "%" field.
<br>
<b>Flat Shipping Charge Per Unit Ordered:</b><br>
If you want shipping costs to be calculated based on the number of items (quantity) purchased, enter the amount into "Per unit" field.
<br>
<b>Flat Shipping Charge Based on Product Weight:</b><br>
If you want shipping costs to be calculated based on the weight of products ordered, enter an amount into "{$config.General.weight_symbol}" field. This uses a flat amount of shipping for each {$config.General.weight_symbol} of products ordered.
<form action="shipping_rates.php" method=get name=zoneform>
<b>Edit charges for</b><br>
<select name="shippingid" onChange='document.zoneform.submit()'>
<option value="">All methods</option>
{section name=ship_num loop=$shipping}
<option value="{$shipping[ship_num].shippingid}" {if $smarty.get.shippingid ne "" and $smarty.get.shippingid eq $shipping[ship_num].shippingid}selected{/if}>{$shipping[ship_num].shipping} ({if $shipping[ship_num].destination eq "I"}Intl{else}National{/if})</option>
{/section}
</select>
<select name=zoneid onChange='document.zoneform.submit()'>
<option value="">All zones</option>
{section name=zone loop=$zones}
<option value={$zones[zone].zoneid} {if $smarty.get.zoneid ne "" and $smarty.get.zoneid eq $zones[zone].zoneid}selected{/if}>{$zones[zone].zone}</option>
{/section}
</select>
</form>
<p>
{capture name=dialog}
<table border=0 cellspacing=3 cellpadding=4>
<form action="shipping_rates.php?zoneid={$smarty.get.zoneid}&shippingid={$smarty.get.shippingid}" method="POST">
<tr bgcolor="#CCCCCC"><td>Shipping method</td><td>Range</td><td colspan=2>Shipping charges</td></tr>
{section name=prod_num loop=$shipping_rates}
<tr>
<td>
<select name="shippingid-{$shipping_rates[prod_num].rateid}">
{section name=ship_num loop=$shipping}
<option value="{$shipping[ship_num].shippingid}" {if $shipping_rates[prod_num].shippingid eq $shipping[ship_num].shippingid}selected{/if}>{$shipping[ship_num].shipping} ({if $shipping[ship_num].destination eq "I"}Intl{else}National{/if})</option>
{/section}
</select><br>
<select name="zoneid-{$shipping_rates[prod_num].rateid}">
{section name=zone loop=$zones}
<option value={$zones[zone].zoneid} {if $shipping_rates[prod_num].zoneid eq $zones[zone].zoneid}selected{/if}>{$zones[zone].zone}</option>
{/section}
</select>
<br>
<input type="button" value="Delete" onClick="document.location='shipping_rates.php?mode=delete&rateid={$shipping_rates[prod_num].rateid}&zoneid={$smarty.get.zoneid}&shippingid={$smarty.get.shippingid}'">
</td>
<td nowrap>
Weight<br>
<input type=text name=maxweight-{$shipping_rates[prod_num].rateid} size=10 value="{$shipping_rates[prod_num].maxweight}"><br>
Order total<br>
<input type=text name=maxtotal-{$shipping_rates[prod_num].rateid} size=10 value="{$shipping_rates[prod_num].maxtotal}">
</td>
<td nowrap>
Flat<br>
<input type=text name=rate-{$shipping_rates[prod_num].rateid} size=5 value="{$shipping_rates[prod_num].rate}"><br>
Per item<br>
<input type=text name=item_rate-{$shipping_rates[prod_num].rateid} size=5 value="{$shipping_rates[prod_num].item_rate}">
</td>
<td nowrap>
%<br>
<input type=text name=rate_p-{$shipping_rates[prod_num].rateid} size=5 value="{$shipping_rates[prod_num].rate_p}"><br>
Per {$config.General.weight_symbol}<br>
<input type=text name=weight_rate-{$shipping_rates[prod_num].rateid} size=5 value="{$shipping_rates[prod_num].weight_rate}">
</td>
</tr>
<tr><td colspan=5 align=center><hr size=1 noshade></td>
</tr>
{/section}
<tr>
<td colspan=5>
<font class=AdminTitle>Add shipping charge values</font>
</td>
<tr>
{if $shipping ne ""}
<tr>
<td>
<select name=shippingid_new>
<option value="">Select one...</option>
{section name=ship_num loop=$shipping}
<option value="{$shipping[ship_num].shippingid}">{$shipping[ship_num].shipping} ({if $shipping[ship_num].destination eq "I"}Int{else}Local{/if})</option>
{/section}
</select><br>
<select name=zoneid_new>
{section name=zone loop=$zones}
<option value={$zones[zone].zoneid} {if $smarty.get.zoneid eq $zones[zone].zoneid}selected{/if}>{$zones[zone].zone}</option>
{/section}
</select>
</td>
<td nowrap>
Weight<br>
<input type=text name=maxweight_new size=10 value="999999.00"><br>
Order total<br>
<input type=text name=maxtotal_new size=10 value="999999.00"></td>
<td nowrap>
Flat<br>
<input type=text name=rate_new size=5 value="0.00"><br>
Per item<br>
<input type=text name=item_rate_new size=5 value="0.00"></td>
<td nowrap>
%<br>
<input type=text name=rate_p_new size=5 value="0.00"><br>
Per {$config.General.weight_symbol}<br>
<input type=text name=weight_rate_new size=5 value="0.00"></td>
</tr>
<tr>
<td colspan=5>
<input type="submit" value="Add/Update">
</td>
</tr>
{else}
<tr>
<td colspan=5 align=center>Shipping rates are calculated in real time. User-defined shipping methods are not defined.</td>
</tr>
{/if}
</form>
</table>
<p>
{/capture}
{include file="dialog.tpl" title="Shipping charges" content=$smarty.capture.dialog extra="width=100%"}
